#ifndef __TConvertImageDialog_H
#define __TConvertImageDialog_H

#include "TDialog.h"

typedef enum {kConvertModulusSquared,kConvertModulus,kConvertPhase,
	kConvertReal,kConvertImaginary } ImageConvertType ;
	
class	TConvertImageDialog : public TDialog {

	public:
		TConvertImageDialog() ;
		void	GetDialogData(void *data) { *(ImageConvertType *)data = mConvertType ; } ;
		void	DoMouseDownInObject(TObject *,Point *) ;
	private:
		TRadioButton	*mModulusSquared ;
		TRadioButton	*mModulus ;
		TRadioButton	*mPhase ;
		TRadioButton	*mReal ;
		TRadioButton	*mImaginary ;
		TObject			*mCurrentType ;

		ImageConvertType	mConvertType ;

} ;


#endif

