#ifndef ___edmttyoes_h
#define ___edmttyoes_h
typedef struct 	{
		unsigned short red ;
		unsigned short green ;
		unsigned short blue ;
} Color ;
typedef struct	{
		int index ;
		Color RGB ;
} ColorSpec ;
typedef struct	{
		ColorSpec CTab[256] ;
} ColorTable ;
#define SOLID 	0
#define DOT	1
#define DASH	2
#define DOTDASH 3
typedef struct	{
		int style ;
		int width ;
		Color color ;
} LineRecord,*LinePtr ;
typedef struct	{
		char 	*fontname ;		
		int  	fontsize ;
		int 	width ;
		Color 	color ;
} CharRecord,*CharPtr ;
typedef struct {
    short left ;
    short top ;
    short right ;
    short bottom ;
} Rect ;
typedef struct {
    float left ;
    float top ;
    float right ;
    float bottom ;
} FRect ;
typedef enum CursorMode {
    kNormalCursor,kDefineUCell,kPickAtom,kDefineIF 
} CursorMode ;

typedef	long			SInt32 ;
typedef unsigned long	UInt32 ;
typedef	short			SInt16 ;
typedef	unsigned short	UInt16 ;

typedef short int		Int16 ;
typedef long			Int32 ;
typedef	long			TableReference ;
typedef	unsigned char	Pattern[8] ;

typedef enum { srcCopy,srcOr,srcXOr
} CopyMode ;
typedef enum {
	kNothing=0,kOriginDefined=1,kADefined=2
} PtDefined ;
typedef enum {
	kFirstAtom=0,kSecondAtom=1
} AtomDef ;

typedef	enum {kLeftJustified,kCenterJustified,kRightJustified} JustificatonType ;
typedef 	unsigned char Pattern[8] ;
typedef enum GrayLevel 	{kBlack=0,kWhite=255} 	GrayLevel ;
typedef enum OrRelation { kDirPlane,kAxisAngle} OrRelation ;
#endif /* ___edmttyoes_h */
