      double precision function rgcale(fhk,fcalc,nref,i)
C     Intensity Fix
C     Use approach that works in refinements, i.e. sum fcalc**2*wt/fobs**2*wt
C     This reduces emphasis on strong, badly measured reflections
      dimension fhk(*),fcalc(*)
      include 'RefineWts.h'
      double precision s2,s4,s5,scL,err
      double precision t1,t2,t3
C       Calculate error-fit in Chi**2 fashion
C       Intensity conservation code
        INCLUDE 'Iconserve.h'
        INCLUDE 'Iconserve1.h'
C       Calculate error-fit
      err=0d0
      do j=1,nref
            t1=fhk(j)*fhk(j)-scL*dble(fcalc(j))
            err=err+abs(t1)*sclwt(j)
      enddo
       rgcale=(err/SumI)
       return
       end
      real function rgcales(fhk,fcalc,nref,i)
C     Intensity Fix
C     Use approach that works in refinements, i.e. sum fcalc**2*wt/fobs**2*wt
C     This reduces emphasis on strong, badly measured reflections
      dimension fhk(*),fcalc(*)
      include 'RefineWts.h'
C      real s2,s4,s5,scL,err
C      real t1,t2,t3
C       Calculate error-fit in Chi**2 fashion
C       Intensity conservation code
        INCLUDE 'Iconserves.h'
C       Calculate error-fit
      err=0d0
      do j=1,nref
            t1=fhk(j)*fhk(j)-scL*(fcalc(j))
            err=err+abs(t1)*rmulti(j)
      enddo
       rgcales=(err/SumI)
       return
       end

