C 
C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a coyo of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
      double precision function robf3Dnp(fhk,nref,
     $  natom,x,y,z,symm,h,k,l,itype,i)
      include 'ffact.h'
      include 'FastDerd.h'
      include 'Constraints.h'
      dimension fhk(*)
C      double precision xe(12,40),ye(12,40)
      real*8 fbump
      complex*16 amp,amp2
      dimension wx(12),wy(12)
      integer h(*),k(*),l(*),itype(*),igotn(20)
      dimension x(*),y(*),z(*),fcv(4000)
      double precision s1,s2,f0,rpcalw,p,pi2
      character*4 symm
      save f0
C      complex*16 x2d(-40:40,40,12),y2d(-40:40,40,12),zrod(-100:100,40)
        logical centro
        common /ccentr/centro
      common /sfcom2/aocc,zatom,forig,brownf,dmult,dmlt
      save /sfcom2/
      logical forig,brownf,dmult,dmlt
      dimension zatom(20),aocc(20)
        logical robnod,rob_fit,dwref,robfm,nodd5
        common /fscom55/robnod,rob_fit,dwref,robfm,nodd5
      include 'STO111.h'
       call chinumb(x,y,natom,itype,symm,nchi)
       chifactor = float(nref)/max(1.,float(nref-nchi))
C
C       Look for centering
        call centered(symm)
        do j=1,20
                igotn(j)=0
        enddo

C     Get the R.M.S. error
      pi2=4.d0*asin(1.0d0)
C       piz=pi2/izsampl
C       write(6,*)piz,izsampl,pi2
      s1=0.0
      s2=0.0
        fsum0=0
      if(i.lt.0)f0=0.0
      do n=1,natom
         call asymm(x(n),y(n),ne,wx,wy,symm)
         fsum0=fsum0+ne*zatom(itype(n))
         igotn(itype(n))=igotn(itype(n))+ne
         do j=1,ne
                xe(j,n)=wx(j)
                ye(j,n)=wy(j)
         enddo
         ine(n)=ne
      enddo
C       This term adjust to absolute levels so we can compare things
C       write(6,*)fsum0,foscl
        if(foscl.lt.1e-8)then
                fsum0=fsum0*fsum0
        else
                fsum0=foscl/(fsum0*fsum0)
        endif
C       write(6,*)fsum0
C       Find ranges to use      
        izmax=0
        ixmax=0
        iymax=0
        ixmin=0
        iymin=0
        izmin=0
        do j=1,nref
                ixmax=max(ixmax,h(j))
                ixmin=min(ixmin,h(j))
                iymax=max(iymax,k(j))
                iymin=min(iymin,k(j))
C               izmax=max(izmax,l(j))
C               izmin=min(izmin,l(j))
        enddo

C       Expand atoms    
      if(i.lt.0)f0=0.0
      do n=1,natom
         call asymm(x(n),y(n),ne,wx,wy,symm)
         do j=1,ne
                xe(j,n)=wx(j)
                ye(j,n)=wy(j)
         enddo
         ine(n)=ne
      enddo
      
C
C       do j3=izmin,izmax
C               w=j3*pi2
C               do n=1,natom
C                       p=w*dble(z(n))
C                       zrod(j3,n)=cmplx(cos(p),sin(p))
C               enddo
C       enddo
        
C
C       Calculate the x for each atom
        do j=ixmin,ixmax
                u=j*pi2
                do n=1,natom
                        do j2=1,ine(n)
                                p=u*xe(j2,n)
                                x2d(j,n,j2)=cmplx(cos(p),sin(p))
                        enddo
                enddo
        enddo
C
C       Calculate the y for each atom
        do j=iymin,iymax
                v=j*pi2
                do n=1,natom
                        do j2=1,ine(n)
                                p=v*ye(j2,n)
                                y2d(j,n,j2)=cmplx(cos(p),sin(p))
                        enddo
                enddo
        enddo
        
C       Now calculate values
        do j=1,nref
        amp=0
        do n=1,natom
                amp2=0
                do j2=1,ine(n)
                        amp2=amp2+x2d(h(j),n,j2)*y2d(k(j),n,j2)
                enddo
                if(centro)amp2=dble(amp2)
                amp=amp+amp2*rfactb(itype(n),j)
        enddo
        fcv(j)=(amp*conjg(amp))*fsum0
        if(twin)then
C       Twinning added
        amp=0
        do n=1,natom
                amp2=0
                do j2=1,ine(n)
                        amp2=amp2+x2d(k(j),n,j2)*y2d(h(j),n,j2)
                enddo
                if(centro)amp2=dble(amp2)
                amp=amp+amp2*rfactb(itype(n),j)
        enddo
        fcv(j)=(fcv(j)+(amp*conjg(amp))*fsum0)*0.5D0
        endif
C       write(18,99)h(j),k(j),l(j),fcv(j)*.3,fhk(j)*fhk(j),p,amp
C99     format(3i4,5f12.4)
      enddo
      robf3Dnp=rpcalw(fhk,fcv,nref,-1,r1fact)
        if(foscl.lt.1e-8)write(13,*)'WARNING: Bug, scale not absolute'
C        close(unit=13)
C       Bonding & bumping - don't use for output!
C       Constraints
C       t0=snewcon(x,y,z,symm,itype,natom)
        rbump=fbump(x,y,z,natom,symm,itype) * bumpwt
        rbond=bonderr(x,y,z,symm,natom,itype) * bondwt
        if(chemon)then
C       Accumulate nett valence charge
                ValCharge=BaseCharge
                do j=1,10
                    if(igotn(j).gt.0)then
                        ValCharge=ValCharge+igotn(j)*ValAtoms(j)
                        write(13,*)'Type ',j,' # ',igotn(j),ValAtoms(j)
                    endif
                enddo
C       Penalty function
                rstoich=(1-exp(-abs(ValCharge)*ValPen))*ValW
                robf3Dnp=robf3Dnp + rstoich * chemwt
                write(13,*)'Chemical constraint ',rstoich,
     1  BaseCharge
        robf3Dnp=robf3Dnp+rbond+rbump
        write(13,991)'G-of-F ',robf3Dnp,' R1 ',r1fact,
     1  ' Constraints ',rbond,rbump,rstoich,' Variable correction ',
     2  chifactor
  991  format(a,F8.5,a,F6.4,a,3F7.4,a,F7.4)
        else
        robf3Dnp=robf3Dnp+rbond+rbump
        write(13,99)'G-of-F ',robf3Dnp,' R1 ',r1fact,
     1  ' Constraints ',rbond,rbump,' Variable correction ',chifactor
        endif
   99   format(a,F8.5,a,F6.4,a,2F7.4,a,F7.4)
        close(unit=13)
        return
      end

