C 
C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
C
      subroutine refine3Dn(fw,h,k,l,nat,x,y,z,itype,nr2,
     $ symm,n1,n2,n3,errg,wts,ntimes)
      include 'Gpars.h'
      include 'Just_Pars.h'
      dimension x(*),y(*),z(*),wts(*),itype(*)
      dimension fw(*)
      dimension fhk(1500)
      integer h(*),k(*),l(*)
      character*4 symm
      double precision robf3Dnp
        logical gotentry
        dimension ftrueh(nhk2h)
        common /sfcom40/ftrueh,gotentry
        include 'rfact.h'
        include 'ffact.h'
        include 'errref.h'
        include 'SeedDef.h'
C       dimension xsd(50,200),ysd(50,200),zsd(50,200),isd(50,200)
C       dimension ntsd(200)
C       common /hunter2/ xsd,ysd,zsd,isd,nsd,ntsd
         logical debug
         common /fscom43/slw1,slw2,secval,debug,basecut 
C       call chinumb(x,y,nat,itype,symm,nchi)
C       chifactor = float(nrref)/max(1.,float(nrref-nchi))
      call only2D(z,nat)
      f0=0.
C     write(6,*)'Values ',nr2,nat,ntimes,symm
C      write(6,*)n1,n2,n3
C      do j=1,nat
C         write(6,*)x(j),y(j),z(j),itype(j)
C      enddo
      do j=1,nr2-1
            fhk(j)=ftrueh(j)*wts(j)
C     Base f0
            f0=f0+fhk(j)*fhk(j)
C           write(6,*)'A ',h(j),k(j),l(j)
      enddo

      nref=nr2-1
      do j=1,nat
         z(j)=0
C        write(6,*)'B ',x(j),y(j),z(j)
      enddo
C      ijunk=-1
C      if(ijunk.lt.0)return


C      if(ntimes.lt.5)ntimes=5
C      if(debug)ntimes=1
C      write(6,*)'Debin ',nref,nat,symm,ntimes,n1,n2,n3
      call gref3Dn(fhk,nref,nat,
     $        x,y,z,symm,h,k,l,ntimes,n1,n2,n3,errg,itype)
C     Base f0
      f0=0.
      do j=1,nrref
            f0=f0+rfhk(j)*rfhk(j)
      enddo
C      Return the top value printed
      errg=robf3Dnp(rfhk,nrref,
     $        nat,x,y,z,symm,rh,rk,rl,itype,-1)

C       Correction for the number of variables in Chi**2 fit
C      if(erron.gt.7)then
C      call chinumb(x,y,nat,itype,symm,nchi)
C      errg=errg*errg*nrref/(nrref-nchi)
C      errg=sqrt(errg)
C      write(13,*)'Variable corrected Chi value is ',errg
C      endif
      close(unit=13)
C       Add the atom to front of seed file
        call shufseedu(ijk)
        ntsd(1)=nat
        fomseed(1)=errg
        do j=1,nat
                xsd(j,1)=x(j)
                ysd(j,1)=y(j)
C               zsd(j,1)=z(j)
                zsd(j,1)=0
                isd(j,1)=itype(j)
        enddo
C       Purge seeds
        call pseed(1,symm)
      return
      end
C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
C     Stolen from refine3Dn to just calculate the G-of-F
      subroutine refone(fw,h,k,l,nat,x,y,z,itype,nr2,
     $ symm,n1,n2,n3,errg,wts,ntimes)
      include 'Gpars.h'
      include 'Just_Pars.h'
      dimension x(*),y(*),z(*),wts(*),itype(*)
      dimension fw(*)
C      dimension fhk(1500)
      integer h(*),k(*),l(*)
      character*4 symm
      double precision robf3Dnp
        logical gotentry
        dimension ftrueh(nhk2h)
        common /sfcom40/ftrueh,gotentry
        include 'rfact.h'
        include 'ffact.h'
        include 'errref.h'
        include 'SeedDef.h'
         logical debug
         common /fscom43/slw1,slw2,secval,debug,basecut 
      call only2D(z,nat)
      nref=nr2-1
      do j=1,nat
         z(j)=0
      enddo

C     Base f0
      f0=0.
      do j=1,nrref
            f0=f0+rfhk(j)*rfhk(j)
      enddo
C      Return the top value, printing result
      errg=robf3Dnp(rfhk,nrref,
     $        nat,x,y,z,symm,rh,rk,rl,itype,-1)

      return
      end
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
C
      subroutine refine3Dn2(fw,h,k,l,nat,x,y,z,itype,nr2,
     $  symm,n1,n2,n3,errg2,wts)
       include 'Gpars.h'
        include 'errref.h'
        include 'rfact.h'
        include 'Just_Pars.h'
C      common /rscom5/nrref Needed here
C       dimension xsd(40,100),ysd(40,100),zsd(40,100),isd(40,100)
C       dimension ntsd(100)
C       common /hunter2/ xsd,ysd,zsd,isd,nsd,ntsd
        include 'SeedDef.h'
      dimension x(*),y(*),z(*),wts(*),itype(*)
      dimension fw(*)
      dimension fhk(1500)
      integer h(*),k(*),l(*)
      character*4 symm
      double precision robf3Dn
        logical gotentry
        dimension ftrueh(nhk2h)
        common /sfcom40/ftrueh,gotentry
C     Run through and eliminate 0,0,0 reflection
       call chinumb(x,y,nat,itype,symm,nchi)
       chifactor = float(nrref)/max(1.,float(nrref-nchi))
      call only2D(z,nat)
      f0=0.
      do j=1,nr2-1
            fhk(j)=ftrueh(j)*wts(j)
C            if(symm.eq.'p3  ')fhk(j)=ftrueh(j)*wts(j)
C     Base f0
            f0=f0+fhk(j)*fhk(j)
      enddo
      nref=nr2-1
         call gref3Dn(fhk,nref,nat,
     $        x,y,z,symm,h,k,l,20,n1,n2,n3,errg,itype)
C      if(erron.gt.7)then
C      call chinumb(x,y,nat,itype,symm,nchi)
C      errg=errg*errg*nrref/(nrref-nchi)
C      errg=sqrt(errg)
C      endif
C       Add the atom to seed file
        call shufseed(ijk)
        nsd=nsd+1
        ntsd(nsd)=nat
        fomseed(nsd)=errg
        do j=1,nat
                xsd(j,nsd)=x(j)
                ysd(j,nsd)=y(j)
C               zsd(j,nsd)=z(j)
                zsd(j,nsd)=0
                isd(j,nsd)=itype(j)
        enddo
C       Purge the seeds
        ijk=1
        call pseed(ijk,symm)
      return
      end
C 
C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
      subroutine refine3Dd(fw,h,k,l,nat,x,y,z,itype,nr2,
     $  symm,n1,n2,n3,errg,wts,ntimes)
        include 'Gpars.h'
        include 'Just_Pars.h'
      dimension x(*),y(*),z(*),wts(*),itype(*)
      dimension fw(*)
      dimension fhk(1500)
      integer h(*),k(*),l(*)
      character*4 symm
      double precision robf3Dn,robf3Dnp
        logical gotentry
        dimension ftrueh(nhk2h)
        common /sfcom40/ftrueh,gotentry
        include 'rfact.h'
        include 'ffact.h'
        include 'errref.h'
C       dimension xsd(40,100),ysd(40,100),zsd(40,100),isd(40,100)
C       dimension ntsd(100)
C       common /hunter2/ xsd,ysd,zsd,isd,nsd,ntsd
        include 'SeedDef.h'
C       call chinumb(x,y,nat,itype,symm,nchi)
C       chifactor = float(nrref)/max(1.,float(nrref-nchi))
      f0=0.
C     write(6,*)'Debug ',nr2,nat,n1,n2,n3
      do j=1,nr2-1
            fhk(j)=ftrueh(j)*wts(j)
C     Base f0
            f0=f0+fhk(j)*fhk(j)
      enddo
      nref=nr2-1
      if(ntimes.lt.5)ntimes=5
         call gref3Dn(fhk,nref,nat,
     $        x,y,z,symm,h,k,l,ntimes,n1,n2,n3,errg,itype)
C     Base f0
      f0=0.
      do j=1,nrref
            f0=f0+rfhk(j)*rfhk(j)
      enddo
C      Return the top value printed
      errg=robf3Dnp(rfhk,nrref,
     $        nat,x,y,z,symm,rh,rk,rl,itype,-1)
C       Correction for the number of variables in Chi**2 fit
C      if(erron.gt.7)then
C      call chinumb(x,y,nat,itype,symm,nchi)
C      errg=errg*errg*nrref/(nrref-nchi)
C      errg=sqrt(errg)
C      endif
C       Add the atom to seed file

C       call shufseed(ijk)
C       nsd=nsd+1
C       ntsd(nsd)=nat
C       do j=1,nat
C               xsd(j,nsd)=x(j)
C               ysd(j,nsd)=y(j)
C               zsd(j,nsd)=z(j)
C               isd(j,nsd)=itype(j)
C       enddo
      return
      end

