C 
C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
C
      subroutine peaks3Da(f,fgot,ind1,ind2,ind3,n1,n2,n3,ntot,tol
     $  ,symm,dx,dy,dz,cut)
      integer ind1(*),ind2(*),ind3(*)
        parameter (np=5000)
      integer io1(np),io2(np),io3(np),ind(np)
      dimension f(*),fgot(*),work(np)
        dimension fg(np)
        character*4 symm
C     First, search for maximum
      fmax=-1e6
      jj=0
C       write(6,*)'Deb -2'
      do 91 j3=1,n3
      do 91 j2=1,n2
      do 91 j1=1,n1
      jj=jj+1
        if(symm.eq.'p2mm'.or.symm.eq.'c2mm'.or.symm.eq.'p6mm'
     $  .or.symm.eq.'p3m1'.or.symm.eq.'p31m')then
                if(j2.gt.n2/2+2)goto 91
                if(j1.gt.n1/2+2)goto 91
        endif
      if(f(jj).gt.fmax)then
         fmax=f(jj)
      endif
91    continue
C
C       Large points
10      fmin=fmax*cut
        jj=0
        igot=0
C       write(6,*)'Deb -1'
        do 92 j3=1,n3
        do 92 j2=1,n2
        do 92 j1=1,n1
        jj=jj+1
        if(symm.eq.'p2mm'.or.symm.eq.'c2mm'.or.symm.eq.'p6mm'
     $  .or.symm.eq.'p3m1'.or.symm.eq.'p31m')then
                if(j2.gt.n2/2+2)goto 92
                if(j1.gt.n1/2+2)goto 92
        endif
        if(f(jj).gt.fmin)then
                igot=igot+1
                if(igot.gt.np)then
                      cut=cut*1.25
                      goto 10
                endif
                io1(igot)=j1
                io2(igot)=j2
                io3(igot)=j3
                fg(igot) =f(jj)/fmax
        endif
92      continue

C       write(6,*)'Deb 0'
C       sort
        do l=1,igot
            work(l)=1./(1.+fg(l))
            ind(l)=l
        enddo
        call sortag(work,igot,ind)

C     Now do a running search
        it=0
C       write(6,*)'Deb 1'
        do 101 l=2,igot
C     Check proximity
        i=ind(l)
C     Trap case when we have a slope of a streaked atom
C     eliminate if adjacent points are larger
      include 'adjacent3D.h'
        if(fg(i).lt.0)goto 101
        j1=io1(i)
        j2=io2(i)
        j3=io3(i)
      do 100 ii=1,l-1
        k=ind(ii)
        if(fg(k).lt.0)goto 100
      i1=j1-io1(k)
      i2=j2-io2(k)
      i3=j3-io3(k)
      i1=min(abs(i1),abs(i1-n1),abs(i1+n1))
      i2=min(abs(i2),abs(i2-n2),abs(i2+n2))
      i3=min(abs(i3),abs(i3-n3),abs(i3+n3))
      r=i1*i1*dx+i2*i2*dy+i3*i3*dz
      if(r.lt.tol)then
102             fg(i)=-1
                goto 101
        endif
C     Done loop (I hope)
100     continue
101     continue

        igg=0
C       write(6,*)'Deb 2'
        do 201 l=1,igot
        i=ind(l)
        if(fg(i).lt.0)goto 201
        igg=igg+1
        fgot(igg)=fg(i)
        ind1(igg)=io1(i)
        ind2(igg)=io2(i)
        ind3(igg)=io3(i)
        if(igg.eq.ntot)return
201     continue
        ntot=igg
C       write(6,*)'Exited peaks3D'
        return
      end
