C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
C
       SUBROUTINE SPKS2D (VV, F, IH, K,FHK,AHK,AIN,SYMM,NREF,NCON
     X    , NBEAMS,NHK,NMAX, CFLAG, IOPT )
         include 'Nlimit.h'
C         PARAMETER (NHK2 = 900, NLIMIT = 65536)
         include 'Atoms.h'
         include 'Just_Pars.h'
         LOGICAL PRINTF ,dist3D
         include 'NewIncludes.h'
         include 'hunting.h'
         include 'ffact.h'
         include 'Constraints.h'
         include 'errref.h'
         include 'Xray.h'
         COMMON /PRINTS/PRINTF
         DIMENSION WINWTS(nhk2),L(nhk2),igotw(20)
         COMMON /FOM5/WINWTS
         LOGICAL PWMASK, EOPT, PWACC, PMACC
         COMMON /WALSH/PWMASK, EOPT, PWACC, PMACC
         LOGICAL CENTRO,gotem
         COMMON /CCENTR/CENTRO
C     data centro /.false./
         COMMON /ERRTRY/NWOPT
         COMMON /ENTC2D/RAD1, RAD2
C     For tuning
         LOGICAL TLOG(6)
         DIMENSION FTUNE(4)
         COMMON /TUNING/TLOG, FTUNE
         LOGICAL WTSON, WT2ON
         DIMENSION WTS(NHK2), EWTS(NHK2), MULTI(NHK2)
         DIMENSION WPOS(NHK2)
         COMMON /WPOSC/WPOS
         COMMON /WCOM/WTS, WTSON, MODE
         COMMON /WCOM2/EWTS, WT2ON
         COMMON /MPCOMM/MULTI
         COMMON /ECALC/SFERR1, ANGERR, SFERR2
         COMMON /PADCMM/NPAD
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
         DIMENSION VV(*), F(*)
         DIMENSION IH(*), K(*), FHK(*), AHK(*), AIN(*)
         DIMENSION HOLD1(NHK2), HOLD2(NHK2), M(3)
         DIMENSION FH1(NHK2), FH2(NHK2), FCALC(NHK2), ACALC(NHK2)
         INTEGER I1(natf), I2(natf),itype(natf),itypew(natf)
         DIMENSION X(natf*5), Y(natf*5),FGOT(natf*5),Z(natf*5)
         DIMENSION XE(20), YE(20)
         DIMENSION XBEST(natf),YBEST(natf),OB(natf),ZBEST(natf)
         DIMENSION XHOLD(natf),YHOLD(natf),OHOLD(natf),ZHOLD(natf)
         DIMENSION XW(natf), YW(natf), OW(natf), ZW(natf)
         CHARACTER*78 TITLE
         CHARACTER*4 SYMM, QUOB, CATYPE
         LOGICAL MAPOFF, CM, CRYST, RFLAG, PWTON, MPROJ, CFLAG
C     Put some stuff out of the way as static space
         CHARACTER*1 QUO, QUOIN,JUNKCHAR
         EQUIVALENCE (QUOB,QUO)
         COMPLEX AMP, AMP2
C         LOGICAL FEXTD
         INTEGER NCONT(20)
         DIMENSION CELL(6), TEMPF(20), AOCC(20), ZATOM(20)
         LOGICAL FORIG, FSEMP, BROWNF, DMULT, DMLT, FOM2, AUTOON
         Include 'Sfacts.h'
         COMMON /SFCOM1/TEMPF, NCONT, NATOM, CELL
         COMMON /SFCOM2/AOCC, ZATOM, FORIG, BROWNF, DMULT, DMLT
         COMMON /MVIS/WIDTH, HEIGHT, TIMES, FSEMP
         COMMON /COPT/ATNUM, PATTC, ACTERM, FOM2
         DIMENSION FSTEST(20)
         COMMON /COPT2/FSTEST
         INTEGER LAT(2)
         COMMON /CLAT/LAT
         SAVE /COPT/ , /MVIS/ , /SFCOM2/ , /SFCOM1/ , MAPOFF
     X      , FGOT, Y, X, I2, I1, ACALC, FCALC, FH2, FH1, /FOMALL
     X      / , /MPCOMM/ , /WCOM2/ , /WCOM/
         SAVE /COPT2/
         DOUBLEPRECISION DD1, DD2, DD3, DD4, DD5, DD6, DD7
         PARAMETER (DD1 = -1D-3, DD2 = -0.1D0, DD3 = -0.1D0, DD4 = 1.D0
     X      / 10.D0, DD5 = -0.05D0)
         PARAMETER (DD6 = 1.D0 / 360.D0, DD7 = 1.D0 / 360.D0)
         DOUBLE PRECISION DD8
C       EDM I/O Buffer         
        character*200 lines(30)
C       Bonding
         INCLUDE 'newbonds.h'
         logical debug, newref ,occdone
         common /fscom43/slw1,slw2,secval,debug,basecut 
         logical robnod,rob_fit,dwref,robfm,nodd5
         common /fscom55/robnod,rob_fit,dwref,robfm,nodd5
         DATA MAPOFF/.TRUE./, debug/.false./, rob_fit/.false./
         data newref/.true./, occdone/.false./
         data robfm/.false./
         data bumpwt/1.0/,bondwt/1.0/,coordwt/1.0/,chemwt/1.0/,
     x          contwt/1./
        dimension ftrueh(nhk2h),ztemp(20)
        common /sfcom40/ftrueh,gotentry
C       complex TWK1, TWK2
        INCLUDE 'rfact.h'
        logical shelx
        common /shelxmode/shelx
        dimension axt(50),ayt(50),azt(50),atcode(50),atint(50)
        character*4 atsymb(50)
        INCLUDE 'TModel.h'
        INCLUDE 'GridSize.h'
        include 'STO111.h'
        conserveint=.true.
        ferr=.false.
        multiplicity=.true.
        nsd=0
        nht=0
        natomq=natom
        ntypes=natomq
        ntype=natomq
        bfgs_abort=.true.
        shelx=.false.
         ACONV = 90.D0 / ASIN (1.D0)
C        Ensure that expansion (error data) is off
         expandset=.false.
C        Refinement symmetry, not currently implimented
         RSYMM=SYMM
         NRREF=NREF-1
         TOL=0.5D0
         ACUT=0.2D0
         DO   I=1,NREF
           HOLD1(I) = AHK(I)
           ftrueh(I) = FHK(I)*wts(i)
           L(I)=0
           EWTS(I)=1
           RH(I)=IH(I)
           RK(I)=K(I)
C          Needs to be changed later
           RL(I)=0
           rfhk(I)=fhk(I)*wts(I)
           rewt(I)=1
           rmulti(I)=multi(I)
C     Trap here negative to indicate fixed beam
           IF (HOLD1(I) .LT. DD1) AIN(I) = AHK(I) * ACONV
         END DO
         DO   I=NREF+1,NPAD
           HOLD1(I) = 0.
           FH1(I) = 0.
           FH2(I) = 0.
           FHK(I) = 0.
           AHK(I) = 0.
         END DO
 
         CALL FINDSZ (IH,K,NREF,SYMM,M,IOPT)
         N1 = M(1)
         N2 = M(2)
         N3 = 1
         IF (M(1) * M(2) .GT. NMAX) THEN
           WRITE (6, *) 'Aaargh... must increase nbeams'
           write (6,*)  'I need ',m(1)*m(2),' not ',nmax
           WRITE (6, *) 'Dying, gracelessly'
           CALL EXIT    (0)
         END IF
C     setup harm tables
         IF (MAPOFF) THEN
           CALL PBUF2 (M)
           MAPOFF = .FALSE.
         END IF
 
         SFOLD = 1D10
         SFF = 1D10
         DO   J=1,N1*N2*2
           VV(J) = 0.
         END DO
         DO   JT=1,NCON
           DO   N=1,NREF
             RR51 = HOLD1(N)
             RR52 = AHK(N)
             HOLD2(N) = RR51
             RR51 = RR52
             HOLD1(N) = RR51
           END DO
           DO   N=NREF+1,NPAD
             RR53 = HOLD1(N)
             RR54 = AHK(N)
             RR55 = FH1(N)
             RR56 = FHK(N)
             HOLD2(N) = RR53
             RR53 = RR54
             FH2(N) = RR55
             RR55 = RR56
             HOLD1(N) = RR53
             FH1(N) = RR55
           END DO
C       Refuse to stop if some beams were not set
        gotem=.true.
        do I=1,NREF-1
                if(abs(ahk(i)).lt. 1D-3)gotem=.false.
        enddo 
C       Refuse to stop with less than ndev cycles
         NDEV = nint( FSTEST(9) )
        if(JT .LT. NDEV)gotem=.false. 
C  The guts, do an iteration
           AERR = TB2D (IH,K,FHK,AHK,AIN,NREF,JT,CFLAG,SYMM,NBEAMS,NHK,
     X        VV,M,IOPT)
 
           WRITE (10, 7002) ' Drift ', AERR, ' SF FOMs ', ER1, EI1, EC1
     X        , SFERR2, ' Aerror', ANGERR
           IF (PRINTF) THEN
             WRITE (6, 7002) ' Drift ', AERR, ' SF FOMs ', ER1, EI1, EC1
     X          , SFERR2, ' Aerror', ANGERR
           ENDIF
           IF (PRINTF) WRITE (10, 100) JT
  100      FORMAT('***** END OF ITERATION NUMBER ',I3,2X,'*****'/)

 7002      FORMAT(A,F6.2,A,4F10.5,A,F7.2,A,I4) 

C     Trap not to stop too early (? correct)
           IF (JT .GT. 4) THEN
             IF (FTUNE(3) .GT. 10.D0) THEN
C     Truncate search with positivity
               A1 = SFERR1
               A2 = SFF
             ELSE
               A1 = SFERR2
               A2 = SFOLD
             END IF

C       Refuse to stop if some beams were not set before
        if(.not.gotem)goto 7110
C       Going uphill
        if((A2 - A1) .LT. 1D-4)goto 7001
C       Stagnant
             IF (abs(A2 - A1) .LT. 1D-5) THEN
               DO   I=1,NPAD
                 ANG = AHK(I) * ACONV
                 IF (ABS (ANG) .GT. 1D-5) THEN
                   ANG = ANG + NINT (ANG * DD2) * (-360.D0)
                   IF (ANG .LT. 1D-2) ANG = 360.D0 + ANG
                   AHK(I) = ANG
                 END IF
                 END DO
               GOTO 7777 
             END IF
           END IF


 7110      SFOLD = SFERR2
           SFF = SFERR1
 
         END DO
 7001    SFERR2 = SFOLD
         SFERR1 = SFF
         DO   I=1,NREF
           AHK(I) = HOLD2(I)
           HOLD1(I) = HOLD2(I)
         END DO
         DO   I=NREF+1,NPAD
           AHK(I) = HOLD2(I)
           FHK(I) = FH2(I)
           FH1(I) = FH2(I)
           HOLD1(I) = HOLD2(I)
         END DO
7777     CONTINUE
C
C     Reset (for safety) vv and f
         CALL TRS2D (IH,K,FHK,AHK,NREF,SYMM,NHK,VV,M)
         CALL TRS2D (IH,K,FHK,AHK,NREF,SYMM,NHK,F,M)
C     Ensure that all beams are now floating
         CFLAG = .TRUE.
C     Ensure that atom number constraint is now off
         ATNUM = (-1.)
 
C     So, now what ?
         NTOT = 0
         PWTON = .FALSE.
         CM = .TRUE.
         CRYST = .FALSE.
         modelmode = .FALSE.
C       ***************** NEW STRUCTURE *******************         
C       Set the flag that we are ready
        nlines=1
        lines(1)='Hello Roar'

        if(EDM_ON)call edm_init
C
 7100   continue
        if(EDM_ON)then 
C               Pass back whatever is appropriate
                call tell_edm(lines,nlines)
                close(unit=6)
C               Wait for line input
                call edm_input(lines,nlines)
                QUOB=lines(1)(1:4)
C               Debug
C               write(6,*)'I got',quo
                close(unit=5)
                open(unit=5,file='.peaks_cheat')
                do j=1,nlines
                        write(5,7102)lines(j)
                enddo
                write(5,7102)' '
                rewind(unit=5)
C       The first line should be the command, so skip
                read(5,7102)junkchar
                close(unit=6)
                open(unit=6,file='.edm_3')
        else
                WRITE (6, 7101)
 7101           FORMAT(' So..., what next'/
     X      ' Positivity Run (P)        Atom peaks      (A)'/
     X      ' Mixed      Run (M)        Refine          (R)'/
     X      ' Entropy    Run (E)        List atoms      (L)'/
     X      ' Fix Atoms      (F)        G-of-F          (G)'/
     X      ' Occupancies    (O)        Difference Map  (D)'/
     X      ' Import sites   (I)        Save Image      (S)'/
     X      ' Z*Occ (Toggle) (Z)        Differnce Proj  (J)'/
     X      ' Symmetry       (Y)        Current Model   (C)'/
     X      ' 1, 2, EDMT, FULL, ERR, ROB, SEED, BFGS'/
     X      ' BOND, BUMP, COORD, DIFT, ACUT, TRIM, SHEL'/
     X      ' Quit           (Q)'/'        _',$)
C       New commands, not documented above
C       1       Create difference map only
C       2       Jump into difference map, after reading difference.lst
C       EDMT    (Toggle) EDM reading flag. Need NEDM in .ins file
C       BOND    Set's up bond distance table
C       BUMP    Set's up bumping table
C       COOR    Not yet implimented -- should read in co-ordination numbers
C       FULL    Reads in errors
C       ERR     (Toggle) Swith on/off error weights
C       ROB     (Toggle) Robust mode ( | | not the square | |**2 )
C       SEED    Refine multiple potential solutions at once
C       BFGS    Toggle off/on full praxis minimization
C       DIFT    fs2002 difference code (might be better)
C       ACUT    Atom cut level (for peaks), e.g. 0.25. Also for difference maps
C       Initially maybe a value of 0.2 is OK when finding atoms, but
C               after that use 0.5
C       TRIM    Reduces number of hunting cases to 10
C       SHEL    (Toggle) Shelx refinement mode
C       ATST    Command for testing, returns G-of-F
C       ASRC    Command to search possibilities
C       WATM    Command to return coding for atoms
C       WHAT    Returns parameter information about current situation
C       TMSET   Sets phase of measured, amp+phase of others to model
C
                READ (5, 7102) QUOB
        endif
 7102    FORMAT(A)
C
C       Save the input value for possible later use 
         QUOIN=QUO
C       Start with New Commands
         IF(QUOB.EQ.'EDMT'.or.quob.eq.'edmt')then
                EDM_ON=.not.EDM_ON
        else if (QUOB.eq.'MULT')then
C       Do nothing, for later
                multiplicity=.not.multiplicity
        else if (QUOB.eq.'ICON')then
             conserveint=.not.conserveint
        else if (QUOB.eq.'SETC')then
             write(6,*)'Setting the constraints'
             call GetConstraints(sfacts,ntypes)
C             write(6,*)'And I just did'
C       ReadAtoms
        else if(QUOB.eq.'T3LD')THEN
                call readdata(x,y,z,fgot,itype,sfacts,zatom,natom,0)
                call settyp(itype,fgot,natom,zatom)
C                write(6,*)'Command not tested yet'
C       Refine on F's, to be implimented
        else if(QUOB.eq.'TFER')then
                FERR=.not.FERR
                write(6,*)'F errors now ',ferr
C       Correct structure factors if needed
                if( .not.expandset )then
                if(FERR)then
                   DO   I=1,NREF
                     T=fhk(I)*wts(I)
                     if(abs(T).gt.1d-8)then
                        rfhk(I)=sqrt(T)
                     else
                        rfhk(I)=0
                     endif
                   enddo
                else
                   DO   I=1,NREF
                     rfhk(I)=fhk(I)*wts(I)
                   enddo
                endif
                endif
C       Purge seeds, added
        else IF(QUOB.EQ.'T2LD')then
                nsd=0
                nht=0
C       Babinet the wave (?)
        else if(QUOB .EQ. 'BABI')then
             PI=acos(-1.D0)
             PI2=2*PI
             do I=1,NREF-1
                 ahk(i)=ahk(i)-PI
                 if(ahk(i) .lt. 1e-5)ahk(i)=ahk(i)+PI2
             enddo
             SFERR=1e6
             SFOLD=1e6
C       Turn on DW flag
        else IF(QUOB.EQ.'DWRE')then
                dwref=.not.dwref
C       Maybe impliment ?
C        else if(QUOB.EQ.'CHIN')then
C                chinumb=.not.chinumb
C       else if(QUOB .EQ. 'UCMI')then
C               Rucmin=.not.Rucmin
C       Atom testing return from edm, put as an include
        else IF(QUOB.EQ.'ATST'.or.quob.eq.'ASR1'.or.quob.eq.'ASR2')then
                if(.not.EDM_ON)then
                  write(6,*)'Command only active with edm interface'
                else
                  INCLUDE 'Test_Atoms.h'
                endif
        else if(quob.eq.'WHAT'.or.quob.eq.'what')then
           ns=0
           do j=1,20
                if(zatom(j).gt.0)ns=ns+1
           enddo
        write(6,*)'PRAXIS        ',.not.bfgs_abort
        write(6,*)'Bump con      ',bumper,bumpwt
        write(6,*)'Bond con      ',bonding,bondwt
        write(6,*)'Cord con      ',coord,coordwt
        write(6,*)'Bond con2     ',bondcon
C        write(6,*)'Overbond      ',overbond
        write(6,*)'Erron is      ',erron
C        write(6,*)'Gotrfacts     ',gotrfacts
C        write(6,*)'Symmetry      ',symm
        write(6,*)'NRREF         ',nrref
        write(6,*)'Refind DW     ',dwref
        write(6,*)'Twin mode     ',twin
        write(6,*)'Robust is     ',rob_fit
        write(6,*)'Errors are    ',robfm
        write(6,*)'Stochiomet    ',chemon,chemwt,(ValAtoms(j),j=1,ns)
        write(6,*)'Contents      ',contents,contwt
        write(6,*)'Multiplicity  ',multiplicity
         else if(QUOB.EQ.'WATM'.or.quob.eq.'watm')then
           NTTT = 0
           DO   J=1,20
             IF (ZATOM(J) .GT. DD2) THEN
               NTTT = NTTT + 1
C               WRITE (6, *) 'Type ', SFACTS(J), ' Z*occ ', ZATOM(J)
               write(6,6999)sfacts(j),j,zatom(j)
6999           format(a,' ',i2,' ',f10.5)
             END IF
           END DO
         else if(QUOB.eq.'TWIN'.or.quob.eq.'twin')then
                twin=.not.twin
         else if(QUOB.eq.'BFGS'.or.quob.eq.'bfgs')then
                bfgs_abort=.not.bfgs_abort
                write(6,*)'PRAXIS is ',.not.bfgs_abort
                write(10,*)'PRAXIS is ',.not.bfgs_abort
         ELSE IF(QUOB.eq.'TMSE' .or.
     1          QUOB .EQ. 'MODL' .or. quob.eq.'modl')then
        INCLUDE 'reset.h'
         ELSE IF(QUOB.EQ.'TRIM'.or.quob.eq.'trim')then
                tol=0.5
                call phunt(xht,yht,zht,nht,tol,symm)
                call pseed(ijk,symm)
                nsd=min(15,nsd)
                nht=min(nht,15)
C         ELSE IF(QUOB(1:3).eq.'NEW')THEN
C            newref=.not.newref
C            write(6,*)'New mode is',newref
         ELSE IF (QUOB.EQ.'ACUT'.or.quob.eq.'acut')THEN
          OLDCUT=ACUT
         if(EDM_ON)then
                read(lines(2),*)ACUT
         else
          ACUT=REALGET('Cut level for finding atoms',OLDCUT,EDM_ON)
         endif
         ELSE IF(QUOB.EQ.'HUNT'.or.QUOB.EQ.'hunt')THEN
C        Ensure that an occupancy search is done first (before hunting)
C                if(.not.occdone)goto 7812
C                write(6,*)'Command not fully tested yet'
C           NTTT = 0
C           DO   J=1,20
C             IF (ZATOM(J) .GT. DD2) THEN
C               NTTT = NTTT + 1
C               WRITE (6, *) 'Type ', SFACTS(J), ' Z*occ ', ZATOM(J)
C             END IF
C           END DO
C           NTYPES = INTGET ('Use how many types',NTTT,EDM_ON)
C           IF (NTYPES .LT. 0) GO TO 7100
C           NATOM = INTGET ('Use how many atoms',NATOM,EDM_ON)
C           NATOM = MIN (NATOM, 50)
C           OPEN (UNIT=13, FILE='search.lst')
C           call grid3Dh(f,fhk,ih,k,l,natom,nref,x,y,z,
C     1     fgot,rbest,rsymm,winwts,n1,n2,n3,rflag,ntypes,
C     2     wts,fwt_on)
C           write(6,*)'Best seed has ',natom,' Atoms, G-of-F',rbest
         ELSE IF(QUOB.EQ.'FULL'.or.QUOB.EQ.'full')THEN
C                write(6,*)'Command not fully tested yet'
                quo='B'
                call geterrdat(errfv,nref,quo,fhk,wts,ewts,erron,
     1          eproj,f,ih,k,l,xray)
         ELSE IF(QUOB.EQ.'BUMP'.or.QUOB.EQ.'bump')THEN
C             write(6,*)'Command not tested yet'
           ns=0
           do j=1,20
                if(zatom(j).gt.0)ns=ns+1
           enddo
           bumper=.true.
           do j1=1,ns
                do j2=j1,ns
                   write(6,*)'Bumping constraint between ',sfacts(j1),
     1             sfacts(j2)
                   read(5,*)bump
                   bumpa(j1,j2)=bump
                   bumpa(j2,j1)=bump
                   write(10,*)'Bumping constraint between ',sfacts(j1),
     1      sfacts(j2),' is ',bump
C           Using bumping constraint here, for later use
                TOL=MIN(TOL,BUMP*0.5D0)
                enddo
           enddo
           TOL=max(TOL,0.5d0)
         ELSE IF(QUOB.EQ.'STOC'.or.QUOB.EQ.'stoc')THEN
           ns=0
           do j=1,20
                if(zatom(j).gt.0)ns=ns+1
           enddo
           chemon=.not.chemon
           if(chemon)then
           do j=1,ns
                write(6,*)'Valence of ',sfacts(j)
                        read(5,*)xval
                        ValAtoms(j)=xval
                write(10,*)'Valence of ',sfacts(j),' is ',xval
           enddo
           write(6,*)'Valence Constraint ?'
           read(5,*)BaseCharge
           endif
         ELSE IF(QUOB.EQ.'BOND'.or.QUOB.EQ.'bond')THEN
C             write(6,*)'Command not tested yet'
           ns=0
           do j=1,20
                if(zatom(j).gt.0)ns=ns+1
           enddo
           bonding=.true.
           do j1=1,ns
                do j2=j1,ns
                   write(6,*)'Bonding distance between ',sfacts(j1),
     1             sfacts(j2)
                   read(5,*)bump
                   bonda(j1,j2)=bump
                   bonda(j2,j1)=bump
                write(10,*)'Bonding distance between ',sfacts(j1),
     1      sfacts(j2),' is ',bump
                enddo
           enddo
         ELSE IF(QUOB.EQ.'COOR'.or.QUOB.EQ.'coor')THEN
                write(6,*)'Command not implimented yet'
         ELSE IF(QUOB(1:4).eq.'SHEL'.or.QUOB(1:4).eq.'shel')then
                shelx=.not.shelx
                write(6,*)'Shelx mode is now ',shelx
                write(10,*)'Shelx mode is now ',shelx
         ELSE IF(QUOB(1:3).EQ.'ERR'.or.QUOB(1:3).EQ.'err')THEN
C                write(6,*)'Command not implimented yet'
                robfm=.not.robfm
                write(6,*)'Errors now ',robfm
C               Errors should trigger getting larger data
                if(robfm)then
                quo='B'
                call geterrdat(errfv,nref,quo,fhk,wts,ewts,erron,
     1          eproj,f,ih,k,l,xray)
                endif
        else if(quob.eq.'DEBU'.or.quob.eq.'debu')then
                debug=.not.debug
                write(6,*)'Debug is now ',debug
                goto 7100
         ELSE IF(QUOB(1:3).EQ.'ROB'.or.QUOB(1:3).EQ.'rob')THEN
C                write(6,*)'Command not tested yet'
                rob_fit=.not.rob_fit
                write(6,*)'Robust mode is ',rob_fit
                goto 7100
         ELSE IF(QUOB.EQ.'SEED'.or.QUOB.EQ.'seed')THEN
          write(10,7102)' Refining seeds'
C             write(6,*)'Command not tested yet'
          call settyp(itype,fgot,natom,zatom)
          call refseed(fhk,ih,k,l,natom,x,y,z,itype,nref,
     $    symm,n1,n2,n3,errg2,ewts,40,fgot,zatom)
          RERR=ERRG2
          write(6,*)'Best has ',natom,' Atoms, G-of-Fit' ,errg2
         ELSE IF (QUO .EQ. 'O' .OR. QUO .EQ. 'o') THEN
7812       occdone=.true.
           autoon=.false.
           if(.not.edm_on)then
                 WRITE (6, 79) ' Automatic search  (Y=A/N)'
                 READ (5, 7102, ERR=7100, END=7100) QUO
                 if((QUO.eq.'Y').or.(QUO.eq.'y'))autoon=.true.
                 IF((QUO.eq.'A').or.(QUO.eq.'a'))autoon=.true.
           endif
           WRITE (10, *) 'Searching occupancies'
           NTTT = 0
           DO   J=1,20
             IF (ZATOM(J) .GT. DD2) THEN
               NTTT = NTTT + 1
               WRITE (6, *) 'Type ', SFACTS(J), ' Z*occ ', ZATOM(J)
             END IF
           END DO
           if(AUTOON)then
                NTYPES=NTTT
           ELSE
                NTYPES = INTGET ('Use how many types',NTTT,EDM_ON)
                IF (NTYPES .LT. 0) GO TO 7100
                NATOM = INTGET ('Use how many atoms',NATOM,EDM_ON)
           ENDIF
           NATOM = MIN (NATOM, 50)
           OPEN (UNIT=13, FILE='search.lst')
           QUO = 'n'
C           Do we have enough space for a grid search ?
            sgrid=log(float(MaxGrid))
            agrid=(natom+nht)*log(float(ntypes+1))
           IF(agrid.lt.sgrid)then
             if(edm_on.or.autoon)then
                 QUO='Y'
             else
                 WRITE (6, 79) ' Grid or genetic  (Grid=Y/N)'
                 READ (5, 7102, ERR=7100, END=7100) QUO
             endif
           END IF
           IF (QUO .EQ. 'n' .OR. QUO .EQ. 'N') THEN
             PWTON = .TRUE.
             RFLAG = .TRUE.
              call grid3Dg(f,fhk,ih,k,l,natom,nref,x,y,z,
     1         fgot,rbest,symm,winwts,n1,n2,n3,rflag,
     2         ntypes,ewts,fwt_on,edm_on,autoon)
              call settyp(itype,fgot,natom,zatom)
              call refseed(fhk,ih,k,l,natom,x,y,z,itype,nref,
     $        symm,n1,n2,n3,errg2,ewts,40,fgot,zatom)
              write(6,*)'Returned ',natom,' Atoms' ,errg2,' grid3Dg'
              rbest=errg2
           ELSE
             RFLAG = .TRUE.
             call grid3Dn(f,fhk,ih,k,l,natom,nref,x,y,z,
     1       fgot,rbest,symm,winwts,n1,n2,n3,rflag,
     2       ewts,fwt_on,ntypes,edm_on,autoon)
             write(6,*)'Returned ',natom,' Atoms' ,rbest
             call settyp(itype,fgot,natom,zatom)
             call refseed(fhk,ih,k,l,natom,x,y,z,itype,nref,
     $       symm,n1,n2,n3,errg2,ewts,40,fgot,zatom)
             write(6,*)'Returned ',natom,' Atoms' ,errg2,' Refseed'
           END IF
           WRITE (6, *) 'Best solution (current) has ', NATOM, ' atoms'
           write (6, *) 'Fit is ',rbest
           WRITE (6, *) 'Top solutions now in search.lst'
           write (6, *) 'Fit is ',rbest
           WRITE (10, *) 'Best solution (current) has ', NATOM, ' atoms'
           WRITE (10, *) 'Top solutions now in search.lst'
           CLOSE (UNIT=13)
C     Reset F
           CALL TRS2D (IH,K,FHK,AHK,NREF,SYMM,NHK,F,M)
         ELSE IF (QUO .EQ. 'Y' .OR. QUO .EQ. 'y') THEN
           WRITE (6, 79) ' Enter new symmetry (4 characters)'
           READ (5, 7102, ERR=7100, END=7100) SYMM
           WRITE (10, *) 'New symmetry is ', SYMM
           RSYMM=SYMM
         ELSE IF (QUO .EQ. 'Z' .OR. QUO .EQ. 'z') THEN
           IF (PWTON) THEN
             WRITE (6, *) 'Z*Occ wts were on before'
             WRITE (6, *) 'Turning them off (toggle)'
             WRITE (10, *) 'Z*Occ wts were on before'
             WRITE (10, *) 'Turning them off (toggle)'
             PWTON = .FALSE.
           ELSE
             WRITE (6, *) 'Z*Occ wts were off before'
             WRITE (6, *) 'Turning them on (toggle)'
             WRITE (10, *) 'Z*Occ wts were off before'
             WRITE (10, *) 'Turning them on (toggle)'
             PWTON = .TRUE.
             WRITE (6, *) 'Input values for atoms'
             DO   J=1,20
               IF (ZATOM(J) .GT. DD3) THEN
                 WRITE (6, *) 'Type ', SFACTS(J), ' Z*occ ', ZATOM(J)
               END IF
             END DO
           END IF
        ELSE IF(quob.eq.'DIFT'.or.quo.eq.'1'.or.quo.eq.'D'.or.
     1       quo.eq.'d')then
          include 'diff2D.h'
          call settyp(itype,fgot,natom,zatom)
          call refseed(fhk,ih,k,l,natom,x,y,z,itype,nref,
     $    symm,n1,n2,n3,errg2,ewts,40,fgot,zatom)
          RERR=ERRG2
          write(6,*)'Returned ',natom,' Atoms' ,errg2,' refseed2'

C       Added '2' command here for jump in to Difference loop
C       Added '1' here as well           

         ELSE IF (QUO .EQ. 'T' .OR. QUO .EQ. 't') THEN
           IF (CRYST) THEN
             WRITE (6, *) 'Robust scaling was on before'
             WRITE (6, *) 'Turning it off (toggle)'
             CRYST = .FALSE.
           ELSE
             WRITE (6, *) 'Robust scaling was off before'
             WRITE (6, *) 'Turning it on (toggle)'
             CRYST = .TRUE.
           END IF
         ELSE IF (QUO .EQ. 'R' .OR. QUO .EQ. 'r') THEN
C           CALL PHTML ('Refining current model')
           WRITE (10, *) 'Refining current model'
C           NATOM = INTGET ('Use how many atoms',NATOM,EDM_ON)
C           write(6,*)'NATOM ',natom
C           if(.not.newref)then
C           CALL REF2D (FHK,IH,K,NATOM,X,Y,FGOT,NREF,SYMM,WINWTS,MULTI,N1
C     X        ,N2,ERRG2)
C           else
             do jref=1,10
             call settyp(itype,fgot,natom,zatom)
C             write(6,*)'TT ',symm,nref,n1,n2,n3,natom
             call refine3Dn(fhk,ih,k,l,natom,x,y,z,itype,nref,
     $       symm,n1,n2,n3,errg2,ewts,60)
             RERR=ERRG2
             enddo
C           endif
           WRITE (6, *) 'Refined FOM ', ERRG2,' R1 ',r1fact
           WRITE (10, *) 'Refined FOM ', ERRG2,' R1 ',r1fact
C       call phtml2('Refined R-factor ',errg2)
C       Alternative current model versions
C         ELSE IF (QUOB.EQ. 'CUR1'.or.QUOB.eq.'cur1')then
C      call settyp(itype,fgot,natom,zatom)
C      call calcfhk(ih,k,l,ftrueh,ahk,fcalc,acalc,wts,scl,
C     1  fgot,natom,zatom,itype,x,y,z,f0,nref,symm)
C      goto 1999
C         ELSE IF (QUOB.EQ. 'CUR2'.or.QUOB.eq.'cur2')then
C      call settyp(itype,fgot,natom,zatom)
C      call calcfhk(ih,k,l,ftrueh,ahk,fcalc,acalc,wts,scl,
C     1  fgot,natom,zatom,itype,x,y,z,f0,nref,symm)
C       call calcufhk(ih,k,l,fcalc,acalc,wts,scl,
C     1  fgot,natom,zatom,itype,x,y,z,f0,nref,npad,symm)
C      goto 1999
         ELSE IF (QUO .EQ. 'C' .OR. QUO .EQ. 'c') THEN
C           CALL PHTML ('Saving current model:')
           WRITE (10, *) 'Saving current model'
C           natom=intget('Use how many atoms',natom,EDM_ON)
C     First, get scale from prfit.h
C     Zero term
           F0 = 0.
           NTOT = 0
           call settyp(itype,fgot,natom,zatom)
C     First, get scale from prfit.h
C       %include 'prfit3.h'
C       write(6,*)'Calling calcfhk'
      call calcfhk(ih,k,l,ftrueh,ahk,fcalc,acalc,wts,scl,
     1  fgot,natom,zatom,itype,x,y,z,f0,nref,symm)
     
C     Jump in location for alternative Current Model Outputs
C1999  continue
C     Now, calculate the beams, rescaled
        call calcufhk(ih,k,l,fcalc,acalc,wts,scl,
     1  fgot,natom,zatom,itype,x,y,z,f0,nref,npad,symm)
C
           WRITE (6, *) 'Saving current model'
C     Reset (for safety) vv
           CALL TRS2D (IH,K,FCALC,ACALC,NPAD,SYMM,NHK,VV,M)
           CALL PIMG2DN (VV,F,IH,K,FCALC,ACALC,NREF,SYMM,TITLE)
C     Reset (for safety) vv and f
           CALL TRS2D (IH,K,FHK,AHK,NREF,SYMM,NHK,VV,M)
           CALL TRS2D (IH,K,FHK,AHK,NREF,SYMM,NHK,F,M)
C     O.K.!
         ELSE IF (QUO .EQ. 'E' .OR. QUO .EQ. 'e') THEN
C        Test the model here
C         modelmode=.true.
C           CALL PHTML ('Mixed Mode Refinement')
           WRITE (10, *) '**** 50% ENT/POS ITERATIONS ***'
           WRITE (6, *) '**** 50% ENT/POS ITERATIONS ***'
           FTUNE(2) = 0.9D0
           GO TO 7200
         ELSE IF (QUO .EQ. 'M' .OR. QUO .EQ. 'm') THEN
C           CALL PHTML ('Lever Refinement')
           WRITE (10, *) '**** Lever ENT/POS ITERATIONS ***'
           WRITE (6, *) '**** Lever ENT/POS ITERATIONS ***'
C           FTUNE(2) = 6.1D0
           FTUNE(2) = 4.1D0
           GO TO 7200
         ELSE IF (QUO .EQ. 'P' .OR. QUO .EQ. 'p') THEN
           WRITE (10, *) '**** POSITIVITY ITERATIONS ***'
           WRITE (6, *) '**** POSITIVITY ITERATIONS ***'
C           CALL PHTML ('Performing positivity refinement')
           FTUNE(2) = 4.1D0
           GO TO 7200
         ELSE IF (QUO .EQ. 'A' .OR. QUO .EQ. 'a') THEN
C           CALL PHTML ('Analyzing peak positions')
           WRITE (10, *) 'Analyzing peak positions'
C     Reset F
           CALL TRS2D (IH,K,FHK,AHK,NREF,SYMM,NHK,F,M)
C     Convert to real space
C     Do a FFT
           CALL FFT2DN (F)
           JK = 0
           MF = (-1)
           DO   I=1,N2
             MF = -MF
             NF = -MF
             DO   J=1,N1
               JK = JK + 1
               NF = -NF
               F(JK) = F(JK*2-1) * NF
             END DO
           END DO
C
C     Debug output
C     call debpic(f,n1,n2,.false.)
           RR5 = CELL(1) / FLOAT (N1)
           DX = RR5 * RR5
           RR6 = CELL(2) / FLOAT (N2)
           DY = RR6 * RR6
C           TOL = 0.5D0
           CLOSE (UNIT=9)
           NATOM = 200
           IF (SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6') NTOT = NTOT
     X         * 2
           CUT = ACUT
          CALL PKS2DA (F,FGOT,I1,I2,N1,N2,NATOM,TOL,SYMM,DX,DY,CUT)

           OPEN (UNIT=2, FILE='peaks.lst')
C
           CALL PKSP2D (X,Y,I1,I2,F,N1,N2,NATOM,FGOT,SYMM,CM,TOL)
           do J=1,natom
              z(j)=0.
C              write(10,*)'Before ',j,x(j),y(j),z(j)
           enddo
C          Reduce peaks
           call redatoms(x,y,z,fgot,natom,symm)
           WRITE (6, *) 'Found ', NATOM, ' sites for possible atoms'
           DO   J=1,NATOM
C              write(10,*)'After ',j,x(j),y(j),z(j)
               IF (J .LT. 10) THEN
               WRITE (2, 2) 'Q', J, X(J), Y(J), Z(J), FGOT(J), 0.05D0
             ELSE
               WRITE (2, 21) 'Q', J, X(J), Y(J), Z(J), FGOT(J), 0.05D0
             END IF
           END DO
           CLOSE (UNIT=2)
C     Reset F and vv
           CALL TRS2D (IH,K,FHK,AHK,NREF,SYMM,NHK,F,M)
           CALL TRS2D (IH,K,FHK,AHK,NREF,SYMM,NHK,VV,M)
         ELSE IF (QUO .EQ. 'L' .OR. QUO .EQ. 'l') THEN
C           NLIST = INTGET ('How many',NATOM,EDM_ON)
      call settyp(itype,fgot,natom,zatom)
           DO   J=1,NATOM
             CATYPE=SFACTS(itype(j))
             ICAT=2
             if(catype(2:2).eq.' ')ICAT=1
             if((catype(3:3).eq.'+').or.(catype(3:3).eq.'-').or.
     1      (catype(4:4).eq.'+').or.(catype(4:4).eq.'-'))then
                write(6,9021)catype,x(j),y(j),z(j),FGOT(J),0.05D0
             ELSE IF (J .LT. 10) THEN
               WRITE (6,902) CATYPE(1:ICAT), J, X(J),Y(J),Z(J),FGOT(J),
     1          0.05D0
             ELSE
               WRITE (6,921) CATYPE(1:ICAT), J, X(J),Y(J),Z(J),FGOT(J), 
     2          0.05D0
             END IF
           END DO
      call alister(x,y,z,natom,itype,symm,cell,
     1  zatom,aocc,ncont,sfacts,rerr)

         ELSE IF (QUO .EQ. 'F' .OR. QUO .EQ. 'f' .OR. QUO .EQ. 'J' .OR.
     X      QUO .EQ. 'j') THEN
           WRITE (10, *) 'Projecting onto current model'
C
C          Generate the mask
           call calcpoint(ih,k,l,fcalc,acalc,
     1  fgot,natom,zatom,itype,x,y,z,npad,symm)

           call TMODMASK (IH, K, FCALC, ACALC, SYMM, VV, M )

           MPROJ = .FALSE.
           IF (QUO .EQ. 'J' .OR. QUO .EQ. 'j') MPROJ = .TRUE.
C           Reset (for safety) vv
           CALL TRS2D (IH,K,FHK,AHK,NREF,SYMM,NHK,VV,M)
           DD8 = ASIN (1.D0) * 4.D0
C              if(quo.eq.'Y'.or.quo.eq.'y')fextd=.true.
           DO   NCC=1,5
C     First, get scale from prfit.h
C     Zero term
             F0 = 0.
             NTOT = 0
      call calcfhk(ih,k,l,ftrueh,ahk,fcalc,acalc,wts,scl,
     1  fgot,natom,zatom,itype,x,y,z,f0,nref,symm)
C
C     Now, calculate the beams, rescaled (U-map)
        call calcufhk(ih,k,l,fcalc,acalc,wts,scl,
     1  fgot,natom,zatom,itype,x,y,z,f0,nref,npad,symm)
C     O.K.!
 
             JT = 10
             AERR = TMOD2D (IH,K,FHK,AHK,AIN,NREF,JT,CFLAG,SYMM,NBEAMS,
     X          NHK,VV,M,IOPT,FCALC,ACALC,MPROJ)
           END DO
C
C           Save fhk and ahk values
           DO   J=1,NPAD
             FH2(J) = FHK(J)
             FH1(J) = FHK(J)
             HOLD1(J) = AHK(J)
             HOLD2(J) = AHK(J)
           END DO
         ELSE IF (QUO .EQ. 'G' .OR. QUO .EQ. 'g') THEN
C     Used for Full at the moment
C                quo='B'
C               call geterrdat(errfv,nref,quo,fhk,wts,ewts,erron,
C     1         eproj,f,ih,k,l,xray)

             call settyp(itype,fgot,natom,zatom)
             call refone(fhk,ih,k,l,natom,x,y,z,itype,nref,
     $       symm,n1,n2,n3,errg2,ewts,-1)
           WRITE (6, *) 'G-of-Fit ', errg2, ' R1 ',r1fact,rbond,rbump,
     $     rstoich
 
         ELSE IF (QUO .EQ. 'Q' .OR. QUO .EQ. 'q') THEN
C           CALL PHTML ('Exiting')
           WRITE (10, *) 'Exiting Peaks analysis'
           IF(EDM_ON)THEN
                WRITE (6, *) 'Exiting Peaks analysis'
                open(unit=17,file='.edm_1')
                close(unit=17,status='DELETE')
                call nsleep2
                open(unit=17,file='.edm_2')
                close(unit=17)
                close(unit=6)
                call exit(0)
           ENDIF
           
           DO   I=1,NREF
             ANG = HOLD2(I) * ACONV
             IF (ABS (ANG) .GT. 1D-2) THEN
               ANG = ANG + NINT (ANG * DD6) * (-360.D0)
               IF (ANG .LT. 1D-3) ANG = 360.D0 + ANG
               AHK(I) = ANG
             ELSE
               AHK(I) = 0.
             END IF
           END DO
           DO   I=NREF+1,NPAD
             ANG = HOLD2(I) * ACONV
             FHK(I) = FH2(I)
             IF (ABS (ANG) .GT. 1D-2) THEN
               ANG = ANG + NINT (ANG * DD7) * (-360.D0)
               IF (ANG .LT. 1D-3) ANG = 360.D0 + ANG
               AHK(I) = ANG
             ELSE
               AHK(I) = 0.
             END IF
           END DO
 
           RETURN
         ELSE IF (QUO .EQ. 'I' .OR. QUO .EQ. 'i') THEN
           WRITE (6, 79) ' From peaks.new (P) or search (S)'
C   79      FORMAT(A,' ? _',$)
C       Include CR here for edm format
   79       FORMAT(A,' ? _')
           READ (5, 7102, ERR=7100, END=7100) QUO
           IF (QUO .EQ. 'S' .OR. QUO .EQ. 's') THEN
C             CALL PHTML ('Importing atom list from file')
             WRITE (6, 79) ' Which number (1-10)'
             READ (5, *, ERR=7100, END=7100) IIN
             OPEN (UNIT=2, FILE='search.lst')
C     Run down, reading 'R' from file
             IGOT = 0
 7310        READ (2, 7102, ERR=7100, END=7100) QUO
             IF (QUO .EQ. 'R') IGOT = IGOT + 1
             IF (IGOT .LT. IIN) GO TO 7310
C     O.K., we have skipped the appropriate number, so...
             IGOT = 0
             DO   J=1,50
               FGOT(J) = 0.
             END DO
             DO   J=1,50
               READ (2, 7102) TITLE
               IF (TITLE(1:1) .EQ. 'Q') THEN
                 IGOT = IGOT + 1
                 READ(TITLE(6:78),*,err=7311,end=7311)X(IGOT),Y(IGOT),
     X           Z(IGOT),FGOT(IGOT)
               ELSE
                 GO TO 7311
               END IF
             END DO
 7311        WRITE (6, *) ' Found ', IGOT, ' atoms'
             NTOT = IGOT
             NATOM = IGOT
             CLOSE (UNIT=2)
             call settyp(itype,fgot,natom,zatom)
          ELSE
             if(.not.edm_on)then
             WRITE (6, *) 'Current list is in peaks.lst'
             WRITE (6, 79) ' Edit peaks.new then return'
             READ (5, 7102) QUO
             endif
             OPEN (UNIT=2, FILE='peaks.new')
             NTOT = 0
             DO   J=1,99
               READ (2, 7102,Err=7301,end=7301) TITLE
               READ (TITLE(6:78),*)X(J),Y(J),Z(J),FGOT(J)
               Z(J)=0
               NTOT = NTOT + 1
               NATOM = J
C 7300          FORMAT(6X,4F10.6,2X,2F8.3)
             END DO
 7301        CLOSE (UNIT=2)
             WRITE (6, *) ' Found ', NTOT, ' atoms'
             NATOM = NTOT
             call settyp(itype,fgot,natom,zatom)
           END IF
C 7301      CONTINUE
         ELSE IF (QUO .EQ. 'S' .OR. QUO .EQ. 's') THEN
C           CALL PHTML ('Saving current image')
           WRITE (10, *) 'Saving current image'
           WRITE (TITLE, 7303) SFERR2
 7303      FORMAT('Solution Testing Case, FOM ',F12.6)
           CALL PIMG2DN (VV,F,IH,K,FHK,AHK,NREF,SYMM,TITLE)
C     Reset (for safety) vv and f
           CALL TRS2D (IH,K,FHK,AHK,NREF,SYMM,NHK,VV,M)
           CALL TRS2D (IH,K,FHK,AHK,NREF,SYMM,NHK,F,M)
         END IF
         GO TO 7100
 
 7200    CONTINUE
C     So, now what ?
C     Now do a positivity run
         SFOLD = 1D10
         SFF = 1D10
         DO   J=1,NPAD
           HOLD2(J) = AHK(J)
           HOLD1(J) = AHK(J)
           FH1(J) = FHK(J)
           FH2(J) = FHK(J)
         END DO
         DO   JT=10,NCON
           DO   N=1,NREF
             HOLD2(N) = HOLD1(N)
             HOLD1(N) = AHK(N)
           END DO
           DO   N=NREF+1,NPAD
             HOLD2(N) = HOLD1(N)
             FH2(N) = FH1(N)
             HOLD1(N) =  AHK(N)
             FH1(N) = FHK(N)
           END DO
C  The guts, do a convolution analysis
           AERR = TB2D (IH,K,FHK,AHK,AIN,NREF,JT,CFLAG,SYMM,NBEAMS,NHK,
     X        VV,M,IOPT)
           WRITE (10, 7002) ' Drift ', AERR, ' SF FOMs ', ER1, EI1, EC1
     X        , SFERR2, ' Aerror', ANGERR
           WRITE (6, 7002) ' Drift ', AERR, ' SF FOMs ', ER1, EI1, EC1
     X        , SFERR2, ' Aerror', ANGERR
           IF (PRINTF) WRITE (10, 100) JT
           IF (JT .GT. 2) THEN
             IF (SFERR2 .GT. SFOLD) GO TO 8001
             IF ((SFOLD - SFERR2) / SFOLD .LT. 1D-4) GO TO 8001
           END IF
           SFOLD = SFERR2
           SFF = SFERR1
 
         END DO
 8001    SFERR2 = SFOLD
         SFERR1 = SFF
         DO   I=1,NREF
           AHK(I) = HOLD2(I)
         END DO
         DO   I=NREF+1,NPAD
           AHK(I) = HOLD2(I)
           FHK(I) = FH2(I)
         END DO
C     Reset (for safety) vv
         CALL TRS2D (IH,K,FHK,AHK,NREF,SYMM,NHK,VV,M)
         RERR=SFERR2
         GO TO 7100
 
    2    FORMAT(A,I1,'  1 ',5F10.6,2X,2F8.3)
   21    FORMAT(A,I2,' 1 ',5F10.6,2X,2F8.3)
  902    FORMAT(A,I1,T5,' 1 ',5F10.6,2x,2F8.3)
 9021    FORMAT(A,T5,' 1 ',5F10.6,2x,2F8.3)
  921    FORMAT(A,I2,T5,' 1 ',5F10.6,2x,2F8.3)
       END
