C 
C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
C
      Function tclean3D(IH,K,L,FHK,AHK,ain,NREF,NCN,cflag,symm
     1 ,nbeams,nhk,c,m,iopt)
C
C           
      include 'Params3.h'
      include 'controls.h'

      DIMENSION IH(*),K(*),l(*),FHK(*),AHK(*),Aold(nhk2),AIN(*)
      dimension frcalc(nhk2),ficalc(nhk2),arcalc(nhk2)
      dimension fcalc(nhk2),acalc(nhk2),aicalc(nhk2)
      dimension wr(nhk2),wi(nhk2)
      integer he(20),ke(20),le(20),ise(20),m(3)
      complex c(*)
      complex*16 w1,w2,res1,res2,res3,res4
      double precision brsum,bisum,pi,pi2
      double precision sr,si,aconv,xr1,xr,ang,fsq
      double precision cosan,sinan,f,aisum,arsum
      logical cflag
      character*4 symm,symt
      integer bequiv(nhk2/4)
      complex fentry(nhk2),fent1(nhk2),fent2(nhk2),
     $ fpred(nhk2),fold(nhk2),ftmp
      save fold,bequiv,oscale,oscold
C      complex amp, amp2
      common /parcomn/ep1
      logical gotem,centref(nhk2),gotcent
	save sfold,sfold2,sp1old,sp2old,fmax,centref,gotcent
	data fmax/-1./,gotcent/.false./
C
C	For adaptive approach
	complex fpos(nhk2),fpunt(nhk2)
	dimension fp1(nhk2),ap1(nhk2),fp2(nhk2),ap2(nhk2)
	dimension wp1(nhk2),wp2(nhk2)
	if(ncn.lt.-5)then
		sfold=sfold+5
		sfold2=sfold2+5
		sp1old=sp1old+5
		sp2old=sp2old+5
	else if(ncn.lt.2)then
		sfold=0
		sfold2=0
		sp1old=0
		sp2old=0
	endif

      gotem=.true.
      NCON=ABS(NCN)

	if(.not.gotcent)then
		gotcent=.true.
		do j=1,npad
      	call equiv3(he,ke,le,ise,ih(j),k(j),l(j),ne,symm)
		if(ise(1).eq.3)then
			centref(j)=.true.
		else
			centref(j)=.false.
		endif
		enddo
	endif

       if(.not.gotentry)then
        do j=1,nref
                ftrueh(j)=fhk(j)
        enddo
        gotentry=.true.
        endif
        if(brall.and.ncn.eq.1)then
        do j=1,nref
        	fhk(j)=ftrueh(j)
        enddo
        endif

	  if(fmax.lt.-0.1)then	  
	  do j=1,nref-1
		if(fhk(j).gt.fmax)fmax=fhk(j)
	  enddo
	  endif

C     Origin for arrays (for consistency with FFT's)
      n1=m(1)
      n2=m(2)
      n3=m(3)
      n3c=n3/2+1
      n1c=n1/2+1
      n2c=n2/2+1
      
C     Angle conversion scaler
      pi=asin(1.0d0)
      pi=pi+pi
      pi2=pi+pi
      aconv=180.d0/pi   

  998 FORMAT('***** START OF ITERATION NUMBER ',I3,2X,'*****'/
     1 2X,'H',2X,'K',2X,'L',3X,'A1',5X,'F1',3X,'A2',5X,'F2'
     2 ,2X,'AOLD',2X,'FOLD',2X,'ANEW',2X,'FNEW',2X,'Diff')

C     Zero estimates for first cycle
      if(ncon.eq.1)then
		do j=1,npad
			fold(j)=0
		enddo
       	do j=nref+1,npad
             	fhk(j)=0.
              	ahk(j)=0.
               	fcalc(j)=0.
         	enddo
         	fhk(nref)=1
     		call winputn(ih,k,l,fhk,ahk,nref,symm,n3)
      endif

	do j=1,nref
		ang=ahk(j)
		if(abs(ang).gt.1e-3)then
                if(ang.lt.5e-2)then
                        ang=ang+pi2
                        ahk(j)=ang
                endif
		    fentry(j)=fhk(j)*cmplx(cos(ang),sin(ang))
		else
		    fentry(j)=0
		endif
	enddo
	do j=nref+1,npad
		ang=ahk(j)
                if(ang.lt.5e-2)then
                        ang=ang+pi2
                        ahk(j)=ang
                endif
		fentry(j)=fhk(j)*cmplx(cos(ang),sin(ang))
	enddo
	fentry(nref)=1
	do j=1,npad
           	aold(j)=ahk(j)*aconv
		acalc(j)=ahk(j)
		fcalc(j)=fhk(j)
	enddo

	fhk(nref)=1
c     Window
	if(n3.gt.1)then
	call winsimple(fcalc,acalc,ih,k,l,m,c,npad,printf)
      fhk(nref)=1
      ahk(nref)=pi2
C
	do j=nref+1,npad
		ahk(j)=acalc(j)
		fhk(j)=fcalc(j)
	enddo
	endif

      IF(printf)then
                WRITE(10,998)NCON
      endif
C     setup in c the symmetry related values
      do j=1,n1*n2*n3
         c(j)=0.
      enddo
D     call timer(1,'Windowed')
      do j=1,npad
      ihh=ih(j)
      ikk=k(j)
      call equiv3(he,ke,le,ise,ihh,ikk,l(j),ne,symm)
      f=fhk(j)
      ang=ahk(j)
      if(centref(j).and.abs(ang).gt.1e-4)then
C     truncate angle to moduli pi provided that > a cutoff
         ia=nint(ang/pi)
         ftt=fentry(j)
	   ftt=abs(ftt)
         if(2*(ia/2).eq.ia)then
         	ia=2
         	fentry(j)=ftt
         else
         	ia=1
		fentry(j)=-ftt
         endif
         ang=pi*ia
         acalc(j)=ang
         ahk(j)=ang
      endif      
      if(ihh.eq.0.and.ikk.eq.0.and.l(j).eq.0)then
         cosan=1.
         sinan=0.
         f=1.
         fhk(j)=1
         ahk(j)=pi2
         aold(j)=360
C         fcalc(j)=1
C         acalc(j)=pi2
      else if(abs(ang).lt.1e-4)then
         f=0.0
         cosan=0.0
         sinan=0.0
      else      
C      if((f.gt.fmax).and.(j.le.nref))fmax=f
        COSAN = COS(ANG)*f
        SINAN = SIN(ANG)*f
        endif
C     Information about symmetry coding of phases        
      include 'transcode3D.h'

C     endif
      enddo
C     Perform the transformation
D     call timer(1,'Setup')
C     Negativity constraints via ftune(4)
C      x1=0
C      xlam=ftune(4)*(1-exp(-ncon*0.5+0.5))
C      x2=xlam

C	Model or normal ?
	if(model)then
		mproj=.true.
      		if(modl2)mproj=.false.
      		base=basemod*(1-exp(-ncon*0.5+0.5))
      		call modsharp3D(n1,n2,n3,m,c,base)
	else
      		call shclean3D(n1,n2,n3,m,c)
	endif
D     call timer(1,'Sharpened')      
C      if(sconst.lt.1e-6)then
C        sconst=1
D       write(6,*)'Bug in sconst !!!'
C      endif
C     Outer loop for target reflections
c     Tweak parameters, taken from tboth2D.f
	scl0=0.25
	scu0=0.35
	scn0=2.0
	sdev=0.5
	dev=exp(ncon*sdev-sdev)
	scu=scu0*dev
	scl=scl0/dev
	scn=scn0*dev
	flow=fmax*0.1/dev
C	write(10,*)'Trap ',scl,scu,scn,flow,fmax,dev,uslw
C	Constant for the positivity recovery
      xmean=ffs2002(7)
	poscon=-1./(sclwin*log(ffs2002(6)*xmean))
	puntcon1=sclwin*log(ffs2002(10))
	puntcon2=0.5/sclwin
	fac2=ffs2002(5)
D	write(18,*)fac2,puntcon1,puntcon2,poscon,ffs2002(10)
C
C	Zero stuff
	do i=1,npad
		frcalc(i)=0
		ficalc(i)=0
		arcalc(i)=0
		aicalc(i)=0
		fp1(i)=0
		fp2(i)=0
		ap1(i)=0
		ap2(i)=0
	enddo
      DO 1031 I = 1,NPAD
C     Index coding for 3D
      include 'bindcode3D.h'

C     Extract two terms from real and imag parts
      res1=(w1+conjg(w2))*0.5d0
      res2=(w1-conjg(w2))/cmplx(0.d0,2.d0)
C	Project the positivity 
	res3=(res1+res2/fac2)*poscon
C	Project the "punt" term (ff0=1)
	res4=(res1-res3*puntcon1)*puntcon2
	arsum=res1
	brsum=imag(res1)
	if(entwl)then
		res2=res2*went(i)
	endif
 	aisum=res2
 	bisum=imag(res2)
      if(centref(i))then
		bisum=0
		brsum=0
		res3=dble(res3)
		res4=dble(res4)
      endif

 1090       FSQ =  ARSUM*ARSUM + BRSUM*BRSUM
            if(fsq.gt.1e-12)then
                FSQ=sqrt(FSQ)
                FRCALC(I) = FSQ
                ARCALC(I) = atan2(brsum,arsum)
                if(arcalc(i).lt.5e-2)arcalc(i)=arcalc(i)+pi2
            endif
           FSQ =  AISUM*AISUM + BISUM*BISUM
            if(fsq.gt.1e-12)then
                FSQ=sqrt(FSQ)
                FICALC(I) = FSQ
                AICALC(I) = atan2(bisum,aisum)
                if(aicalc(i).lt.5e-2)aicalc(i)=aicalc(i)+pi2
            endif
		AISUM=res3
		BISUM=imag(res3)
           	FSQ =  AISUM*AISUM + BISUM*BISUM
            if(fsq.gt.1e-12)then
                FSQ=sqrt(FSQ)
                Fp1(I) = FSQ
                Ap1(I) = atan2(bisum,aisum)
                if(ap1(i).lt.5e-2)ap1(i)=ap1(i)+pi2
            endif
		AISUM=res4
		BISUM=imag(res4)
           	FSQ =  AISUM*AISUM + BISUM*BISUM
            if(fsq.gt.1e-12)then
                FSQ=sqrt(FSQ)
                Fp2(I) = FSQ
                Ap2(I) = atan2(bisum,aisum)
                if(ap2(i).lt.5e-2)ap2(i)=ap2(i)+pi2
            endif 
c	Only trap the first three cycles
	if(ncon.lt.4.and.i.lt.nref.and.uslw)then
	  Ftrap=FHK(i)*scl
        ftrap2=fhk(i)*scu
	  if(fhk(i).lt.flow.and.aold(i).lt.0.01)then
c	  	Unconditionally too small, set to zero (unless input)
		frcalc(i)=0
		ficalc(i)=0
		arcalc(i)=0
		aicalc(i)=0
		fold(i)=0
		fentry(i)=0
		aold(i)=0
		ahk(i)=0
		fp1(i)=0
		ap1(i)=0
		fp2(i)=0
		ap2(i)=0
		
	  else if(aold(i).lt.1e-2)then
        	if(frcalc(i).lt.Ftrap.or.frcalc(i).gt.ftrap2)then
c		Too small/large for predicting a new value, set to zero
			frcalc(i)=0
			ficalc(i)=0
			arcalc(i)=0
			aicalc(i)=0
			fold(i)=0
			fentry(i)=0
			aold(i)=0
			ahk(i)=0
			fp1(i)=0
			ap1(i)=0
			fp2(i)=0
			ap2(i)=0
             endif
        endif
	endif

1031  CONTINUE
      do j=1,nref
		wr(j)=arcalc(j)-ahk(j)
		wi(j)=aicalc(j)-ahk(j)
		wp1(j)=ap1(j)-ahk(j)
		wp2(j)=ap2(j)-ahk(j)
      enddo
      do j=1,nref
      	wr(j)=cos(wr(j))
      	wi(j)=cos(wi(j))
		wp1(j)=cos(wp1(j))
		wp2(j)=cos(wp2(j))
      enddo
D     call timer(1,'Extracted')      

C	Entropy
	if(flat)then
	if(flat04.or.flat05)then
      call errflatr(fhk,frcalc,wr,nref,ih,k,l,sclr,aold)
	else
      call errflat(fhk,frcalc,wr,nref,ih,k,l,sclr,aold)
	endif
	do j=1,npad
		if(frcalc(j).lt.1e-6)then
			arcalc(j)=0
			frcalc(j)=0
		endif
	enddo
	else
      call errclean(fhk,frcalc,wr,nref,ih,k,l,sclr,aold)
	endif
      er1=sferr2
      er2=sferr1
C	Quick escape if we are increasing unless ncn is negative
      ndev=4
      if(fstest(9).gt.1)ndev=nint(fstest(9))
      ndev=max(ndev,4)
	if(ncon.gt.ndev.and.sfold-sferr2.le.1e-5.and.ncn.gt.-3)then
		tclean3D=-99
		return
C	if sclr is very small, we have bombed
	else if(abs(sclr).lt.1e-5)then
		sferr2=sfold+10
		tclean3D=-98
		return
	endif
C	Positivity
	if(flat)then
	if(flat04.or.flat05)then
        	call errflatr(fhk,fp1,wp1,nref,ih,k,l,sclp1,aold)
	else
        	call errflat(fhk,fp1,wp1,nref,ih,k,l,sclp1,aold)
	endif
	do j=1,npad
		if(fp1(j).lt.1e-5)then
			ap1(j)=0
			fp1(j)=0
		endif
	enddo
	else      
	call errclean(fhk,fp1,wp1,nref,ih,k,l,sclp1,aold)
	endif
	errp1=sferr2
	fomt1=sferr2
	sclp1=abs(sclp1)

C	Punt Mode
	if(flat)then
	if(flat04.or.flat05)then
       	 call errflatr(fhk,fp2,wp2,nref,ih,k,l,sclp2,aold)
	else
       	 call errflat(fhk,fp2,wp2,nref,ih,k,l,sclp2,aold)
	endif
	do j=1,npad
		if(fp2(j).lt.1e-5)then
			ap2(j)=0
			fp2(j)=0
		endif
	enddo
	else      
	call errclean(fhk,fp2,wp2,nref,ih,k,l,sclp2,aold)
	endif
	errp2=sferr2
	fomt2=sferr2
	sclp2=abs(sclp2)

C	Max Ent
	if(flat)then
	if(flat04.or.flat05)then
      call errflatr(fhk,ficalc,wi,nref,ih,k,l,scli,aold)
	else
      call errflat(fhk,ficalc,wi,nref,ih,k,l,scli,aold)
	endif
	do j=1,npad
		if(ficalc(j).lt.1e-5)then
			aicalc(j)=0
			ficalc(j)=0
		endif
	enddo
	else      
	call errclean(fhk,ficalc,wi,nref,ih,k,l,scli,aold)
	endif
      ei1=sferr2
      ei2=sferr1
C	Trap Max ent bombing
	if(abs(scli).lt.1e-5)then
		if(abs(sclp2).gt.1e-4)then
			do j=1,npad
				ficalc(j)=fp2(j)
				aicalc(j)=ap2(j)
			enddo
			scli=sclp2
			ei1=errp2
		else if(abs(sclp1).gt.1e-4)then
			do j=1,npad
				ficalc(j)=fp1(j)
				aicalc(j)=ap1(j)
			enddo
			scli=sclp1
			ei1=errp1
		else
C			Both are 0 - Punt!
			tclean3D=-97
			sferr2=sfold+10
			return
		endif
	endif
D     call timer(1,'Scaled')      

      scaler=abs(sclr)
      scalei=abs(scli)
      sferr2=er1
      sferr1=ei1
      prl=0
C	Trap the setting of new reflections with small values
        if(slow)then
        prl=exp(-(ncon-1)/abs(slw1))/slw2
        phigh=1e9
        if(prl.gt.0.01)then
        do j=1,nref-1
        if(aold(j).lt.1e-3)then
        if(frcalc(j).lt.prl*ftrueh(j))then
		gotem=.false.
		frcalc(j)=0
		arcalc(j)=0
		ficalc(j)=0
		aicalc(j)=0
		fentry(j)=0
		ahk(j)=0
		fold(j)=0
		aold(j)=0
		ap1(j)=0
		ap2(j)=0
		fp1(j)=0
		fp2(j)=0
        endif
        endif
        enddo
        endif
        endif


c	Save Entropy values
	do j=1,npad
	      frcalc(j)=frcalc(j)*scaler
	      ficalc(j)=ficalc(j)*scalei
	      fp1(j)=fp1(j)*sclp1
	      fp2(j)=fp2(j)*sclp2
	enddo
	do j=1,npad
		ang=arcalc(j)
		fent1(j)=frcalc(j)*cmplx(cos(ang),sin(ang))
		ang=aicalc(j)
		fent2(j)=ficalc(j)*cmplx(cos(ang),sin(ang))
		ang=ap1(j)
		fpos(j)=fp1(j)*cmplx(cos(ang),sin(ang))
		ang=ap2(j)
		fpunt(j)=fp2(j)*cmplx(cos(ang),sin(ang))
C	Probably should have this trap - with some low level
		if(frcalc(j).lt.1e-5)then
			arcalc(j)=0
			ficalc(j)=0
			aicalc(j)=0
			frcalc(j)=0
			fent1(j)=0
			fent2(j)=0
			fentry(j)=0
			ahk(j)=0
			fold(j)=0
			aold(j)=0
			fp1(j)=0
			fp2(j)=0
			fpos(j)=0
			ap1(j)=0
			ap2(j)=0
			fpunt(j)=0
		else if(ficalc(j).lt.1e-5)then
			ficalc(j)=frcalc(j)
			aicalc(j)=arcalc(j)
			fent2(j)=fent1(j)
		endif
	enddo

C     Different cases
      if(ftune(2).lt.1)then
C     3-way combination
         sr=1./3.*(2+exp(-(ncon-1.)/3.))
         si=abs(sr-1.)
      else if(ftune(2).lt.5)then
C     Positivity only
         sr=0
         si=1
      else if(ftune(2).lt.6)then
C     2/3 Entropy, 1/3 Positivity
         sr=1./3.*(2+exp(-(ncon-1.)/3.))
         si=abs(sr-1.)
      else if(ftune(2).lt.7)then
C     Entropy Only
         sr=1
         si=0
	else if(ftune(2).lt.8)then
C	75% Entropy, 25% Max Ent
         sr=(.75+.25*exp(-(ncon-1.)/3.))
         si=1-sr
	else
C     2/3 Entropy, 1/3 Positivity
         sr=1./3.*(2+exp(-(ncon-1.)/3.))
         si=abs(sr-1.)
      endif

      xr1=abs(ftune(1))
D	write(10,*)'Debug xr1 ',xr1,ftune(1)
      xr3=ftune(3)
      if(xr3.gt.10.)xr3=xr3-10.
      if(xr3.lt.0.01)xr3=0.5
        if(ftune(1).gt.99.)then
C       Automatic case (Clean this junk up!)
                xx=abs(ftune(3))*(1-exp(-(ncon-1.)/3.))
         	xx=xx+1
                at=sr*(1-xx)+xx
                bt=xx*(2-sr)
                if(at.lt.1e-2)then
                        xr1=1.0
                else
                        xr1=bt/at
                endif
                if(xr1.gt.1.95)xr1=1.95
        else
       if(xr1.gt.10.)then
         xr1=xr1-10*int(xr1*0.1)
         if(xr1.gt.10.)xr1=xr1-10
         if(xr1.lt.0.)xr1=xr1+10.
        if(xr1.lt.1.)then
        xr1=1+1.5*xr3*exp(-(ncon-9.)*(ncon-9.)/20.)
        xr1=xr1+xr3*0.5*(1-exp(-ncon*ncon/20.))
        if(xr1.gt.1+xr3)xr1=1+xr3
        else
         xr1=1+xr3*(1-exp(-(ncon-1.)/xr1))
        endif
         if(xr1.lt.0)xr1=0.1
      endif
        endif
      xr=xr1-1.
C	write(10,*)'Debug 2 ',xr,xr1
      nang2=0
      sang3=0
	sr_1=sr*0.5
	if((ftune(2).lt.1.).and.(.not.punt))then
		do j=1,npad
C		3-way sum
		fpred(j)=(fent1(j)+fpunt(j))*sr_1+fent2(j)*si
		enddo
	else
		do j=1,npad
C		2-way sum
		fpred(j)=fent1(j)*sr+fent2(j)*si
		enddo
	endif
	do j=1,npad
		arsum=fpred(j)
		aisum=imag(fpred(j))
		fsq=arsum*arsum+aisum*aisum
		if(fsq.gt.1d-12)then
			fcalc(j)=sqrt(fsq)
			acalc(j)=atan2(aisum,arsum)
			if(acalc(j).lt.5e-2)acalc(j)=acalc(j)+pi2
			wr(j)=cos(acalc(j)-ahk(j))
		else
			fcalc(j)=0
			acalc(j)=0
			wr(j)=1
		endif
	enddo         
       
C	Scale the combination
	call errclean(fhk,fcalc,wr,nref,ih,k,l,scalec,aold)
      errc2=sferr2
      scalec1=abs(scalec)
      do j=1,npad
	      fcalc(j)=fcalc(j)*scalec1
	enddo
	do j=1,npad
		ang=acalc(j)
		fpred(j)=fcalc(j)*cmplx(cos(ang),sin(ang))
      enddo
C
C	Extended Over-relaxation
	if(sfold.lt.1e-6.or.ncon.le.2.or.ncn.le.2)then
		predl=1
	else
C	Adjust the scaling of the two
		t1=ei1*sfold/sfold2
		predl=(sr*er1+si*t1)*sfold/(er1*er1)
		xr1=1+(xr1-1)*predl
		xr1=min(xr1,2.)
        	xr=xr1-1
      endif
	sfold=er1
	sfold2=ei1
	sp1old=errp1
	sp2old=errp2
	xo2=0.5+0.45*exp(-(ncon-1.)/3.)
	xo1=1-xo2

	if(ncn.gt.2)then
		do j=1,npad
		fpred(j)=fpred(j)*xr1-(xo2*fentry(j)+xo1*fold(j))*xr
		enddo
	else
		do j=1,npad
		fpred(j)=fpred(j)*xr1-fentry(j)*xr
		enddo
	endif
      do j=1,npad
	arsum=fpred(j)
	aisum=imag(fpred(j))
	fsq=arsum*arsum+aisum*aisum
	if(fsq.gt.1d-12)then
		fcalc(j)=sqrt(fsq)
		ang=atan2(aisum,arsum)
		if(ang.lt.5e-2)ang=ang+pi2
C     	 	call equiv3(he,ke,le,ise,ih(j),k(j),l(j),ne,symm)
                if(centref(j))then
C               truncate angle to moduli pi provided that > a cutoff
                        ia=nint(ang/pi)
                        if(2*(ia/2).eq.ia)then
                                ia=2
                        else
                                ia=1
                        endif
		        ang=ia*pi
                endif
		wr(j)=cos(ang-ahk(j))
		acalc(j)=ang
	else
		fcalc(j)=0
		acalc(j)=0
		wr(j)=1
		fpred(j)=0
	endif
	enddo         
 
C	Scale the over-relaxed value
	call errclean(fhk,fcalc,wr,nref,ih,k,l,scalec,aold)
      scalec=abs(scalec)
      do j=1,npad
      	fcalc(j)=fcalc(j)*scalec
	enddo
	do j=1,npad
	ang=acalc(j)
      	fpred(j)=fcalc(j)*cmplx(cos(ang),sin(ang))		
      enddo
      ec1=sferr2
      ec2=sferr1
      scaler=abs(sclr)
      scalei=abs(scli)
      sferr2=er1
      sferr1=ei1
C	Rods ?
	if(brod)then
                if(brod3)then
                call rodthree(fpred,fold,ih,k,l,npad,symm,wts,printf)
                else if(brod2)then
                call rodtwo(fpred,fold,ih,k,l,npad,symm,wts,printf)
                else
		call rodone(fpred,fold,ih,k,l,npad,symm,wts,printf)
                endif
      		do j=1,npad
			arsum=fpred(j)
			aisum=imag(fpred(j))
			fsq=arsum*arsum+aisum*aisum
			if(fsq.gt.1d-12)then
				fcalc(j)=sqrt(fsq)
				ang=atan2(aisum,arsum)
				if(ang.lt.5e-2)ang=ang+pi2
                		if(centref(j))then
C               truncate angle to moduli pi provided that > a cutoff
                        		ia=nint(ang/pi)
                        		if(2*(ia/2).eq.ia)then
                                		ia=2
                        		else
                                		ia=1
                        		endif
		        		ang=ia*pi
                		endif
				acalc(j)=ang
			else
				fcalc(j)=0
				acalc(j)=0
				fpred(j)=0
			endif
		enddo 
	endif        

      s1=0
      s2=0
      s3=0
      nang2=0
      sang3=0
C	Sums for monitoring (exclude ?)
	do j=1,npad
		s1=s1+fhk(j)
	enddo
	do j=1,npad
		del=ahk(j)-acalc(j)
		s3=s3+fhk(j)*del*del
		sang3=sang3+del*del
	enddo
	s3=s3*aconv*aconv
	sang3=sang3*aconv*aconv/npad

	nnup=nref
      if(printf)then
	if((n3.eq.1).or.debug)nnup=npad
      do j=1,nnup
            ar=arcalc(j)*aconv
            ai=aicalc(j)*aconv
            ac=acalc(j)*aconv
C     reduce difference to smallest value with multivaluedness
            delta=ac-aold(j)
            delta1=abs(delta+360)
            delta2=abs(delta-360)
            delta=abs(delta)
            if(delta.lt.delta1.and.delta.lt.delta2)then
               del=ac-aold(j)
            else if(delta1.lt.delta2)then
               del=ac-aold(j)+360.
            else
              del=ac-aold(j)-360.
            endif
        if(abs(abs(del)-180.).lt.5e-2)del=180.
C     Trap undefined to 360
      if(abs(aold(j)).lt.1e-2.and.abs(ac-360).lt.1e-2)del=360.

C
C	Stuff for two other directions
		arsum=fpos(j)
		aisum=imag(fpos(j))
		brsum=fpunt(j)
		bisum=imag(fpunt(j))
		fsq=arsum*arsum+aisum*aisum
		if(fsq.gt.1d-10)then
			fp_got=sqrt(fsq)
			ap_got=atan2(aisum,arsum)*aconv
			if(ap_got.lt.1)ap_got=ap_got+360
		else
			fp_got=0
			ap_got=0
		endif
 		fsq=brsum*brsum+bisum*bisum
		if(fsq.gt.1d-10)then
			fp2_got=sqrt(fsq)
			ap2_got=atan2(bisum,brsum)*aconv
			if(ap2_got.lt.1)ap2_got=ap2_got+360
		else
			fp2_got=0
			ap2_got=0
		endif

            WRITE(10,4)IH(j),K(j),l(j),ar,frcalc(j),ai,ficalc(j),
     1       aold(j),FHK(j),ac,fcalc(j),del,ap_got,fp_got,
     2	 ap2_got,fp2_got
    4       FORMAT(3I3,4(F6.1,f6.3),f6.1,4(f6.1,f6.3))
  401       FORMAT(3I3,5(F7.2,f7.4),f8.3,f9.4,f8.3)
      enddo
      endif

C	      include 'errproj.h'
D     call timer(1,'Generated')      


	do j=1,npad
		ahk(j)=acalc(j)
	enddo
	jslow=nref+1
	if(brall)jslow=1
	do j=jslow,npad
		fhk(j)=fcalc(j)
	enddo
C	fhk(nref)=1
	ahk(nref)=pi2
	tclean3D=sqrt(sang3)
	if(s3.lt.1e-5)then
		anglerr=0.
	else
		anglerr=sqrt(s3/s1)
	endif

      if(printf)then
      write(10,901)'Phase Relaxation: ',xr1, ' Amplification ',predl
      write(10,901)'Scales of Entropy:',sclr,' Max Ent:',scli,
     1' Comb1' , scalec1,' Comb2' , scalec
      write(10,901)'Weight of Entropy:',sr,  ' Max Ent:',si
      write(10,901)'Scales of Positive:',sclp1,' FOM',errp1,
     1' Scale Old' , sclp2,' FOM' , errp2
	write(10,901)'Positive Sum: ',ffs2002(2),' Negative Sum: '
     1 ,ffs2002(1)
	write(10,901)'Positive Max% ',ffs2002(4)*100,' Negative Max% '
     1 ,ffs2002(3)*100
901   format(a,f10.5,a,f10.5,a,f10.5,a,f10.5a,f10.5a,f10.5)
      endif

      if(ncn.le.1)then
      	do j=1,npad
      		fold(j)=fentry(j)
      	enddo
      else
	if(lgtmp4)then
		xo2=1
		xo1=0
	endif
        do j=1,npad
        	fold(j)=(xo1*fold(j)+xo2*fentry(j))
        enddo
      endif
      fold(nref)=1
      RETURN
      END
