C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE ESHP2D (N1, N2, M, C)
         COMPLEX C(*)
         REAL*8 X, XMEAN, BCUT
         INTEGER M(3), N1, N2
         include 'NewStuff.h' 
C     Do a negative FFT
         CALL FFT2DN (C)
C
C           Correction for the origin shift
C           Quench any imaginary component as a rounding error
         XMEAN = 1./dble(N1*N2)
         IF(UFLIP5)XMEAN=XMEAN*STOE
         BCUT=BCUTP*XMEAN
         MF = (-1)
         JK = 0
         DO   I=1,N2
           MF = -MF
           NF = (-MF)
           DO   J=1,N1
             JK = JK + 1
             NF = -NF
             X = C(JK)
             IF(NF .LT. 0) X = -X
             IF(LENT4)then
                IF(X .LT. -XMEAN) THEN
                        X= 0
                ELSE
                        X = X*LOG( ABS(X)/XMEAN) 
                ENDIF
             ELSE
                IF (X .LT. BCUT ) THEN
                        X = 0
                ELSE IF (.not.PWind) THEN
                        X = X * LOG (X/XMEAN)
                END IF
             ENDIF
             IF(NF .LT. 0)X =-X
             C(JK) = X
           END DO
         END DO
         CALL FFT2DP (C)
         RETURN
       END

