C 
C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
C
      Function tclean2D(IH,K,FHK,AHK,ain,NREF,NCN,cflag,symm
     1 ,nbeams,nhk,c,m,iopt)
C
C           
      PARAMETER (NHK2 = 900, NLIMIT = 65536)

      LOGICAL PRINTF
      COMMON /PRINTS/PRINTF
         LOGICAL TLOG(6),gotentry
         DIMENSION FTUNE(4)
         COMMON /TUNING/TLOG, FTUNE
         DIMENSION FSTEST(20)
         COMMON /COPT2/FSTEST
         Data gotentry /.false./
         save gotentry
      INCLUDE 'NewStuff.h'
         COMMON /ECALC/SFERR1, ANGERR, SFERR2
         COMMON /PADCMM/NPAD
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
         
      DIMENSION IH(*),K(*),FHK(*),AHK(*),Aold(nhk2),AIN(*)
      dimension frcalc(nhk2),ficalc(nhk2),arcalc(nhk2),L(nhk2)
      dimension fcalc(nhk2),acalc(nhk2),aicalc(nhk2)
      dimension wr(nhk2),wi(nhk2)
      integer he(20),ke(20),le(20),ise(20),m(3)
      complex c(*)
      complex*16 w1,w2,res1,res2,res3,res4
      double precision brsum,bisum,pi,pi2
      double precision sr,si,aconv,xr1,xr,ang,fsq
      double precision cosan,sinan,f,aisum,arsum
      logical cflag
      character*4 symm,symt
      integer bequiv(nhk2/4)
      complex fentry(nhk2),fent1(nhk2),fent2(nhk2),
     $ fpred(nhk2),fold(nhk2),ftmp
      save fold,bequiv,oscale,oscold
C      complex amp, amp2
      common /parcomn/ep1
      logical gotem,centref(nhk2),gotcent
	save sfold,sfold2,sp1old,sp2old,fmax,centref,gotcent
	data fmax/-1./,gotcent/.false./
C
C	For adaptive approach
	complex fpos(nhk2),fpunt(nhk2)
	dimension fp1(nhk2),ap1(nhk2),fp2(nhk2),ap2(nhk2)
	dimension wp1(nhk2),wp2(nhk2),ftrueh(nhk2)
	save ftrueh
C        Parameters for when angle ~0 and slow development (fs2002)
         parameter (ACUT=1D-5)



	do J=1,npad
             L(J)=0
        enddo

	if(ncn.lt.-5)then
		sfold=sfold+5
		sfold2=sfold2+5
		sp1old=sp1old+5
		sp2old=sp2old+5
	else if(ncn.lt.2)then
		sfold=0
		sfold2=0
		sp1old=0
		sp2old=0
	endif

      gotem=.true.
      NCON=ABS(NCN)

	if(.not.gotcent)then
		gotcent=.true.
		do j=1,npad
      	call equiv3(he,ke,le,ise,ih(j),k(j),l(j),ne,symm)
		if(ise(1).eq.3)then
			centref(j)=.true.
		else
			centref(j)=.false.
		endif
		enddo
	endif

       if(.not.gotentry)then
        do j=1,nref
                ftrueh(j)=fhk(j)
        enddo
        gotentry=.true.
        endif

C	  if(fmax.lt.-0.1)then
          fmax=fhk(1)
	  do j=2,nref-1
		if(fhk(j).gt.fmax)fmax=fhk(j)
	  enddo
C	  endif

C     Origin for arrays (for consistency with FFT's)
      m(3)=0
      n1=m(1)
      n2=m(2)
      n3=m(3)
      n3c=n3/2+1
      n1c=n1/2+1
      n2c=n2/2+1
      
C     Angle conversion scaler
      pi=asin(1.0d0)
      pi=pi+pi
      pi2=pi+pi
      aconv=180.d0/pi   

  998 FORMAT('***** START OF ITERATION NUMBER ',I3,2X,'*****'/
     1 2X,'H',2X,'K',2X,'L',3X,'A1',5X,'F1',3X,'A2',5X,'F2'
     2 ,2X,'AOLD',2X,'FOLD',2X,'ANEW',2X,'FNEW',2X,'Diff')

C     Zero estimates for first cycle
      if(ncon.eq.1)then
		do j=1,npad
			fold(j)=0
		enddo
       	do j=nref+1,npad
             	fhk(j)=0.
              	ahk(j)=0.
               	fcalc(j)=0.
         	enddo
         	fhk(nref)=1
C     		call winputn(ih,k,l,fhk,ahk,nref,symm,n3)
      endif

	do j=1,nref
		ang=ahk(j)
		if(abs(ang).gt.1e-3)then
                if(ang.lt.5e-2)then
                        ang=ang+pi2
                        ahk(j)=ang
                endif
		    fentry(j)=fhk(j)*cmplx(cos(ang),sin(ang))
		else
		    fentry(j)=0
		endif
	enddo
	do j=nref+1,npad
		ang=ahk(j)
                if(ang.lt.5e-2)then
                        ang=ang+pi2
                        ahk(j)=ang
                endif
		fentry(j)=fhk(j)*cmplx(cos(ang),sin(ang))
	enddo
	fentry(nref)=1
	do j=1,npad
           	aold(j)=ahk(j)*aconv
		acalc(j)=ahk(j)
		fcalc(j)=fhk(j)
	enddo

	fhk(nref)=1
        ahk(nref)=pi2
c     Window
C	if(n3.gt.1)then
C	call winsimple(fcalc,acalc,ih,k,l,m,c,npad,printf)

C
C	do j=nref+1,npad
C		ahk(j)=acalc(j)
C		fhk(j)=fcalc(j)
C	enddo
C	endif

      IF(printf)then
                WRITE(10,998)NCON
      endif
C     setup in c the symmetry related values
      do j=1,n1*n2*n3
         c(j)=0.
      enddo
D     call timer(1,'Windowed')
      do j=1,npad
      ihh=ih(j)
      ikk=k(j)
      call equiv3(he,ke,le,ise,ihh,ikk,l(j),ne,symm)
      f=fhk(j)
      ang=ahk(j)
      if(centref(j).and.abs(ang).gt.1e-4)then
C     truncate angle to moduli pi provided that > a cutoff
         ia=nint(ang/pi)
         ftt=fentry(j)
	   ftt=abs(ftt)
         if(2*(ia/2).eq.ia)then
         	ia=2
         	fentry(j)=ftt
         else
         	ia=1
		fentry(j)=-ftt
         endif
         ang=pi*ia
         acalc(j)=ang
         ahk(j)=ang
      endif      
      if(ihh.eq.0.and.ikk.eq.0.and.l(j).eq.0)then
         cosan=1.
         sinan=0.
         f=1.
         fhk(j)=1
         ahk(j)=pi2
         aold(j)=360
C         fcalc(j)=1
C         acalc(j)=pi2
      else if(abs(ang).lt.1e-4)then
         f=0.0
         cosan=0.0
         sinan=0.0
      else      
C      if((f.gt.fmax).and.(j.le.nref))fmax=f
        COSAN = COS(ANG)*f
        SINAN = SIN(ANG)*f
        endif
C     Information about symmetry coding of phases        
C      include 'transcode3D.h'
      do jj=1,ne
C     trap problems with p3 symmetry to give rectangular axes
         if(symm(1:2).eq.'p3'.or.symm(1:2).eq.'p6')then
            call p3exp(ihjj,ikjj,he(jj),ke(jj))
            ihjj=ihjj+n1c
            ikjj=ikjj+n2c
          else
            ihjj=he(jj)+n1c
            ikjj=ke(jj)+n2c
         endif
         ind=(ikjj-1)*n1+ihjj
        isjj=ise(jj)
         if(isjj.lt.0)then
            C(ind)=cmplx(cosan,-sinan)
        else if(isjj.lt.2)then
            C(ind)=cmplx(cosan,sinan)
         else if(isjj.eq.3)then
            C(ind)=cmplx(cosan,0.d0)
         else if(isjj.eq.6)then
            C(ind)=cmplx(0.d0,sinan)
         else if(isjj.lt.8)then
            C(ind)=cmplx(cosan,sinan)
         else if(isjj.lt.110)then
            awork=ang+he(1)*pi
            C(ind)=f*cmplx(cos(awork),sin(awork))

C     X or Y-glide
         else if(isjj.lt.210)then
            C(ind)=-cmplx(cosan,sinan)
         else if(isjj.eq.300)then
            C(ind)=-cmplx(cosan,-sinan)

C     p2mg case
         else if(isjj.eq.1000)then
            C(ind)=-cmplx(cosan,0.d0)
         else if(isjj.eq.2000)then
            C(ind)=cmplx(0.d0,-sinan)
         endif
      enddo

C     endif
      enddo
C     Perform the transformation
D     call timer(1,'Setup')

C	Model or normal ?
C	if(model)then
C		mproj=.true.
C      		if(modl2)mproj=.false.
C      		base=basemod*(1-exp(-ncon*0.5+0.5))
C      		call modsharp3D(n1,n2,n3,m,c,base)
C	else
      		call shclean3D(n1,n2,n3,m,c)
C	endif
D     call timer(1,'Sharpened')      
C      if(sconst.lt.1e-6)then
C        sconst=1
D       write(6,*)'Bug in sconst !!!'
C      endif
C     Outer loop for target reflections
c     Tweak parameters, taken from tboth2D.f
	scl0=0.25
	scu0=0.35
	scn0=2.0
	sdev=0.5
	dev=exp(ncon*sdev-sdev)
	scu=scu0*dev
	scl=scl0/dev
	scn=scn0*dev
	flow=fmax*0.1/dev
        poscon=1
        puntcon1=1
        puntcon2=1
        fac2=1
D	write(18,*)fac2,puntcon1,puntcon2,poscon,ffs2002(10)
C
C	Zero stuff
	do i=1,npad
		frcalc(i)=0
		ficalc(i)=0
		arcalc(i)=0
		aicalc(i)=0
		fp1(i)=0
		fp2(i)=0
		ap1(i)=0
		ap2(i)=0
	enddo
      DO 1031 I = 1,NPAD
C     Index coding for 3D
C     *** bindcode3D.h start
C	Average over equivalent reflections (does it matter?)
         call equiv3(he,ke,le,ise,ih(i),k(i),l(i),ne,symm)
         w1=0.
         w2=0.
         nnn=0
         do jt=1,ne

         if(ise(jt).eq.1.or.ise(jt).eq.3)then
	   ihjj=he(jt)
	   ikjj=ke(jt)
C     trap problems with p3 symmetry to give rectangular axes
         if(symm(1:2).eq.'p3'.or.symm(1:2).eq.'p6')
     $	call p3exp(ihjj,ikjj,he(jt),ke(jt))
          ih1=ihjj+n1c
          ik1=ikjj+n2c
          ih2=-ihjj+n1c
          ik2=-ikjj+n2c
         ind1=(ik1-1)*n1+ih1
         ind2=(ik2-1)*n1+ih2
         w1=w1+c(ind1)
         w2=w2+c(ind2)
         nnn=nnn+1
         endif

         enddo
         w1=w1/dble(nnn)
         w2=w2/dble(nnn)
C         write(10,*)'Averaged ',ih(i),k(i),nnn
C        *** bindcode3d.h end
C

C     Extract two terms from real and imag parts
      res1=(w1+conjg(w2))*0.5d0
      res2=(w1-conjg(w2))/cmplx(0.d0,2.d0)
C	Project the positivity 
C	res3=(res1+res2/fac2)*poscon
C	Project the "punt" term (ff0=1)
C	res4=(res1-res3*puntcon1)*puntcon2
        res3 = res2
        res4 = res2
	arsum=res1
	brsum=imag(res1)
	if(lentr)then
		res2=res2*entw(i)
	endif
 	aisum=res2
 	bisum=imag(res2)
      if(centref(i))then
		bisum=0
		brsum=0
		res3=dble(res3)
		res4=dble(res4)
      endif

 1090       FSQ =  ARSUM*ARSUM + BRSUM*BRSUM
            if(fsq.gt.1e-12)then
                FSQ=sqrt(FSQ)
                FRCALC(I) = FSQ
                ARCALC(I) = atan2(brsum,arsum)
                if(arcalc(i).lt.5e-2)arcalc(i)=arcalc(i)+pi2
            endif
           FSQ =  AISUM*AISUM + BISUM*BISUM
            if(fsq.gt.1e-12)then
                FSQ=sqrt(FSQ)
                FICALC(I) = FSQ
                AICALC(I) = atan2(bisum,aisum)
                if(aicalc(i).lt.5e-2)aicalc(i)=aicalc(i)+pi2
            endif
		AISUM=res3
		BISUM=imag(res3)
           	FSQ =  AISUM*AISUM + BISUM*BISUM
            if(fsq.gt.1e-12)then
                FSQ=sqrt(FSQ)
                Fp1(I) = FSQ
                Ap1(I) = atan2(bisum,aisum)
                if(ap1(i).lt.5e-2)ap1(i)=ap1(i)+pi2
            endif
		AISUM=res4
		BISUM=imag(res4)
           	FSQ =  AISUM*AISUM + BISUM*BISUM
            if(fsq.gt.1e-12)then
                FSQ=sqrt(FSQ)
                Fp2(I) = FSQ
                Ap2(I) = atan2(bisum,aisum)
                if(ap2(i).lt.5e-2)ap2(i)=ap2(i)+pi2
            endif 
c	Only trap the first three cycles
C        write(10,*)ih(i),k(i),res1,res2
	if(ncon.lt.4.and.i.lt.nref)then
	  Ftrap=FHK(i)*scl
          ftrap2=fhk(i)*scu
	  if(fhk(i).lt.flow.and.aold(i).lt.0.01)then
c	  	Unconditionally too small, set to zero (unless input)
		frcalc(i)=0
		ficalc(i)=0
		arcalc(i)=0
		aicalc(i)=0
		fold(i)=0
		fentry(i)=0
		aold(i)=0
		ahk(i)=0
		fp1(i)=0
		ap1(i)=0
		fp2(i)=0
		ap2(i)=0
C		write(10,*)'Trap ',fhk(i),flow,ih(j),k(j)
	  else if(aold(i).lt.1e-2)then
        	if(frcalc(i).lt.Ftrap.or.frcalc(i).gt.ftrap2)then
c		Too small/large for predicting a new value, set to zero
			frcalc(i)=0
			ficalc(i)=0
			arcalc(i)=0
			aicalc(i)=0
			fold(i)=0
			fentry(i)=0
			aold(i)=0
			ahk(i)=0
			fp1(i)=0
			ap1(i)=0
			fp2(i)=0
			ap2(i)=0
C			write(10,*)'Trunc ',frcalc(i),ftrap,ftrap2,
C     X                  ih(i),k(i)
             endif
        endif
	endif

1031  CONTINUE
      do j=1,nref
		wr(j)=arcalc(j)-ahk(j)
		wi(j)=aicalc(j)-ahk(j)
		wp1(j)=ap1(j)-ahk(j)
		wp2(j)=ap2(j)-ahk(j)
      enddo
      do j=1,nref
      	wr(j)=cos(wr(j))
      	wi(j)=cos(wi(j))
		wp1(j)=cos(wp1(j))
		wp2(j)=cos(wp2(j))
      enddo
D     call timer(1,'Extracted')      

C	Entropy
        call errclean(fhk,frcalc,wr,nref,ih,k,l,sclr,aold)
        er1=sferr2
        er2=sferr1
C	Quick escape if we are increasing unless ncn is negative
      ndev=4
      if(fstest(9).gt.1)ndev=nint(fstest(9))
      ndev=max(ndev,4)
	if(ncon.gt.ndev.and.sfold-sferr2.le.1e-5.and.ncn.gt.-3)then
		tclean2D=-99
		return
C	if sclr is very small, we have bombed
	else if(abs(sclr).lt.1e-5)then
		sferr2=sfold+10
		tclean2D=-98
		return
	endif
C	Positivity
	call errclean(fhk,fp1,wp1,nref,ih,k,l,sclp1,aold)
	errp1=sferr2
	fomt1=sferr2
	sclp1=abs(sclp1)

C	Punt Mode
	call errclean(fhk,fp2,wp2,nref,ih,k,l,sclp2,aold)
	errp2=sferr2
	fomt2=sferr2
	sclp2=abs(sclp2)

C	Max Ent
	call errclean(fhk,ficalc,wi,nref,ih,k,l,scli,aold)
        ei1=sferr2
        ei2=sferr1
C	Trap Max ent bombing
	if(abs(scli).lt.1e-5)then
		if(abs(sclp2).gt.1e-4)then
			do j=1,npad
				ficalc(j)=fp2(j)
				aicalc(j)=ap2(j)
			enddo
			scli=sclp2
			ei1=errp2
		else if(abs(sclp1).gt.1e-4)then
			do j=1,npad
				ficalc(j)=fp1(j)
				aicalc(j)=ap1(j)
			enddo
			scli=sclp1
			ei1=errp1
		else
C			Both are 0 - Punt!
			tclean2D=-97
			sferr2=sfold+10
			return
		endif
	endif
D     call timer(1,'Scaled')      

      scaler=abs(sclr)
      scalei=abs(scli)
      sferr2=er1
      sferr1=ei1
      prl=0
C	Trap the setting of new reflections with small values
C        slow=.false.
        if(slow)then
        prl=exp(-(ncon-1)/abs(slw1))/slw2
        phigh=1e9
        if(prl.gt.0.01)then
        do j=1,nref-1
        if(aold(j).lt.1e-3)then
        if(frcalc(j).lt.prl*ftrueh(j))then
		gotem=.false.
		frcalc(j)=0
		arcalc(j)=0
		ficalc(j)=0
		aicalc(j)=0
		fentry(j)=0
		ahk(j)=0
		fold(j)=0
		aold(j)=0
		ap1(j)=0
		ap2(j)=0
		fp1(j)=0
		fp2(j)=0
C		write(10,*)'Slow ',frcalc(j),prl*ftrueh(j),ih(j),k(j)
        endif
        endif
        enddo
        endif
        endif


c	Save Entropy values
	do j=1,npad
	      frcalc(j)=frcalc(j)*scaler
	      ficalc(j)=ficalc(j)*scalei
	      fp1(j)=fp1(j)*sclp1
	      fp2(j)=fp2(j)*sclp2
	enddo
	do j=1,npad
		ang=arcalc(j)
		fent1(j)=frcalc(j)*cmplx(cos(ang),sin(ang))
		ang=aicalc(j)
		fent2(j)=ficalc(j)*cmplx(cos(ang),sin(ang))
		ang=ap1(j)
		fpos(j)=fp1(j)*cmplx(cos(ang),sin(ang))
		ang=ap2(j)
		fpunt(j)=fp2(j)*cmplx(cos(ang),sin(ang))
C	Probably should have this trap - with some low level
		if(frcalc(j).lt.1e-5)then
			arcalc(j)=0
			ficalc(j)=0
			aicalc(j)=0
			frcalc(j)=0
			fent1(j)=0
			fent2(j)=0
			fentry(j)=0
			ahk(j)=0
			fold(j)=0
			aold(j)=0
			fp1(j)=0
			fp2(j)=0
			fpos(j)=0
			ap1(j)=0
			ap2(j)=0
			fpunt(j)=0
C			write(10,*)'Kill 1',frcalc(j),ih(j),k(j)
		else if(ficalc(j).lt.1e-5)then
			ficalc(j)=frcalc(j)
			aicalc(j)=arcalc(j)
			fent2(j)=fent1(j)
		endif
	enddo

C     Different cases
         sr=1./3.*(2+exp(-(ncon-1.)/3.))
         si=abs(sr-1.)
         xr1=1+0.5*(1-exp(-(ncon-1.)/3.))
         xr=xr1-1.
      nang2=0
      sang3=0
	sr_1=sr*0.5
	do j=1,npad
C		2-way sum
		fpred(j)=fent1(j)*sr+fent2(j)*si
	enddo
	do j=1,npad
		arsum=fpred(j)
		aisum=imag(fpred(j))
		fsq=arsum*arsum+aisum*aisum
		if(fsq.gt.1d-12)then
			fcalc(j)=sqrt(fsq)
			acalc(j)=atan2(aisum,arsum)
			if(acalc(j).lt.5e-2)acalc(j)=acalc(j)+pi2
			wr(j)=cos(acalc(j)-ahk(j))
		else
			fcalc(j)=0
			acalc(j)=0
			wr(j)=1
		endif
	enddo         
       
C	Scale the combination
	call errclean(fhk,fcalc,wr,nref,ih,k,l,scalec,aold)
        errc2=sferr2
        scalec1=abs(scalec)
        do j=1,npad
	      fcalc(j)=fcalc(j)*scalec1
	enddo
	do j=1,npad
		ang=acalc(j)
		fpred(j)=fcalc(j)*cmplx(cos(ang),sin(ang))
        enddo
C
C	Extended Over-relaxation
	sfold=er1
	sfold2=ei1
	sp1old=errp1
	sp2old=errp2
	xo2=0.5+0.45*exp(-(ncon-1.)/3.)
	xo1=1-xo2

	if(ncn.gt.2)then
		do j=1,npad
		fpred(j)=fpred(j)*xr1-(xo2*fentry(j)+xo1*fold(j))*xr
		enddo
	else
		do j=1,npad
		fpred(j)=fpred(j)*xr1-fentry(j)*xr
		enddo
	endif
      do j=1,npad
	arsum=fpred(j)
	aisum=imag(fpred(j))
	fsq=arsum*arsum+aisum*aisum
	if(fsq.gt.1d-12)then
		fcalc(j)=sqrt(fsq)
		ang=atan2(aisum,arsum)
		if(ang.lt.5e-2)ang=ang+pi2
                if(centref(j))then
C               truncate angle to moduli pi provided that > a cutoff
                        ia=nint(ang/pi)
                        if(2*(ia/2).eq.ia)then
                                ia=2
                        else
                                ia=1
                        endif
		        ang=ia*pi
                endif
		wr(j)=cos(ang-ahk(j))
		acalc(j)=ang
	else
		fcalc(j)=0
		acalc(j)=0
		wr(j)=1
		fpred(j)=0
	endif
	enddo         
 
C	Scale the over-relaxed value
	call errclean(fhk,fcalc,wr,nref,ih,k,l,scalec,aold)
        scalec=abs(scalec)
        do j=1,npad
      	  fcalc(j)=fcalc(j)*scalec
	enddo
	do j=1,npad
	  ang=acalc(j)
      	  fpred(j)=fcalc(j)*cmplx(cos(ang),sin(ang))		
        enddo
      ec1=sferr2
      ec2=sferr1
      scaler=abs(sclr)
      scalei=abs(scli)
      sferr2=er1
      sferr1=ei1
      s1=0
      s2=0
      s3=0
      nang2=0
      sang3=0
C	Sums for monitoring (exclude ?)
	do j=1,npad
		s1=s1+fhk(j)
	enddo
	do j=1,npad
		del=ahk(j)-acalc(j)
		s3=s3+fhk(j)*del*del
		sang3=sang3+del*del
	enddo
	s3=s3*aconv*aconv
	sang3=sang3*aconv*aconv/npad

	nnup=nref
      if(printf)then
	if((n3.eq.1))nnup=npad
      do j=1,nnup
            ar=arcalc(j)*aconv
            ai=aicalc(j)*aconv
            ac=acalc(j)*aconv
C     reduce difference to smallest value with multivaluedness
            delta=ac-aold(j)
            delta1=abs(delta+360)
            delta2=abs(delta-360)
            delta=abs(delta)
            if(delta.lt.delta1.and.delta.lt.delta2)then
               del=ac-aold(j)
            else if(delta1.lt.delta2)then
               del=ac-aold(j)+360.
            else
              del=ac-aold(j)-360.
            endif
        if(abs(abs(del)-180.).lt.5e-2)del=180.
C     Trap undefined to 360
      if(abs(aold(j)).lt.1e-2.and.abs(ac-360).lt.1e-2)del=360.

C
C	Stuff for two other directions
		arsum=fpos(j)
		aisum=imag(fpos(j))
		brsum=fpunt(j)
		bisum=imag(fpunt(j))
		fsq=arsum*arsum+aisum*aisum
		if(fsq.gt.1d-10)then
			fp_got=sqrt(fsq)
			ap_got=atan2(aisum,arsum)*aconv
			if(ap_got.lt.1)ap_got=ap_got+360
		else
			fp_got=0
			ap_got=0
		endif
 		fsq=brsum*brsum+bisum*bisum
		if(fsq.gt.1d-10)then
			fp2_got=sqrt(fsq)
			ap2_got=atan2(bisum,brsum)*aconv
			if(ap2_got.lt.1)ap2_got=ap2_got+360
		else
			fp2_got=0
			ap2_got=0
		endif

            WRITE(10,4)IH(j),K(j),l(j),ar,frcalc(j),ai,ficalc(j),
     1       aold(j),FHK(j),ac,fcalc(j),del,ap_got,fp_got,
     2	 ap2_got,fp2_got
    4       FORMAT(3I3,4(F6.1,f6.3),f6.1,4(f6.1,f6.3))
  401       FORMAT(3I3,5(F7.2,f7.4),f8.3,f9.4,f8.3)
      enddo
      endif

	do j=1,npad
		ahk(j)=acalc(j)
	enddo
	jslow=nref+1
C	if(brall)jslow=1
	do j=jslow,npad
		fhk(j)=fcalc(j)
	enddo
C	fhk(nref)=1
	ahk(nref)=pi2
	tclean2D=sqrt(sang3)
	if(s3.lt.1e-5)then
		anglerr=0.
	else
		anglerr=sqrt(s3/s1)
	endif

      if(printf)then
      write(10,901)'Phase Relaxation: ',xr1, ' Amplification ',predl
      write(10,901)'Scales of Entropy:',sclr,' Max Ent:',scli,
     1' Comb1' , scalec1,' Comb2' , scalec
      write(10,901)'Weight of Entropy:',sr,  ' Max Ent:',si
      write(10,901)'Scales of Positive:',sclp1,' FOM',errp1,
     1' Scale Old' , sclp2,' FOM' , errp2
C	write(10,901)'Positive Sum: ',ffs2002(2),' Negative Sum: '
C     1 ,ffs2002(1)
C	write(10,901)'Positive Max% ',ffs2002(4)*100,' Negative Max% '
C     1 ,ffs2002(3)*100
901   format(a,f10.5,a,f10.5,a,f10.5,a,f10.5,a,f10.5,a,f10.5)
      endif

      if(ncn.le.1)then
      	do j=1,npad
      		fold(j)=fentry(j)
      	enddo
      else
C	if(lgtmp4)then
C		xo2=1
C		xo1=0
C	endif
        do j=1,npad
        	fold(j)=(xo1*fold(j)+xo2*fentry(j))
        enddo
      endif
      fold(nref)=1
      RETURN
      END
      subroutine errclean(fhk,frcalc,wr,nref,ih,k,l,sclr,aold)
      dimension fhk(*),frcalc(*),wr(*),ih(*),k(*),l(*),aold(*)
      call ERRNT2 (FHK,FRCALC,WR,NREF,IH,K,SCLR,AOLD)
      return
      end
      subroutine equiv3(he,ke,le,ise,ih,k,l,ne,symm)
      integer he(*),ke(*),le(*),ise(*)
      character*4 symm
      call EQUIV2 (HE,KE,ISE,IH,K,NE,SYMM)
      do n=1,ne
         le(n)=0
      enddo
      return
      end
      subroutine shclean3D(n1,n2,n3,m,c)
C	Should edit this to only relevant part of controls.h !
      complex c(*)
      integer m(3),n1,n2
         include 'NewStuff.h'
C	Use double-precision stuff here
      real*8 t1,t2,t3,ff0d,x,xi,xr,xmean,ft1,fac1,y
	real*8 fac2
	xneg=0
	xpos=0
	xnmax= 1e5
	xpmax=-1e5
        CALL FFT2DN (C)
C	Copy some parameters
	ff0d=STOE
C     Evaluate window function
      n3=1
      xm=n3/2+1
      npt=0
C     Quench any imaginary component as a rounding error
      t1=0.
      t2=0.
      t3=0.
      jk=0
	xmean=1./dble(n1*n2*n3)/ff0d
        ft1=xmean
	fac2=0.375d0
C      DO jl=1,n3
           wjl=1
           	MF=-1
           	DO I=1,n2
                MF=-MF
                NF=-MF
                FAC1=-MF*ft1
                DO j=1,n1
                        jk=jk+1
                        NF=-NF
                        FAC1=-FAC1
                        xi=c(jk)
			if(nf.lt.0)xi=-xi
                        y=xi*xi
                        x=xi/xmean
                        if(x.lt.1d-7)then
                        	xr=0
                        	xi=0
				xneg=xneg-x
				if(x.lt.xnmax)xnmax=x
                        else
				xpos=xpos+x
				if(x.gt.xpmax)xpmax=x
                        	xr=x*log(x)*fac1
                        	xi=xi*ff0d
                       		xi=-x*log(xi)*fac1*fac2
                        endif
                        c(jk)=cmplx(xr,xi)
                enddo
           enddo

C      enddo

        fomt1=0
	fomt2=0
C	endif
C	fomt2=abs(1.0d0-t3)
C     Invert
200     CALL FFT2DP (C)
	xneg=xneg*xmean
	xpos=xpos*xmean
C	Save stuff
        return
        end
