C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       PROGRAM FS2D
C
C
C        PARAMETER (NBEAMS = 256, NHK = 900, NBB = 80)
         include 'Nlimit.h'
         include 'Nbeams.h'
         DIMENSION P(2000)
         DIMENSION D(3)
         LOGICAL XRAY,PATTCHECK
         DIMENSION LL(9), M(3), L(NHK)
         COMMON /TDATA/LL, NDIMM, MDIMM, AB, D2, THETA, NSLICE
         COMMON /DBTERM/BTEMP
C         PARAMETER (NHK2 = 900, NLIMIT = 65536)
         LOGICAL PRINTF
         COMMON /PRINTS/PRINTF
         DIMENSION WINWTS(NHK2)
         COMMON /FOM5/WINWTS
         LOGICAL PWMASK, EOPT, PWACC, PMACC
         COMMON /WALSH/PWMASK, EOPT, PWACC, PMACC
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
C     data centro /.false./
         COMMON /ERRTRY/NWOPT
         COMMON /ENTC2D/RAD1, RAD2
 
C     For tuning
         LOGICAL TLOG(6)
         DIMENSION FTUNE(4)
         COMMON /TUNING/TLOG, FTUNE
         LOGICAL WTSON, WT2ON
         DIMENSION WTS(NHK2), EWTS(NHK2), MULTI(NHK2)
         DIMENSION WPOS(NHK2)
         COMMON /WPOSC/WPOS
         COMMON /WCOM/WTS, WTSON, MODE
         COMMON /WCOM2/EWTS, WT2ON
         COMMON /MPCOMM/MULTI
         COMMON /ECALC/SFERR1, ANGERR, SFERR2
         COMMON /PADCMM/NPAD
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
         INTEGER NCONT(20)
         DIMENSION CELL(6), TEMPF(20), AOCC(20), ZATOM(20)
         LOGICAL FORIG, FSEMP, BROWNF, DMULT, DMLT, FOM2
         Include 'Sfacts.h'
         COMMON /SFCOM1/TEMPF, NCONT, NATOM, CELL
         COMMON /SFCOM2/AOCC, ZATOM, FORIG, BROWNF, DMULT, DMLT
         COMMON /MVIS/WIDTH, HEIGHT, TIMES, FSEMP
         COMMON /COPT/ATNUM, PATTC, ACTERM, FOM2
         DIMENSION FSTEST(20)
         COMMON /COPT2/FSTEST
         INTEGER LAT(2)
         COMMON /CLAT/LAT
 
         PARAMETER (NMAX = nlimit)
         DIMENSION VV(nmax*2), F(nmax*2)
         DIMENSION S(2048), IS(1024)
         INTEGER HE(20), KE(20), ISE(20)
         DIMENSION IH(NHK), K(NHK), FHK(NHK), AHK(NHK), AIN(NHK)
         DIMENSION F2((-80):80,(-80):80)
         CHARACTER*4 SYMM, NAME
         CHARACTER*78 TITLE, CDNAME
         LOGICAL CFLAG, FLAGS, FNORM, PMASK
         CHARACTER*50 FORMT
         SAVE F2, AIN, AHK, FHK, K, IH, IS, S, F, /COPT2/ , /COPT/ , /
     X      MVIS/ , /SFCOM2/ , /SFCOM1/ , /FOMALL/ , /MPCOMM
     X      / , /WCOM2/ , /WCOM/ , /FOM5/
         DOUBLEPRECISION DD1, DD2, DD3, DD4, DD5, DD6
         PARAMETER (DD1 = -0.5D0, DD2 = -0.5D0, DD3 = -0.5D0, DD4 = -
     X      0.5D0, DD5 = -0.5D0)
         PARAMETER (DD6 = -0.5D0)
         REAL RR1, RR2, RR3, RR4, RR5, RR6, RR7, RR8
         LOGICAL LL1
 
C
         FORMT = '((20f9.5))     '
 
C     get the input as arguement
         CALL UOPEN2 (2)
 
C      READ(2,5) CDNAME
    5    FORMAT(A)
         CALL BOPT (PCOR,SYMM,MODE,IOPT,PMASK,PCORM,XRAY,CDNAME,NCON,
     X      CVAR)
C         WRITE (10, 501)  'Title is: ',CDNAME
C         WRITE (6, 501)  'Title is: ',CDNAME
501     format(5a)
 
C      read(2,5)symm
C      READ(2,*)NREF,NCON,cvar,nsam,nlow,pcor,expand
  140    FORMAT(6I6,1X,A20)
  141    FORMAT(A)
 
         WTSON = .FALSE.
 
C      WRITE(10,27)NREF
C      WRITE(6,27)NREF
   27    FORMAT(/'NUMBER OF REFLECTIONS IS ',I5/)
 
         CENTRO = .FALSE.
C      printf=.true.
         ACONV = 90.D0 / ASIN (1.D0)
         IF (SYMM .EQ. 'p3mt') SYMM = 'p6mm'
C         IF (PRINTF) WRITE (10, 48)
C         IF (PRINTF) WRITE (6, 48)
   48    FORMAT('Input Data:'/,'    H    K    L    FHK        Angle')
C  Do an unformatted read of the data
         I0 = (-1)
         NREF = 0
         DO   I=1,9999
           EWTS(I) = 1.
           READ (2, *, END=1777, ERR=1777) IH(I), K(I), L(I), FHK(I),
     X        AIN(I)
           NREF = NREF + 1
           IF (IH(I) .EQ. 0 .AND. K(I) .EQ. 0) I0 = I
           AHK(I) = AIN(I)
C           IF (PRINTF) WRITE (10, 49) IH(I), K(I), L(I), FHK(I), AHK(I)
C           IF (PRINTF) WRITE (6, 49) IH(I), K(I), L(I), FHK(I), AHK(I)
           AHK(I) = AHK(I) / ACONV
         END DO
 1777    IF (I0 .LT. 0) THEN
           I0 = NREF + 1
           NREF = NREF + 1
           IH(NREF) = 0
           K(NREF) = 0
           L(NREF) = 0
           FHK(NREF) = 1.
           AIN(NREF) = 360.
           AHK(NREF) = 360.D0 / ACONV
         END IF
   49    FORMAT(3I5,9F11.5)
C     For p3 cases, reduce h,k
         IF (SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6') THEN
           DO   J=1,NREF
             KLOW = 9999
             INDD = 1
             CALL EQUIV2 (HE,KE,ISE,IH(J),K(J),NE,SYMM)
             DO   JJ=1,NE
               IF (ISE(JJ) .GT. 0) THEN
                 IF (ABS (KE(JJ)) .LT. KLOW) THEN
                   KLOW = ABS (KE(JJ))
                   INDD = JJ
                 ELSE IF (ABS (KE(JJ)) .EQ. KLOW) THEN
                   IF (HE(JJ) .GT. HE(INDD)) INDD = JJ
                 END IF
               END IF
             END DO
             IH(J) = HE(INDD)
             K(J) = KE(INDD)
           END DO
         END IF

C 
	do N=1,natom
c	Loop over atoms, generating single-atom potential
	do j=1,nref
		p(j)=0
	enddo
c
        CALL potatom(P,IH,K,L,NREF,N,F0,xray)
C
	name=sfacts(n)
	write(6,990)'Writing Semper readable file for type ',name
 	write(10,990)'Writing Semper readable file for type ',name
 	write(10,990)'   H   K   L      F '
990	format(2a) 	
	p(i0)=f0
	aang=4.d0*asin(1.d0)
        if(n.eq.1)cor=1000./f0
	do j=1,nref
		fhk(j)=p(j)*cor
		ahk(j)=aang
		write(10,991)ih(j),k(j),l(j),fhk(j)
991		format(3i4,f12.7)		
	enddo
C     Output the image
	 NPAD=NREF
         CALL EONE2D (VV,F,IH,K,FHK,AHK,NREF,SYMM,CDNAME,NAME)
         enddo
         STOP
       END
 
 
