/*
 * ts_scan.h
 *  (mbutl)
 */
/*
void mb_thickness_scan( FILE *fi, char *infile );
void mb_shift_scan( FILE *fi, char *infile );
  */

void read_int_file(FIT_EXP_INTSET *ei, char *intfile);
void read_hg_shift_weight_file(
  int num_reflex_preset, char *HGshift_wt_file,
  double *H_shift, double *G_shift, double *g_weight
  );
void read_hg_shift_file(
  int num_reflex_preset, char *HGshift_wt_file,
  double *H_shift, double *G_shift
  );
void read_sim_data(
  SIM_RES *sr, char *simfile, double Hshift_SIM, double Gshift_SIM
  );
void free_sr(SIM_RES *sr);
double eval_gof(
  FIT_EXP_INTSET *ei, double scale, int num_reflex_preset, double *g_weight
  );
double eval_scale_factor(
  FIT_EXP_INTSET *ei, int num_reflex_preset, double *g_weight
 );

void set_calint_to_ei(
  FIT_EXP_INTSET *ei, SIM_RES *sr
  );
void set_calint_to_ei_shift(
  FIT_EXP_INTSET *ei, SIM_RES *sr,
  int num_reflex, double *H_shift, double *G_shift
  );

void set_calint_to_ei_shiftscan(
  FIT_EXP_INTSET *ei, SIM_RES *sr,
  int num_shiftscan_x, double shiftscan_x_begin, double shiftscan_x_end,
  int num_shiftscan_y, double shiftscan_y_begin, double shiftscan_y_end,
  int num_g, double *Hshift_opt, double *Gshift_opt,
   double *Scale_opt, double *gof_reflex, int *success_flag
  );

void shiftscan_res_output(
  char *shift_outfile, int num_reflex, double thickness, 
  double *Hshift_opt, double *Gshift_opt, HKL *g_reflex,
  double *gof_reflex, int *success_flag,
  double total_gof_shift, double total_scale_factor_shift
  );
