#ifndef __TAmplitudePage_H
#define __TAmplitudePage_H

#include "TPage.h"

class TAmplitudePage : public TPage { 
	public:
		TAmplitudePage(TWindow *window = nil) ;
		~TAmplitudePage() ;
		void	Draw() ;
		void	DoMouseDownInObject(TObject *obj,Point *pt) ;

	private:

		void			PlotBeams() ;
		void			PrintBeams() ;
		TRadioButton	*mPlotAmplitude ;
		TRadioButton	*mPlotIntensity ;
		TRadioButton	*mSuperImposeBeams ;
		TRadioButton	*mIndividualBeams;
		TCheckBox		*mPlotPhases ;

		TButton			*mHelp ;

		TButton			*mOK ;
		TButton			*mCancel ;

		TCheckBox		*mBeams[10] ;

		char	mTitle[80] ;
		float	mA,mB,mC ;
		long		mN,mM ;
		float	mVolt ;
		long		mNumBeamsStored ;
		long		mNumSlices ;
		long		mNumBeamsToPlot ;
		float	mSliceThickness ;
		float	mGMax ;

		float	*mZplot ;

		long 	mHStored[10],mKStored[10],mLStored[10] ; 
		long 	mHPlot[10],mKPlot[10],mLPlot[10] ;
		long 	INTENSITY,IMANY,PLOTPHS ;
		

} ;


#endif // __TAmplitudePage_H

