#ifndef __TDialog_h
#define __TDialog_h

typedef enum {kDialogCancel, kDialogOK, kDialogNO } DialogReturnCode ;
#include "TPage.h"

void	DisplayMessage(char *text) ;
class	TDialog : public TPage {
	public:
		TDialog(short xloc,short yloc,short width,short height) ;
		~TDialog() ;

		virtual	void	SetDialogData(void *data) {} ;
		virtual	void	GetDialogData(void *data) {} ;

		virtual	void	DefineDialog() {} ;
		void			Show() ;

		virtual	void	Draw() ;
		virtual	void	DoUpdate(XEvent *) ;
		virtual	DialogReturnCode		DoModalDialog() ;

		void	SetCancelButton(TObject *obj) { mCancelButton = obj ; } ;
		void	SetOKButton(TObject *obj) { mOKButton = obj ; } ;
		void	SetDefaultButton(TObject *obj) { mDefaultButton = obj ; } ;

		virtual	void	DoEvent(XEvent *) ;
		virtual	void	DoMouseDown(XEvent *) ;
		virtual	void	DoMouseDownInObject(TObject *,Point *);

	protected:
		TObject		*mOKButton ;
		TObject		*mCancelButton ;
		TObject		*mDefaultButton ;
		DialogReturnCode	mDialogReturnCode ;
} ;

class	TMessageDialog : public TDialog {
	public:
		TMessageDialog(short xloc,short yloc,short width,short height,char *text) ;
		TMessageDialog(char *text) ;
		void	DefineDialog() ;
} ;

class	TCancelOKDialog : public TDialog {
	public:
		TCancelOKDialog(short xloc,short yloc,short width,short height,char *text) ;
		TCancelOKDialog(char *text) ;
} ;

#endif // __TDialog_h

