#ifndef __ATOM__
#define __ATOM__
#define MAXATOMS	5000
#define MAXTYPES	100
typedef struct {
       struct {
              union {
                     long iv ;
                     float fv ;
                     char *cv ;
              } val ;
              long xl ;
              long yl ;
              long xh ;
              long yh ;
       } type, name, no,occ, xc, yc, zc, dw ;
} AtomRec,*AtomRecPtr ;
#ifdef __MAIN__
long	gMaxAtoms = MAXATOMS ;
AtomRecPtr atom,basis ;
float covrad[] = {
		.32,.93,1.23,.9,.82,.77,.75,.73,.72,.71,
     		1.54,1.36,1.18,1.11,1.06,1.02,.99,.98,
     		2.03,1.74,1.44,1.32,1.22,1.18,1.17,1.17,1.16,
     		1.15,1.17,1.25,1.26,1.22,1.20,1.16,1.14,1.12,
     		2.16,1.91,1.62,1.45,1.34,1.3,1.27,1.25,1.25,
     		1.28,1.34,1.48,1.44,1.41,1.4,1.36,1.33,1.31,
     		2.35,1.98,1.69,
     		1.65,1.65,1.64,1.63,1.62,1.85,1.61,1.59,1.59,
     		1.58,1.57,1.56,1.56,1.56,
     		1.44,1.34,1.30,1.28,1.26,1.27,1.30,
     		1.34,1.49,1.48,1.47,1.46,1.46,1.45,1.5,
     		2.55,2.1,1.65,1.65,1.5,1.42,1.5,1.5,1.5,1.5,1.5,
		1.5,1.5,1.5} ;
#else
extern long gMaxAtoms ;
extern AtomRecPtr atom,basis ;
extern float covrad[] ;
#endif
#endif /* __ATOM__ */

