// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#ifdef VMS
#include <decw$include/Xlib.h>
#include <decw$include/Xutil.h>
#include <decw$include/cursorfont.h>
#else
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#endif
void change_cursor() ;
void reset_cursor() ;
#include "globals.h"
Cursor	gCrossHair = (Cursor)0 ;
void change_cursor() {
    if (gCrossHair == (Cursor)0) {
    	gCrossHair = XCreateFontCursor(gDisplay,XC_crosshair) ;
    }
    XDefineCursor(gDisplay,gCurrentPort->GetDrawable(),gCrossHair) ;
}
void reset_cursor() {
    XUndefineCursor(gDisplay,gCurrentPort->GetDrawable()) ;
}
