// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
// --------------------------------------------------------------------------
// This routine is never called. It was intended to be used in case 
// the program is changed to pick up an experimental image.	 
// --------------------------------------------------------------------------
#include "funcdefs.h"
#include "ProjCellRecord.h"
#include "PhasegratingRecord.h"
#include "storage.h"
#include "files.h"
#include "filenames.h"
#include "errors.h"
extern struct { long ipot,icmplx ; } flag ;
void getxim(long *np,long *mp) {
    long jmax,ierr ;
	
    if (gPhsgrtRec->nbeam == 0.) {
	SetProjectedCell(&ierr) ;
	SetCalculationDimensions(&gProjCell->a,&gProjCell->b,&gPhsgrtRec->gmax,&gPhsgrtRec->nbeam,
        	&gPhsgrtRec->mbeam) ;
    }
    *np = gPhsgrtRec->nbeam ;
    *mp = gPhsgrtRec->mbeam ;
    jmax = *np*(*mp) ;
    flag.ipot = 0 ;
    flag.icmplx = 0 ;
	
    /* ------------ Space to read in the experimental image ----------- */
	
  }
