// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "header.h"
#include "symops.h"
#include "funcdefs.h"
void read_symop(long i) ;
// --------------------------------------------------------------------------
// Routine to read the symmetry operator from the terminal
// --------------------------------------------------------------------------
void read_symop(long i) {
    long j ;
    char c,sfield[32],*cp,*sp ;

    ReadString(sfield,32) ;
    if (strlen(sfield) != 0) {
        // Throw away blanks in the i/o buffer 
        sp = symop_txt[i] ;
        cp = sfield ;
        for (sp=symop_txt[i],cp=sfield;(c = *cp) != EOS;cp++) {
            if (c != BLANK) *sp++ = c ;
        }
        *sp = EOS ;
    }
    else {
    	strcpy(symop_txt[i],"x,y,z") ;
    }
    txtptr_symop[i] = &symop_txt[i][0] ;
}
