// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "menudef.h"
#include "devices.h"
#include "globals.h"
void set_video_normal() ;
void set_video_reverse() ;
void set_video_off() ;
void SetFgColor(unsigned long) ;
void SetBkColor(unsigned long) ;

// ---------------------------------------------------------------------
// Switch to normal video
// ---------------------------------------------------------------------
void set_video_normal() {

    SetFgColor(gBlackPixel) ;
    SetBkColor(gGrayPixel) ;
    XSetFunction(gDisplay,gControlWindow->GetGC(),GXcopy) ;
}

// ---------------------------------------------------------------------
// Switch to reverse video
// ---------------------------------------------------------------------
void set_video_reverse() {
    /* For now we will use an empty statement here */
    /* 
    SetFgColor(gWhitePixel) ;
    SetBkColor(gBlackPixel) ;
    XSetFunction(gDisplay,gControlWindow->GetGC(),GXcopy) ;
    */
    /* XSetFunction(gDisplay,gControlWindow->GetGC(),GXinvert) ; */
}

// ---------------------------------------------------------------------
// Write in erase mode 
// ---------------------------------------------------------------------
void set_video_off() {
    uLong GetBkColor() ;
    SetFgColor(GetBkColor()) ;
}
