#ifndef __FUNCDEFS__
#define __FUNCDEFS__
#include <stdio.h>
#include "types.h"
#include "menudef.h"
#include "atoms.h"
#include "layers.h"

#include "XDrivers.h"

void enableast() ;
void cntrlctrap() ;
int abandn() ;
void AdjustGamma(int *np,int *mp,int nx,int ny);
void AdjustSampling(int *np,int *mp,int nx,int ny) ;
void PlotAmplitudes() ;
void set_refl(int i) ;
void set_ampl() ;
void set_int() ;
void set_many() ;
void set_one();
void set_phs() ;
void ApplySymmetries() ;
void atom3d() ;
int atomno(char *cp) ;
void ball3d(short *atma,short *atmb,short *atmc,short *atmr,int natom) ;
void FUpdateRect(int x1,int y1,int x2,int y2) ;
void boks(int xl,int yl,int xh,int yh) ;
void construct() ;
void draw_screen() ;
void erase_window() ;
void erase_cnstrct_menu() ;
void erase_cmnd_line() ;
void ret_cnstrct();
void action1() ;
void add_x_unit_cells() ;
void add_y_unit_cells() ;
void dis_new_cell() ;
void celext(int *np,int *mp,int nx,int ny,short *ierr);
void cfft(int *np,int *mp) ;
void cfftinv(int *np,int *mp) ;
void change_cursor() ;
void reset_cursor() ;
void change_par() ;
void close_ps_file() ;
void close_semper_file() ;
void clr_display() ; 
void condense(float *array,int length) ;
void r_insert_col() ;
void r_remove_col() ;
void r_move_col() ;
void r_change_col() ;
void get_atom_position(float *x_coord,float *y_coord) ;
void get_atom_index(float x_coord,float y_coord,int *index) ;
void set_toleranse() ;
void check_button_1() ;
void displ_pick_atom(int atoms_at_site,int *index_array) ;
void r_adj_cntrst() ;
void lbl_brite_bar(int xl,int yl,int xh,int yh) ;
void lbl_contr_bar(int xl,int yl,int xh,int yh) ;
void draw_brite_bar(int xl,int yl,int xh,int yh);
void draw_contr_bar(int xl,int yl,int xh,int yh) ;
void draw_cntrst_curve() ;
void plot_cntrst(int xo,int yo,int xm,int ym) ;
void modify_cntrst(int i) ;
void cp_abs(int ix,int iy) ;
void cpage() ;
void create_file() ;
void ctfplot() ;
void dcl(char *input_command) ;
int get_spcgrp_number() ;
int get_event() ;
void assm_spcgrp(int spcgrp_number) ;
void generate_spcgrp(char  *spacegroup) ;
void encode_symop(char *string,struct GENERATOR *sym_op) ;
void apply_gen(struct GENERATOR *oper,struct GENERATOR *source,struct GENERATOR *dest) ;
int ident(struct GENERATOR *p_sym) ;
int new_symop(struct GENERATOR *p_symop,int num_symop) ;
void decode_spcgrp(char *string,int *pnum_gen,int *pinversion) ;
void get_inverse(struct GENERATOR *source,struct GENERATOR *dest) ;
void decode_gen(int rot,int trnsl,struct GENERATOR *sym_op) ;
void decode_symop(int j) ;
void diffr(int *np,int *mp) ;
void dispfft(int *pnp,int *pmp) ;
void displ_hist(int *np,int *mp) ;
void displ_menu() ;
void erase_self() ;
void erase_remain_menu() ;
void displ_msg(int i) ;
void displ_var() ;
void display(COMMAND *item) ;
void DrawControl(COMMAND *control) ;
void r_sngle_structure(char *structname,char *status) ;
void r_lay_structure(char *structname,char *status) ;
void r_display() ;
void r_ret8() ;
void r_dispfft(int *np,int *mp) ;
void r_dsply() ;
void dsply(int *np,int *mp) ;
void r_cancel() ;
void r_exe() ;
void SetCustomMontageSequence() ;
void DoAdvertise() ;
void dis_at() ;
void r_ret5() ;
void cel_persp()  ;
void cel_nopersp() ;
void vu_std_cell() ;
void vu_new_cell() ;
void nucel_persp() ;
void nucel_nopersp() ;
void r_atom3d() ;
void draw_circle(int x,int y,int rad) ;
void gDrawPixel(int x,int y) ;
void gDrawLine(int x1,int y1,int x2,int y2) ;
void gMoveTo(int ix,int iy) ;
void gDrawChar(int x,int y,char c) ;
void gDrawCircle(int x,int y,int rad) ;
void gSetFgColor(int value) ;
void gFillCircle(int x,int y,int rad) ;
void gDrawRect(int xlow,int ylow,int xhi,int yhi) ;
void gDrawText(int x,int y,char *text) ;
void gDrawImageLine(int x,int y,int n,unsigned char *imageline) ;
int gReadImageLine(int x,int y,int n,unsigned char *imageline) ;
int gDrawImage(unsigned char *image,int x,int y,int width,int height) ;
int gReadImage(char *image,int x,int y,int width,int height) ;
void LandScape() ;
void echo_char(int x,int y,char c) ;
void erase_message() ;
void err(int i) ;
void err_disp(int i) ;
void err_seq(int i) ;
void err_io(int i) ;
void err_io_ds(int i) ;
void ExitX() ;
void fb_crt_toggle() ;
void fb_crt_erase() ;
void fb_crt_ergra() ;
void fb_crt_erim() ;
void fb_crt_store_image() ;
void fb_crt_display() ;
void fb_crt_laser() ;
void fb_crt_mod_lut() ;
void fb_crt_wr_txt() ;
void fb_crt_displ(char *out,int *np,int *mp,int *ixp,int *iyp) ;
void fb_crt_dir() ;
void set_chann_1() ;
void set_chann_2() ;
void fb_crt_index() ;
void r_stemdxw() ;
void fb_crt_screen() ;
void set_min_int() ;
void ret_switch() ;
void set_erase() ;
void set_noerase() ;
void set_montage() ;
void set_nomontage() ;
void set_req_pos() ;
void set_noreq_pos() ;
void erase_screen() ;
void set_camera_length() ;
void set_min_fft_int() ;
void set_abs_scale() ;
void set_auto_scale() ;
void set_mont_space() ;
void set_nomont_space() ;
void set_ctf_autoscale() ;
void set_ctf_absscale() ;
void set_pseudo_slice() ;
void set_ull_slice() ;
void set_titles() ;
void set_notitles() ;
void set_aperture() ;
void set_noaperture() ;
void set_diffpt_cntr() ;
void set_laswrit_cntrst() ;
void set_elfactors() ;
void set_xrayfactors() ;
void set_recipspace() ;
void set_realspace() ;
void SetNoOverLayAtoms() ;
void SetOverLayAtoms() ;
void set_dp_theta() ;
void set_ampl_absscale() ;
void set_ampl_autoscale() ;
void SetDisplayValues() ;
void SetPrintValues() ;
void SetSubPhase() ;
void SetNoSubPhase() ;
void SetAsciiFile() ;
void SetBinaryFile() ;
void SetPrintToFile() ;
void SetPrintToPrinter() ;
void SetNormalMontage() ;
void SetCustomMontage() ;
void set_halftone() ;
void set_solid() ;
void CalculateProjectedPotential(float *zvg,int *noz,int jmax) ;
void AtomicFormFactor(float usq,int *noz,int j,int ino,float *elfrmf) ;
void fft2d(float *data,int n,int m,int isign) ;
void fft1d(float *data,float *table,int m,int inc) ;
void binrev(float *c,int m,int inc) ;
void r_sngl_layered(int i) ;
void r_old_fl() ;
void set_file(int i) ;
void copy_files(char *whichFile) ;
void r_fl_exit() ;
void displ_files() ;
void r_exit() ;
void r_prev_page() ;
void r_next_page() ;
void r_new_fl() ;
void r_loc_fls() ;
void r_com_fls() ;
void r_lay_fls() ;
void r_scan_structure(char *structname) ;
void r_use_file() ;
void r_nouse_file() ;
void read_fls(int k) ;
void ScanDirectory(char *filename) ;
void fill_area(int xlow,int ylow,int xhi,int yhi) ;
void fill_circle(int x,int y,int rad,int intens) ;
void get_atoms() ;
void get_atoms() ;
int get_char_size() ;
void get_microscopes() ;
float get_float(float defaultValue) ;
int get_int(int defaultValue) ;
char * GetNumber() ;
void EchoChar(char c) ;
int ReadString(char *buffer,int numChar) ;
char *get_snumber() ;
void r_diff() ;
void r_exwf() ;
void r_image() ;
void r_pot() ;
void get_symop() ;
void get_ttfs(char *buffer,float *low_value,float *high_value,float *increment) ;
void getim(int *np,int *mp) ;
void getpot(int *np,int *mp) ;
void GetXEvents() ;
void DoMouseDown(XEvent *event) ;
void ChangeWindowSize(XConfigureRequestEvent *eventP) ;
void getxim(int *np,int *mp) ;
void getxwf(int *np,int *mp) ;
void set_ctm(float size,float angle) ;
void hafton(int *np,int *mp) ;
void ws_image(char *out,int nmax,int mmax) ;
void OverLayAtoms(int xlow,int ylow,int width,int height) ;
void histog(int *np,int *mp) ;
void r_hist() ;
void histeq_c(int *np,int *mp) ;
void r_histeq() ;
void set_ohkl_nhkl(float r[3][3]) ;
void CalculateImages(int *nobeam,float *sum,float *range,int *ierr) ;
void SetLensParameters(float *cs1,float *div1,float *cs,float *div,float *gmax,
		int *nbeam,int *mbeam,int *nz) ;
void SetImageIntensities(float *out,int jmax) ;
void ScaleImageIntensities(int *pnp,int *pmp,float *prange,int *ierr) ;
void contrst(int *pnp,int *pmp,float *pcntrst,float *prange,float *pbrite) ;
void histeq(int *pnp,int *pmp) ;
void ApplyObjectiveLens(float *zphi,float *ihk,float cs,float theta,int nbeam,int mbeam,
	int jmax,int *nobeam,int *num_beam,float *sum,float *wrkspc,int maxRefl) ;
void trfunc(float h1,float k1,float h2,float k2,float u1sq,float u2sq,
	float astsq,float bstsq,float abga,float *xcoeff) ;
int in_zone(int i,int ij,int ik,int izone[3]) ;
void r_v_comp() ;
void SetSequence() ;
void r_deposit() ;
void r_insert() ;
void r_repeat() ;
void r_reset() ;
void r_def_layer() ;
void r_del_layer() ;
void displ_lay() ;
void displ_spec() ;
void r_ret_lay() ;
void mod_pg(int num) ;
void rem_pg(int i) ;
void do_repeat() ;
void do_reset() ;
void mmfft(float *data,int n,int m,float *rtime) ;
void mmffti(float *data,int n,int m,float *rtime) ;
void mod_atom(int i) ;
void modify_par(int i) ;
void DoMultisliceCalculation() ;
void SetMsliceParameters() ;
void PrintMsliceOutput() ;
void StoreAmplitudes() ;
void CalculatePropagator(float *zprop,float dz) ;
void CalculateExitWavefunction(float *zphi,float *zphsgr,float *zprop,int jmax) ;
void ApplyPhasegrating(float *zphi,float *zphsgr,int jmax) ;
void ApplyPropagator(float *zphi,float *zprop,int n,int m,int jmax,short iamp,int islice) ;
void SetPhasegrating(float *rphsgr,float slcth,float sigma,int jmax) ;
void newhkl(short ioldh,short ioldk,short ioldl,int *inewh,int *inewk,int *inewl) ;
void SetPendellosungData(float *zphi,int n,int m,int i) ;
int near(float x) ;
void CalculateProjectedCell(float *av,float *bv,float *cv,int ihkl[][3],float *gsq,
	int ic,float rm[3][3],int *inx,int *iny,int *inz) ;
void rotmat(float *v1,float *v2,float *v3,float rm[3][3]) ;
int not_equiv(float x,float y,float z,int icount,int ndx) ;
void off_highlight() ;
void on_highlight() ;
void on_off(COMMAND *item) ;
FILE *open_ps_file(char *filename) ;
void open_semper_file(char *filename) ;
void packfb(float *data,int *n) ;
void pattern(int xlow,int ylow,int xhi,int yhi,int num) ;
void pgflnm(char *string1,char *string2) ;
void celexp(float *x0,float *y0,float *z0,short *iaz0,float *dw0,float *occ0,
	short *nt0,float *x,float *y,float *z,short *iaz,float *dw,float *occ,short *nt,
	int *natom,int *inx,int *iny,int *inz,float r[3][3]) ;
void CalculatePhasegrating(int *ierr) ;
void SetPhasegratingParameters(char name[MAXTYPES][8],int *noz) ;
void WritePhasegratingOutput(char name[MAXTYPES][8]) ;
void Find3DHKLIndicies(int ih,int ik,int il,int *jh,int *jk,int *jl,float r[3][3]) ;
void ViewOriginalUnitCell(float *rview,int *ierr) ;
void SetProjectedCell(int *ierr) ;
void SortAtoms(float *x,float *y,float *z,short *iz,float *dw,float *occ,short *ntype,int n) ;
void SortGVectors(float *f,float *g,short *ihk,int n) ;
void SortAtomsOnZ(float *x,float *y,float *z,float *r,int *icolor,int n) ;
void ProjectedCellEqualsOriginal() ;
void ViewNewUnitCell() ;
void DrawNewUnitCell(float *rview,int *ierr) ;
void AddUnitCellAtoms(float x[][3],float *x0,float *y0,float *z0,short *iz0,
	int num_atoms,int *nview_atoms) ;
void TranslateIntoUnitCell(float *x,float *y,float *z,int natom) ;
void TransformAtomCoordinates(float *x,float *y,float *z,int n,float r[3][3]) ;
void SetOriginalUnitCellParameters(int *ierr) ;
void SortHKLVectors(int ihkl[][3],float *gsq,int n) ;
void CrossProduct(float *v1,float *v2,float vol,float *v3) ;
void DotProduct(float *v1,float *v2,float a,float b,float c,
	float csa,float csb,float csg,float *dot) ;
void SetHKLTransformationMatrix(float *v1,float *v2,float *v3,float r[3][3]) ;
void SetPerpendicularReflections(int ihkl[][3],float *gsq,int *ic,int *iuvw) ;
void SetCoordinateTransformationMatrix(float *ruvw,float siang,float csang,float a,float b,float c,
	float sial,float sibe,float siga,float csal,float csbe,float csga,float r[3][3]) ;
void TransfVectorToProjectedCell(float *x,float *xtr,float r[3][3]) ;
void pr_help_msg(COMMAND *item) ;
void r_remove() ;
void rd_image(unsigned char *image,int order,int *ierror) ;
int read_file(FILE *fp) ;
void read_symop(int i) ;
int requested(FPV function) ;
void r_ret6() ;
void r_ret7() ;
void rewrite_file(char *fl_name) ;
void run_ampli() ;
void run_ctfplot() ;
void run_dcl() ;
void r_expim() ;
void r_fft() ;
void r_filter() ;
void filter(int *np,int *mp) ;
void run_prog() ;
void run_p_pg() ;
void run_phsgrt() ;
void run_mslice() ;
void run_p_im() ;
void run_image() ;
void ReportFileOpenError(char *filename) ;
void run_shell() ;
void dcl(char *input_command) ;
void r_add_unit_cells() ;
void add_unit_cells(int *np,int *mp) ;
void r_zoom() ;
void zoom_c(int *np,int *mp) ;
int semdat() ;
int semdet() ;
int semdro(float *a,int *i,int *j,int *k,int *mode,int *ix1,
	int *iy1,float *bot,float *top) ;
int semdri(float *a,int *j,int *mode,int *ix,int *iy,float *bot,
	float *top) ;
int semdln(int *ix1,int *iy1,int *ix2,int *iy2) ;
int semfil(int *ix1,int *iy1,int *ix2,int *iy2) ;
int sempat() ;
int semdtx(int *itext,int *nchar,int *ix,int *iy) ;
int semdxw(int *ix1,int *iy1) ;
int semder(int *opcode) ;
int semdfl() ;
void keys() ;
void semdvc() ;
void semdpt(int *,int *) ;
void keys() ;
void semdvc() ;
void semdpt(int *,int *) ;
void send_ps_file() ;
void send_to_laser(char *out,int ncol,int nrow) ;
void set_blkwht(int xo,int yo,int xm,int ym) ;
void set_char_size(int size) ;
void set_menu(int number) ;
int set_microscope(char *string) ;
void set_nz() ;
void set_video_normal() ;
void set_video_reverse() ;
void set_video_off() ;
void SetCalculationState() ;
void SetCalculationDimensions(float *pa,float *pb,float *pgmax,int *pn,int *pm) ;
void setup_trnsf() ;
void chng_at() ;
void chng_so() ;
void mod_symop(int i) ;
void show_at() ;
void show_symop() ;
void show_basis() ;
void fw_at();
void fw_so() ;
void rw_at() ;
void r_page() ;
void rw_so() ;
void add_so() ;
void add_symop() ;
void del_at() ;
void del_so() ;
void ret_at() ;
void ret_so() ;
void ret_basis() ;
void del_atom() ;
void del_symop() ;
void displ_atoms(AtomRecPtr unit) ;
void displ_symop() ;
void add_atom() ;
void add_at() ;
void sort(AtomRecPtr unit,int n) ;
void sound_bell() ;
void cell3c(float *av,float *bv,float *cv) ;
void DrawAtoms(float *xp,float *yp,float *zp,float *r,
	int *icolor,int number) ;
void DrawAtomCircles(short *ix,short *iy,short *iz,short *ir,
	int *ic,int n) ;
void stemdln(int x1,int y1,int x2,int y2) ;
void stemdpt(int x1,int y1) ;
void stemdro(char *a,int *i,int *j,int *k,int *mode,int *ix,
	int *iy,float *bot,float *top) ;
void stemdri(char *a,int *j,int *mode,int *ix,int *iy,
	float *bot,float *top) ;
void stemder(int *opcode) ;
void stemdxw(int *x,int *y) ;
void stemfil(int x1,int y1,int x2,int y2) ;
void stemdtx(int *x,int *y,int *itext,int *len) ;

void switch_display(int iswitch) ;
void switch_on(COMMAND *item) ;
void r_terminal() ;
void r_lp() ;
void r_semper() ;
int temdxw(int *px,int *py) ;
void temdln(int x1,int y1,int x2,int y2) ;
void temdpt(int x1,int y1) ;
void temdtx(int x,int y,char *text) ;
void temfil(int xlow,int ylow,int xhi,int yhi) ;
void temdro(char *buffer,int *i,int *j,int *k,int *mode,
	int *ix,int *iy,float *bot,float *top) ;
void temdri(char *a,int *j,int *mode,int *ix,int *iy,
	float *bot,float *top) ;
void temder() ;
void titles(int *np,int icx,int iy) ;
int types(AtomRecPtr unit,int natom) ;
void open_semper_file() ;
void qiow() ;
void terminateNcemss() ;
void r_upd() ;
void r_no_upd() ;
void r_upd_rename() ;
void view_o_file()  ;
void view_outfile(FILE *filep) ;
void write_message(char *text) ;
void write_par(int i) ;
void write_postscript_file(char *postscript_file,char *out,
	int *ncol,int *nrow) ;
void wrt_image(unsigned char *image,int *ierror) ;
void eraser(int,int,int,int) ;
void DrawPixel(int x,int y) ;
void DrawLine(int x1,int y1,int x2,int y2) ;
void MoveTo(int ix,int iy) ;
void DrawString(char *text) ;
void DrawChar(int x,int y,char c) ;
void DrawRect(int xlow,int ylow,int xhi,int yhi) ;
void DrawText(int x,int y,char *text) ;
void DrawImageLine(int x,int y,int n,char *imageline) ;
void RDrawRect(Rect *tRect) ;
void FrameRect(Rect *tRect) ;
void FillRect(Rect *tRect) ;
void EraseRect(Rect *tRect) ;
void EraseCircle(short x,short y,short rad) ;
void ClearDisplay() ;
void GetPort(GrafPtr *port) ;
void SetPort(GrafPtr port) ;
void SetRect(Rect *tRect,short x1,short y1,short x2,short y2) ;
Boolean PtInRect(Point *pt,Rect *tRect) ;
void OffsetRect(Rect *tRect,short x,short y) ;
void InsetRect(Rect *tRect,short x,short y) ;
void DrawCircle(short x,short y,short rad) ;
void FillCircle(short x,short y,short rad) ;
unsigned long GetFgColor() ;
unsigned long GetBkColor() ;
void SetFgColor(unsigned long value) ;
void SetBkColor(unsigned long value) ;
void TextSize(short size) ;
void TextFace(short face) ;
void PenSize(short width,short height) ;
void PenNormal() ;
void SetWatchCursor() ;
void InitCursor() ;
void SetTrackingMode() ;
void UnSetTrackingMode() ;
Boolean Button() ;
void GetMouse(Point *where) ;
int StringWidth(char *text) ;
void UnionRect(Rect *srcRect1,Rect *srcRect2,Rect *destRect) ;
Boolean RectISectRect(Rect *aRect,Rect *bRect) ;
void ClipImage(int *np,int *mp,int *nmax,int *mmax) ;
void ZoomImage(int *np,int *mp,float zoom_fact,short *ierr) ;
void UpdateWindow(XEvent *event) ;
void UpdateFromOffscreen(GrafPtr dest,GrafPtr source) ;
void UpdateFromOffScreenRect(GrafPtr dest,GrafPtr source,Rect *tRect) ;
void UpdateScreen() ;
void UpdateImageScreen() ;
void DrawCommandLine() ;
void SetOffscreenPort(OffScreenPtr portPtr) ;
void UnSetOffscreenPort(OffScreenPtr portPtr) ;
void CopyBits(GrafPtr source,GrafPtr dest,Rect *srcRect,Rect *dstRect,
	CopyMode mode = srcCopy) ;
void UnHighlightControl(COMMAND *control) ;
void HighlightControl(COMMAND *control) ;
MENUS	GetFirstMenuItem() ;
void	SetMenu(int theMenuID) ;
void	SetFirstMenuItem(MENUS *menuitemlistPtr) ;
void	DisplayMenu() ;
int	GetCurrentMenu();
void	PutMessage(char *) ;
void 	EnableControl(COMMAND *control) ;
void 	DisableControl(COMMAND *control) ;
void	ActivateButton(FL_OBJECT *button) ;
void	DeactivateButton(FL_OBJECT *button) ;

#endif