#ifndef __GRAPHICS__
#define __GRAPHICS__
void set_ctm(float size,float angle) ;
void ctm(int *x,int *y) ;
void eushft(char symbol) ;
void instrct(char symbol) ;
void decode_instruction(char *(*cp),int *y_offset,float old_size,float *new_size) ;
void messag(float x_ndc,float y_ndc,float size,float angle,char *text) ;
void write_legend(float x_ndc,float y_ndc,float size,float angle,char *text) ;
void physor(float xo,float yo) ;
void area2d(float xlength,float ylength) ;
void line(float x1,float y1,float x2,float y2) ;
void set_world(float xmin,float xmax,float ymin,float ymax) ;
void set_window(float xmin,float xmax,float ymin,float ymax) ;
void set_viewport(float xmin,float xmax,float ymin,float ymax) ;
void frame() ;
void axes() ;
void move_abs(float x_world,float y_world) ;
void line_abs(float x1,float y1,float x2,float y2) ;
float x_wrld_ndc(float x_world) ;
float y_wrld_ndc(float y_world) ;
void label(float xloc,float yloc,float value,int iaxis) ;
void graph2d(float xmin,float xmax,float ymin,float ymax) ;
void set_mapping() ;
void move_ndc(float x_ndc,float y_ndc) ;
void line_ndc(float x1,float y1,float x2,float y2) ;
int x_ndc_pdc(float x) ;
int y_ndc_pdc(float y) ;
void move_pdc(int ix,int iy) ;
void line_pdc(int ix1,int iy1,int ix2,int iy2) ;
void xname(char *cp,float size) ;
void yname(char *cp,float size) ;
void headin(char *cp,float size) ;
void ticks_x(float xmin,float xmax) ;
void ticks_y(float ymin,float ymax) ;
void curve(float *x,float *y,int pn,int marker_interval) ;
void marker(char cp) ;
void SetLineStyle(int style) ;
int GetLineStyle() ;
void SetLineWidth(int width) ;
short GetLineWidth() ;
void erase_pdc(int ix1,int iy1,int ix2,int iy2) ;
void dash() ;
void dot_dash() ;
void solid() ;
void on_data() ;
void off_data() ;
void dot() ;
void thkcrv() ;
void nrmcrv() ;
#endif
