#ifndef __edmtyoes_h
#define __edmtyoes_h

#ifdef VMS
#include <decw$include/Xlib.h>
#include <decw$include/Xutil.h>
#else
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#endif

#include "ttypes.h"
typedef float 	Matrix[4][4] ;
typedef float 	Vector[4] ;
typedef int 	AtomList ; /* For now */
typedef float	*MtrxPt ;
typedef unsigned long	uLong ;
typedef unsigned long	ULong ;
typedef unsigned short	Boolean	;

#define	true	1
#define	false	0
#define	on	1
#define	off	0
#define	nil	0
#define ON	1
#define OFF	0

typedef struct RGBColor {
	unsigned short red ;
	unsigned short green ;
	unsigned short blue ;
} RGBColor ;
	
typedef struct {
	short x ;
	short y ;
} Point ;
typedef struct {
	float x ;
	float y ;
} FPoint ;

typedef struct {
	short h ;
	short v ;
	short d ;
} Point3D ;

typedef struct {
	float h ;
	float v ;
	float d ;
} FPoint3D ;

typedef	Region	RgnHandle ;
typedef void	*Handle ;

#ifndef __FPI__
	#define __FPI__
	typedef int (*FPI)() ;
#endif
#ifndef __FPV__
	#define __FPV__
	typedef void (*FPV)() ;
#endif
#ifndef __FPVI__
	#define __FPVI__
	typedef void (*FPVI)(int arg) ;
#endif
#ifndef __FPVII__
	#define __FPVII__
	typedef void (*FPVII)(long arg1,long arg2) ;
#endif

#endif
