        subroutine GetConstraints(sfacts,ntypes)
        CHARACTER*80 LINE
        logical robnod,rob_fit,dwref,robfm,nodd5
        common /fscom55/robnod,rob_fit,dwref,robfm,nodd5
        character*4 mode,sfacts(*)
        integer AtomType
        logical isactive
        include 'newbonds.h'
        include 'Constraints.h'
        include 'STO111.h'
        NMAX=80
        bonding=.false.
        bumper=.false.
        chemon=.false.
        contents=.false.
        coords=.false.
        bondwt=1
        bumpwt=1
        coordwt=1
        chemwt=1
        contwt=1
        do j=1,ntypes
                ValAtoms(j)=0
                contmin(j)=0
                contmax(j)=999
                numcord(j)=0
                numbond(j)=999
                do k=1,ntypes
                     bumpa(j,k)=-0.1
                     bonda(j,k)=-0.1
                enddo
        enddo
C        write(77,*)'Init'
        open(unit=11,file='.constraints')
C        write(6,*)'Got to 1'
        ijunk=-1
C       Get a line
10       READ (11, 1, ERR=2000, END=2000) LINE
         call cleanline(line)
         mode = line(1:4)
         NI=4
C         write(6,*)'Got to 2'
C        if(ijunk.lt.0)return
        next = NFIELD(LINE,NI,NMAX)
         if(mode.eq.'BOND')then
C              write(77,*)'Bond'
              if(line(next:next+2).eq.'YES')then
                 READ (11, 1, ERR=2000, END=2000) LINE
                 bonding=isactive(line,iflag)
                 read(11,1,err=2000,end=2000) line
                 call cleanline(line)
                 read(line(7:80),*)bondwt
                 read(11,1,err=2000,end=2000) line
                 call cleanline(line)
                 read(line(7:80),*)number
                 do j=1,number
                    read(11,1,err=2000,end=2000) line
                    NI=1
                    I1=AtomType(line,NI,NMAX,sfacts,ntypes)
                    I2=AtomType(line,NI,NMAX,sfacts,ntypes)
                    read(line(ni:80),*)Bonda(I1,I2)
                    bonda(i2,i1)=bonda(i1,i2)
                 enddo
              endif

         else if(mode.eq.'BUMP')then
C              write(77,*)'BUMP'
              if(LINE(next:next+2).eq.'YES')then
                 READ (11, 1, ERR=2000, END=2000) LINE
                 bumper=isactive(line,iflag)
                 read(11,1,err=2000,end=2000) line
                 call cleanline(line)
                 read(line(7:80),*)bumpwt
                 read(11,1,err=2000,end=2000) line
                 call cleanline(line)
                 read(line(7:80),*)number
                 do j=1,number
                    read(11,1,err=2000,end=2000) line
                    NI=1
                    I1=AtomType(line,NI,NMAX,sfacts,ntypes)
                    I2=AtomType(line,NI,NMAX,sfacts,ntypes)
                    read(line(ni:80),*)Bumpa(I1,I2)
                    bumpa(i2,i1)=bumpa(i1,i2)
                 enddo
              endif
         else if(mode.eq.'STOC')then
C               write(77,*)'STOC'
               if(LINE(next:next+2).eq.'YES')then
                 READ (11, 1, ERR=2000, END=2000) LINE
                 chemon=isactive(line,iflag)
                 read(11,1,err=2000,end=2000) line
                 call cleanline(line)
                 read(line(7:80),*)chemwt
                 read(11,1,err=2000,end=2000) line
                 call cleanline(line)
                 read(line(5:80),*)BaseCharge
                 read(11,1,err=2000,end=2000) line
                 call cleanline(line)
                 read(line(7:80),*)number
                 do j=1,number
                    NI=1
                    read(11,1,err=2000,end=2000) line
                    IATOM=AtomType(line,NI,NMAX,sfacts,ntypes)
                    read(line(ni:80),*)ValAtoms(IATOM)
                 enddo
              endif

         else if(mode.eq.'COOR')then
C                write(77,*)'COOR'
                if(LINE(next:next+2).eq.'YES')then
                 READ (11, 1, ERR=2000, END=2000) LINE
                 overbond=isactive(line,iflag)
                 coord=overbond
                 read(11,1,err=2000,end=2000) line
                 call cleanline(line)
                 read(line(7:80),*)coordwt
                 read(11,1,err=2000,end=2000) line
                 call cleanline(line)
                 read(line(7:80),*)number
                 do j=1,number
                    NI=1
                    read(11,1,err=2000,end=2000) line
                    IATOM=AtomType(line,NI,NMAX,sfacts,ntypes)
                    read(line(ni:80),*)tmp
                    numbond(IATOM)=nint(tmp)
                 enddo
               endif
              
        else if(mode.eq.'CONT')then
C                write(77,*)'CONT'
                if(LINE(next:next+2).eq.'YES')then
                 READ (11, 1, ERR=2000, END=2000) LINE
                 contents=isactive(line,iflag)
                 read(11,1,err=2000,end=2000) line
                 call cleanline(line)
                 read(line(7:80),*)contwt
                 read(11,1,err=2000,end=2000) line
                 call cleanline(line)
                 read(line(7:80),*)number
                 do j=1,number
                    NI=1
                    read(11,1,err=2000,end=2000) line
                    IATOM=AtomType(line,NI,NMAX,sfacts,ntypes)
                    read(line(ni:80),*)tmp1,tmp2
                    contmin(IATOM)=nint(tmp1)
                    contmax(iatom)=nint(tmp2)
                 enddo
                endif
        endif
        goto 10
2000    close(unit=11)
        do j=1,ntypes
           write(10,20)j,sfacts(j)
20         format(' Type ',i2,' ',a)
           do k=1,j
            write(10,21)k,sfacts(k),bonda(j,k),bumpa(j,k)
           enddo
21         format(' Type ',i2,' ',a,' Bond ',F9.3,' Bump ',F9.3)
           write(10,22)numcord(j),numbond(j)
22         format(' Minimum Co-ordination ',i3,' Maximum ',i3)
           write(10,23)contmin(j),contmax(j)
23         format(' Minimum Number ',i3,' Maximum ',i3)
        enddo
        write(10,*)'Base Valence',BaseCharge
        do j=1,ntypes
           write(10,*)'Type ',j,' ',sfacts(j),' Valence ',ValAtoms(j)
        enddo
        return
    1    FORMAT(A)
        end

         logical function isactive(line,iflag)
         character*(*) line
         iflag=0
         call cleanline(line)
         if(line(1:4).ne.'ACTI')then
                iflag=1
                write(10,*)'Screwup!'
                isactive=.false.
                return
         endif
         NI=4
         next=NFIELD(LINE,NI,NMAX)
         if(line(next:next+2).eq.'YES')then
            isactive=.true.
         else
            isactive=.false.
         endif
         return
         end
         
         integer function AtomType(line,NI,NMAX,sfacts,ntypes)
C        Get an atom type starting at NI, padding to 4 characters
         character*4 Watom,sfacts(*)
         character*(*) line
         call cleanline(line)
C         write(6,*)line(1:10)
         ntmp=ni
         next=nfield(line,ni,nmax)
         length=ni-1-ntmp
         if(length.gt.4)length=4
         watom='    '
         watom(1:length)=line(ntmp:ntmp+length-1)
C         write(6,*)'Found ',watom,'-',length
C         write(6,*)'Test ',line(ntmp:ntmp+length-1)
         do j=1,ntypes
            if(sfacts(j).eq.watom)then
              AtomType=j
              return
            endif
         enddo
         AtomType=-1
         return
         end
         
       INTEGER FUNCTION NFIELD (LINE, NI, NMAX )
C     Find the next non blank character after a space, starting at ni
C     Return a negative value if none before nmax
C     Recognise ! as a comment
         CHARACTER*(*) LINE
         N = NI
   10    IF (LINE(N:N) .EQ. ' ') THEN
           N = N + 1
           IF (N .GT. NMAX) THEN
             NFIELD = (-1)
             RETURN
           END IF
           NFIELD=N
           NI=NFIELD
           RETURN
         END IF
         N=N+1
         GOTO 10
       END
       
         subroutine cleanline(line)
         character*80 line
         character*1 DUM
C     Replace commas by blanks, and use upper case
         I1 = ICHAR ('a')
         I2 = ICHAR ('z')
         DO   J=1,80
           DUM = LINE(J:J)
           IDUM = ICHAR (DUM)
           IF (DUM .EQ. '!') THEN
             DO   KK=J+1,80
               LINE(KK:KK) = ' '
             END DO
             return
           END IF
           IF (DUM .EQ. ',') DUM = ' '
           IF (IDUM .GT. 126 .OR. IDUM .LT. 32) THEN
             DUM = ' '
             LINE(J:J) = DUM
           ELSE IF (IDUM .GE. I1 .AND. IDUM .LE. I2) THEN
             DUM = CHAR (IDUM - 32)
           END IF
          END DO
C          write(6,*)'Cleaned'
         return
         end

