      logical function dist2Dt(dx,dy,tol)
C     Return true if the two points are very close
      integer ncont(20)
      dimension cell(6),tempf(20)
      common /sfcom1/tempf,ncont,natomq,cell
      logical aflag
      save aflag,aa,bb,ab
      data aflag/.true./
      if(aflag)then
      ang=cell(6)*asin(1.0)/90.
      aa=cell(1)*cell(1)
      bb=cell(2)*cell(2)
      ab=2.*cell(1)*cell(2)*cos(ang)
      aflag=.false.
      endif
      if(abs(dx).lt.1e-6.and.abs(dy).lt.1e-6)then
        dist2Dt=.true.
        return
      endif
      r=dx*dx*aa+dy*dy*bb+dx*dy*ab
      dist2Dt=.false.
      if(r.lt.tol*tol)dist2Dt=.true.
      return
      end
      logical function dist2D(dx,dy,tol)
      logical dist2Dt
      dist2D=dist2Dt(dx,dy,tol)
      return
      end

      real function dist2Dv(dx,dy)
C     Return true if the two points are very close
      integer ncont(20)
      dimension cell(6),tempf(20)
      common /sfcom1/tempf,ncont,natomq,cell
      logical aflag
      save aflag,aa,bb,ab
      data aflag/.true./
      if(aflag)then
      ang=cell(6)*asin(1.0)/90.
      aa=cell(1)*cell(1)
      bb=cell(2)*cell(2)
      ab=2.*cell(1)*cell(2)*cos(ang)
      aflag=.false.
      endif
      dist2Dv=dx*dx*aa+dy*dy*bb+dx*dy*ab
      return
      end
      
      real*8 function dist2Dvd(dx,dy)
C     Return true if the two points are very close
      integer ncont(20)
      dimension cell(6),tempf(20)
      common /sfcom1/tempf,ncont,natomq,cell
      real*8 dx,dy,aa,bb,ab
      logical aflag
      save aflag,aa,bb,ab
      data aflag/.true./
      if(aflag)then
      ang=cell(6)*asin(1.0)/90.
      aa=cell(1)*cell(1)
      bb=cell(2)*cell(2)
      ab=2.*cell(1)*cell(2)*cos(ang)
      aflag=.false.
      endif
      dist2Dvd=dx*dx*aa+dy*dy*bb+dx*dy*ab
      return
      end
