C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE BRWNIE (H, K, BWT, F, SYMM, NREF, NPAD )
         INTEGER H(*), K(*)
         DIMENSION BWT(*), F(*)
         CHARACTER*4 SYMM
         INTEGER HE1(20), KE1(20), ISE(20)
         INTEGER HE2(20), KE2(20)
         DIMENSION BROWN((-50):50,(-50):50)
         LOGICAL PRINTF
         COMMON /PRINTS/PRINTF
         SAVE BROWN
         INTEGER II1, II2, II3, II4, II5
         REAL RR1, RR2, RR3
         DO   I2=(-50),50
 
           DO   I1=(-50),50
             BROWN(I1,I2) = 0.
           END DO
         END DO
 
         II5 = NREF + 1
         DO 1 J=1,NREF
           IF (H(J) .NE. 0 .OR. K(J) .NE. 0) THEN
             CALL EQUIV2 (HE1,KE1,ISE,H(J),K(J),NE1,SYMM)
             RR3 = F(J)
             DO 10 J1=1,NE1
               II3 = HE1(J1)
               II4 = KE1(J1)
               RR2 = RR3
 
               DO 10 I=II5,NPAD
                 CALL EQUIV2 (HE2,KE2,ISE,H(I),K(I),NE2,SYMM)
                 II1 = II3
                 II2 = II4
                 RR1 = RR2
                 DO 10 J2=1,NE2
                   I1 = HE2(J2) + II1
                   I2 = KE2(J2) + II2
                   IF (ABS (I1) .LE. 50 .AND. ABS (I2) .LE. 50) THEN
                     BROWN(I1,I2) = BROWN(I1,I2) + RR1
                   END IF
   10              CONTINUE
           END IF
    1      CONTINUE
 
         IF (PRINTF) THEN
         write (10, *) ' '
         WRITE (10, *) 'Weightings for Missing Reflections'
         ENDIF
         DO   J=1,NREF
           IF (H(J) .EQ. 0 .AND. K(J) .EQ. 0) THEN
             BWT(J) = 1.
           ELSE
             BWT(J) = BWT(J) * (1 + BROWN(H(J),K(J)))
             IF (PRINTF) THEN
               WRITE (10, 20) H(J), K(J), 0, BWT(J)
             END IF
   20        FORMAT(3I5,F12.5)
           END IF
         END DO
         RETURN
       END
