C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE CMAPS (VV, S, IS, M, IOPT, NBEAMS, NMAX, FHK, H, K,
     X    NREF, SYMM, IND, ANEW, BWT, F0, NFIX )
C     Try a convergence map
C         PARAMETER (NHK2 = 900, NLIMIT = 65536)
         include 'Nlimit.h'
         include 'NewStuff.h'
         LOGICAL PRINTF, HPRINTF,JOK
         COMMON /PRINTS/PRINTF
C         DIMENSION WINWTS(NHK2)
C         COMMON /FOM5/WINWTS
         LOGICAL PWMASK, EOPT, PWACC, PMACC
         COMMON /WALSH/PWMASK, EOPT, PWACC, PMACC
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
C     data centro /.false./
         COMMON /ERRTRY/NWOPT
         COMMON /ENTC2D/RAD1, RAD2
C     For tuning
         LOGICAL TLOG(6)
         DIMENSION FTUNE(4),R(100)
         COMMON /TUNING/TLOG, FTUNE
         LOGICAL WTSON, WT2ON
         DIMENSION WTS(NHK2), EWTS(NHK2), MULTI(NHK2)
         DIMENSION WPOS(NHK2)
         COMMON /WPOSC/WPOS
         COMMON /WCOM/WTS, WTSON, MODE
         COMMON /WCOM2/EWTS, WT2ON
         COMMON /MPCOMM/MULTI
         COMMON /ECALC/SFERR1, ANGERR, SFERR2
         COMMON /PADCMM/NPAD
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
         INTEGER NCONT(20)
         DIMENSION CELL(6), TEMPF(20), AOCC(20), ZATOM(20)
         LOGICAL FORIG, FSEMP, BROWNF, DMULT, DMLT, FOM2
         Include 'Sfacts.h'
         COMMON /SFCOM1/TEMPF, NCONT, NATOM, CELL
         COMMON /SFCOM2/AOCC, ZATOM, FORIG, BROWNF, DMULT, DMLT
         COMMON /MVIS/WIDTH, HEIGHT, TIMES, FSEMP
         COMMON /COPT/ATNUM, PATTC, ACTERM, FOM2
         DIMENSION FSTEST(20)
         INTEGER HE(20), KE(20), ISE(20)
         COMMON /COPT2/FSTEST
         INTEGER LAT(2)
         COMMON /CLAT/LAT
         DIMENSION FHK(*), FCALC(NHK2), ANEW(*), BWT(*), AIN(NHK2)
         DIMENSION AHK(NHK2), VV(*), S(*), IS(*), M(*), FRND(NHK2)
         CHARACTER*4 SYMM
         LOGICAL CFLAG
         LOGICAL CENTHKL(NHK2)
         INTEGER H(*), K(*), IND(*)
         COMMON /DIVAMP/CAMP
         SAVE /COPT2/ , /COPT/ , /MVIS/ , /SFCOM2/ , /SFCOM1/ 
     X   , /FOMALL/ , /MPCOMM/ , /WCOM2/ , /WCOM/
         DOUBLEPRECISION DD1, DD2, DD3, DD4
         PARAMETER (DD1 = 360.D0 / 57.2957795131D0, DD2 = 360.D0 /
     X      57.2957795131D0, DD3 = 360.D0 / 57.2957795131D0, DD4 =
     X      360.D0 / 57.2957795131D0)
         REAL RR1
         JBAD=-1
         DEFOLD=0
         NJTRY=0
         HPRINTF = PRINTF
         IDUM = -1
         IDRAND=0
         NTIMES = 1
         if ( DivRand ) NTIMES=12
         NFIX = (-1)
        JBIG=1 
         CALL CNTRD (SYMM)
         FWT = 0.
         if(positivity)fwt=1
         IF (F0 .GT. 5.D0) THEN
           SECWT = SQRT (F0)
         ELSE
           SECWT = 10.
         END IF
C     Change here
          SECWT = MAX( sqrt (F0) , 5. )
          write(10,*)'Calculated weighting ',secwt,f0,sqrt(f0)
 
C     Origin determination? (not quite right for cm, p3, p6)
         IF ((FORIG) .and. 
     1  (SYMM(1:2).ne.'p3') .and. (SYMM(1:2).ne.'p6')) THEN
           WRITE (10, 21)
           WRITE (6, 21)
           WRITE (10, 401)
           WRITE (6, 401)
  401      FORMAT('Determining Origin defining reflections')
C     Set all reflections to zero
           DO   J=1,NREF
           CALL EQUIV2 (HE,KE,ISE,H(J),K(J),NE,SYMM)
C       Check for centered reflections
           IF(ISE(1).eq.3)THEN
                CENTHKL(J)=.TRUE.
           ELSE
                CENTHKL(J)=.FALSE.
           ENDIF
             IF (H(J) .NE. 0 .OR. K(J) .NE. 0) THEN
               ANEW(J) = 0.
               AIN(J) = 0.
             ELSE
               ANEW(J) = DD1
               AIN(J) = ANEW(J)
             END IF
           END DO
           CALL ORIGIN (H,K,FHK,I1,I2,SYMM,NREF)
           IF (I1 .GT. 0) THEN
             WRITE (6, 402) 'Origin definers:'
             WRITE (10, 402) 'Origin definers:'
           ELSE
             WRITE (6, 402) 'Cannot define origin, sorry !'
             WRITE (10, 402) 'Cannot define origin, sorry !'
           END IF
  402      FORMAT(A)
  403      FORMAT('H=',I3,' K=',I3,' L=0 U = ',F9.5)
           IF (I1 .GT. 0) THEN
             WRITE (6, 403) H(I1), K(I1), FHK(I1)
             WRITE (10, 403) H(I1), K(I1), FHK(I1)
             ANEW(I1) = DD2
             AIN(I1) = ANEW(I1)
           END IF
           IF (I2 .GT. 0) THEN
             WRITE (6, 403) H(I2), K(I2), FHK(I2)
             WRITE (10, 403) H(I2), K(I2), FHK(I2)
             ANEW(I2) = DD3
             AIN(I2) = ANEW(I2)
           END IF
         END IF
 
C     Header printout
         WRITE (10, 20)
         WRITE (6, 20)
   20    FORMAT('*************************************************')
         WRITE (10, 21)
         WRITE (6, 21)
   21    FORMAT('Divergence Analysis '/
     X      'The definition levels as a function of beams is a'/
     X      'guide to how many reflections should be specifed.')
         WRITE (10, 20)
         WRITE (6, 20)
C     Make F0 sqrt of the number of atoms
         F0 = SQRT (MAX (1.D0, DBLE (F0)))
 
C     Sizes and so forth
         CFLAG = .TRUE.
         CALL FINDSZ (H,K,NREF,SYMM,M,IOPT)
         IF (M(1) * M(2) .GT. Nlimit) THEN
           WRITE (6, *) 'Aaargh... must increase nbeams'
           write (6,*)  'I need ',m(1)*m(2),' not ',nlimit
           WRITE (6, *) 'Dying, gracelessly'
           CALL EXIT    (0)
         END IF
C     setup harm tables
         CALL PBUF2 (M)
 
C     How many beams are already defined
         NPRE = 0
         DO   J=1,NREF
           IF (ANEW(J) .GT. 1D-3) THEN
             WRITE (10, 201) 'Predefined (', H(J), ',', K(J),
     X          ') in starting set'
             WRITE (6, 201) 'Predefined (', H(J), ',', K(J),
     X          ') in starting set'
             NPRE = NPRE + 1
  201        FORMAT(A,I3,A,I3,A)
           END IF
         END DO
C
C     Add strongest beam unless npre < 2 when use three
         NGET = 1
         IF (NPRE .LT. 2) NGET = 3 - NPRE
C     How far to go with search ?
C       ** CHANGE ** This was NREF/2 and 20
         NFIND = MIN (MIN (80, MAX (20, NREF / 3)), NREF)
C       ** ADD a minimum number
         nrlow=camp*11.*log(nref/20.)
         nrlow=min(nrlow,nref*0.125)
         NFIND2 = MIN (80, MAX (5, NRLOW), NREF)
         NFIND = MAX(NFIND, NFIND2, NREF/2)
C
C        Trap very big size
         ntrap = nint(10*log(nref*0.667)-8)
         if(nref .gt. 20)then
                NFIND = min(nfind,ntrap)
                NFIND2 = min(nfind,nfind2,nrlow)
         endif
C        Constraint to find a specific number of beams
         if(ndforce .gt. 1)then
                nfind=ndforce+2
                nfind2=ndforce+2
         endif
C     Let us start by using the top nget f(h,k) and predefined beams
         NUSE = 0
         JT = 1
         I = 0
   10    I = I + 1
C     Skip predefined beams and 0,0
         IF (ANEW(I) .GT. 0.D0) GO TO 10
         IF (H(I) .EQ. 0 .AND. K(I) .EQ. 0) THEN
           I0 = I
           GO TO 10
         END IF
C     Skip beams with small Bwt
         NUSE = NUSE + 1
         IND(NUSE) = I
         WRITE (10, 201) 'Including  (', H(I), ',', K(I),
     X      ') in starting set'
         WRITE (6, 201) 'Including  (', H(I), ',', K(I),
     X      ') in starting set'
         IF (NUSE .LT. NGET) GO TO 10
         WRITE (10, 20)
         WRITE (6, 20)
 
C     We now have (at least) npre defined beams
 
C     Set all (unless preset)
  100    JT = JT + 1
C
C     Randomization loop
        DO J=1,nref
                FRND(J)=0
        enddo
        DO 1001 NDTIMES = 1 , NTIMES
         DO   J=1,NREF
           RR1 = ANEW(J)
           AHK(J) = RR1
           AIN(J) = RR1
         END DO
C     Set beams specified to date
         DO   I=1,NUSE
           AHK(IND(I)) = DD4
           AIN(IND(I)) = AHK(IND(I))
         END DO
C       Randomization ?
        if( divrand )then
                IDIV = 0
                ATMP = asin (1.0d0)/90.D0
C                write(10,*)npre,nuse
C                write(6,*)npre,nuse
                DO I=1,nuse
                 random= RANC1 (IDUM )
                        IDIV=nint(RANDOM*360)
C                        IDIV=IDIV+45
C                        if(IDIV.gt.360)IDIV=45
                        II=IND(I)
                        IDIVT=IDIV
                        if(centhkl(ii))then
                                IDIVT=IDIV/180
                                if(IDIVT.eq.0)IDIVT=360
                        ENDIF                        
                        AHK(II)=IDIVT*ATMP
                        AIN(II)=IDIVT*ATMP
                ENDDO
        endif 
C     Zero unmeasured
         DO   I=NREF+1,NPAD
           FHK(I) = 0.
           AHK(I) = 0.
         END DO
 
C     Over-ride any extension options
         FTUNE(3) = 0.
         FTUNE(1) = 1.
         FTUNE(2) = 3.1D0
 
C  The guts, do a sharpening operation with all options included for method
         JTT = 1
         printf=.false.
         IF(ndtimes.eq.1)printf=hprintf
         AERR = TB2DC (H,K,FHK,AHK,AIN,NREF,JTT,CFLAG,SYMM,NBEAMS,NHK,VV
     X      ,M,IOPT,FCALC,FWT,NUSE)
C
C       Sum F's
        DO J=1,nref
                FRND(J)=FRND(J)+FCALC(J)
        enddo
1001    continue
C
        printf=hprintf
C       Move frnd back
        do J=1,nref
           if((h(j) .ne. 0).and.(k(j) .ne. 0))then
                FCALC(J)=FRND(J)/float(NTIMES)
           else
                FCALC(J)=0
           endif
        enddo
C     fcalc now has calculated values for the reflections of interest
C     Let us use fhk*(fhk/[fhk+fcalc*5.]) to find new reflections
         DO   I=1,NUSE
           AHK(IND(I)) = 0.
         END DO
         WBIG = (-1.)
         WSET = 0.
         WR = 0.
         N10 = 0
         N25 = 0
         N50 = 0
         NE = 0
         NE7 = 0
         N710 = 0
         N725 = 0
         N750 = 0
         NU = 0
         NU10 = 0
         NU25 = 0
         NU50 = 0
         DO   J=1,NREF
           IF (J .NE. I0) THEN
             IF (AIN(J) .LE. 1D-3) THEN
C     Look for statistics of E>1.0 and E>0.075 reflections and U>0.1
               EHK = FHK(J) * F0
               IF (EHK .GE. 1.D0) THEN
                 F = FCALC(J) / FHK(J)
                 IF (F .GT. 0.1D0) N10 = N10 + 1
                 IF (F .GT. 0.25D0) N25 = N25 + 1
                 IF (F .GT. 0.5D0) N50 = N50 + 1
                 NE = NE + 1
               END IF
               IF (EHK .GE. 0.75D0) THEN
                 F = FCALC(J) / FHK(J)
                 IF (F .GT. 0.1D0) N710 = N710 + 1
                 IF (F .GT. 0.25D0) N725 = N725 + 1
                 IF (F .GT. 0.5D0) N750 = N750 + 1
                 NE7 = NE7 + 1
               END IF
               IF (FHK(J) .GE. 0.1D0) THEN
                 F = FCALC(J) / FHK(J)
                 IF (F .GT. 0.1D0) NU10 = NU10 + 1
                 IF (F .GT. 0.25D0) NU25 = NU25 + 1
                 IF (F .GT. 0.5D0) NU50 = NU50 + 1
                 NU = NU + 1
               END IF
 
 
C     Definition statistics
               WSET = WSET + FCALC(J)
               WR = WR + FHK(J)
               W = FHK(J) * FHK(J) / (FHK(J) + FCALC(J) * SECWT) * BWT(J
     X            )
C       Look for Centering
C       IF(CENTHKL(j))W=W*2
               IF ((W .GT. WBIG).and. (J.NE.JBAD)) THEN
C       Trap that J is not already defined -- can happen!
                 JOK=.true.
                 DO JT=1,NUSE
                    IF(J.EQ.IND(JT))JOK=.false.
                 ENDDO
                 IF( JOK ) THEN
                     WBIG = W
                     JBIG = J
                 ENDIF
               END IF
             END IF
           END IF
         END DO
 
C     Printout of statistics
         IF (NE .GT. 0) THEN
           F10 = N10 * 100 / FLOAT (NE)
           F25 = N25 * 100 / FLOAT (NE)
           F50 = N50 * 100 / FLOAT (NE)
         ELSE
           F10 = 100.
           F25 = 100.
           F50 = 100.
         END IF
         IF (NE7 .GT. 0) THEN
           F710 = N710 * 100 / FLOAT (NE7)
           F725 = N725 * 100 / FLOAT (NE7)
           F750 = N750 * 100 / FLOAT (NE7)
         ELSE
           F710 = 100.
           F725 = 100.
           F750 = 100.
         END IF
         IF (NU .GT. 0) THEN
           FU10 = NU10 * 100 / FLOAT (NU)
           FU25 = NU25 * 100 / FLOAT (NU)
           FU50 = NU50 * 100 / FLOAT (NU)
         ELSE
           FU10 = 100.
           FU25 = 100.
           FU50 = 100.
         END IF
C       Note, was 80 & 70 here with old code

         DEFN = WSET * 48 / WR / camp
C         if( centro )defn=70*wset/wr / camp
         if( divrand )defn=defn*5./3.
         WRITE (10, 203) NUSE, DEFN, F10, F25, F50, F710, F725, F750,
     X      FU10, FU25, FU50
         WRITE (6, 203) NUSE, DEFN, F10, F25, F50, F710, F725, F750,
     X      FU10, FU25, FU50
  203    FORMAT('For a total of ',I2,' beams'/
     X      'Overall Definition Level   ',F6.2,'%'/
     X      'For E(h,k)>1.0,  defined to 10% ',F6.2,'%; to 25% ',F6.2,
     X      '%; to 50% ',F6.2,'%'/'For E(h,k)>0.75, defined to 10% ',F6.
     X      2,'%; to 25% ',F6.2,'%; to 50% ',F6.2,'%'/
     X      'For U(h,k)>0.1,  defined to 10% ',F6.2,'%; to 25% ',F6.2,
     X      '%; to 50% ',F6.2,'%'/)
 
C       Hack the definition level for forcing of the number of reflections
        if(ndforce .gt. 1)then
                if(NUSE .eq. ndforce+2)then
                        defn=100
                else
                        defn=20
                endif
        endif
         IF (DEFN .GT. 24 .AND. NFIX .LT. 0 .AND. NUSE .GE. NFIND2
     X          ) NFIX = NUSE
         IF(ndforce .gt. 0)NFIX=NDFORCE
         IF (NUSE .LT. NFIND.AND.DEFN.LT.80) THEN
C     jbig is now the stongest, poorly defined reflection
C     Add it to the starting set unless it made things worse!
C           IF( (DEFN.GT.(DEFOLD+0.01)).or.(NJTRY.EQ.1))THEN
C              Accept
               NUSE = NUSE + 1
               IND(NUSE) = NUSE !JBIG
               DEFOLD = DEFN
               NJTRY = 0
               JBAD = -1
C           ELSE
C               JBAD = IND(NUSE)
C           WRITE (10, 202)'Deleted ', NUSE, 'th beam (',H(JBAD),',',K
C     X        (JBAD), ') from starting set'
C           WRITE (6, 202)'Deleted ', NUSE, 'th beam (', H(JBAD),',',K(
C     X        JBAD), ') from starting set'
C               IND(NUSE) = JBIG
C               NJTRY = NJTRY + 1
C           ENDIF
           WRITE (10, 202)'Adding  ', NUSE, 'th beam (', H(JBIG), ',', K
     X        (JBIG), ') to starting set'
           WRITE (6, 202)'Adding  ', NUSE, 'th beam (', H(JBIG), ',', K(
     X        JBIG), ') to starting set'
  202      FORMAT(A,I2,A,I3,A,I3,A)
           WRITE (6, 20)
           WRITE (10, 20)
           GO TO 100
         END IF
         IF (NFIX .LT. 0) NFIX = NUSE

C     Now transfer these back via ind
         DO   J=1,NREF
           FCALC(J) = FHK(J)
         END DO
         DO   I=1,NUSE
           FCALC(IND(I)) = (-999.)
         END DO
         N = NUSE + 1
         DO   J=1,NREF
           IF (FCALC(J) .GT. (-998.D0)) THEN
             IND(N) = J
             N = N + 1
           END IF
         END DO
       END
 
