      double precision function rpcalw(fhk,fcalc,nref,i,rf)
      dimension fhk(*),fcalc(*)
      double precision s1,s2,s4,rpcal3,rpcalef
      double precision t1,t2,rpshelx,rpcaler
      save s4
      integer rh(2000),rk(2000),rl(2000)
      common /rscom4/rh,rk,rl
      integer ncont(20)
      dimension cell(6),tempf(20),aocc(20),zatom(20)
      common /sfcom2/aocc,zatom,forig,brownf,dmult,dmlt
      common /sfcom1/tempf,ncont,natomq,cell
      include 'Sfacts.h' 
      logical robnod,rob_fit,dwref,robfm,nodd5
      common /fscom55/robnod,rob_fit,dwref,robfm,nodd5
      include 'errref.h'
      logical itrflag
      common /trefcom/it98,it98b,it98c,itrflag
      include 'RefineWts.h'
      logical shelx
      common /shelxmode/shelx
        COMMON /COPT/ATNUM, PATTC, ACTERM, FOM2
        real*8 sclwt(2000)
C
C       Calculate the G-of-Fit
      if(shelx)then
C       Shelx form
        rpcalw=rpshelx(fhk,fcalc,nref,i,rf)
        return
      else if(rob_fit.and.robfm)then
C       Robust Chi
        rpcalw=rpcaler(fhk,fcalc,nref,i,rf)
        return
      else if(rob_fit)then
C       R1 on Intensities
        rpcalw=rpcale(fhk,fcalc,nref,i,rf)
        return
      else if(robfm)then
C       Chi**2 form
        rpcalw=rpcalef(fhk,fcalc,nref,i,rf)
        return
C      else if(shelx)then
C       Shelx form
C        rpcalw=rpshelx(fhk,fcalc,nref,i,rf)
C        write(10,*)'Shelx Hack Used'
C        rpcalw=rpcalef(fhk,fcalc,nref,i,rf)
C        return
      endif

C       Alternative is R2 on I's
C
      s4=0
      s3=0

      Include 'Conservep.h'
C     Get the R.M.S. error
      s1=0.0d0
      s2=0
      do j=1,nref
                t=fhk(j)*fhk(j)
                err=t-scl*fcalc(j)
                s1=s1+err*err*sclwt(j)
                s2=s2+t*t*sclwt(j)
      enddo
      rpcalw=sqrt(s1/s2)
C      scl=sqrt(scl)
      fmax=fmax/10.
      fmax=max(fmax,1e-4)
      open(unit=13,file='rbfit.dat')
      open(unit=33,file='rfit.dat')
      write(13,*)'Output of fitted data '
      if(ferr)then
         write(13,981)
      else
         write(13,99)
      endif
      write(33,*)'Output of fitted data '
      write(33,99)
      Rf=0
      S1=0
      do j=1,nref
        t2=fcalc(j)*scl
        t1=fhk(j)*fhk(j)
C       t1=sqrt(t1)
      write(13,96)rh(j),rk(j),rl(j),t1/fmax,t2/fmax,
     1  (t2-t1)/fmax
        q1=t1/fmax
        q2=t2/fmax
        if(.not.ferr)then
           q1=sqrt(q1)
           q2=sqrt(q2)
        endif
        qmax=max(q1,qmax)
        qmax=max(q2,qmax) 
       write(33,96)rh(j),rk(j),rl(j),q1,q2,q1-q2
        S1=S1+t1*sclwt(j)
        Rf=Rf+abs(t2-t1)*sclwt(j)
      enddo
C     Add 0,0 to pin intensity scaling
      write(33,96)0,0,0,qmax,qmax,0.
      close(unit=33)
      Rf=Rf/S1
      write(13,97)'R.M.S. I ',rpcalw,' Scalings ',scl
      if(dwref)then
      ndw=1
      do j=1,20
         if(zatom(j).gt.-0.1)then
         tempf(j)=tempf(1)
         write(13,92)'DW for atom ',sfacts(j),' is ',tempf(j)
         endif
      enddo
      endif
C      close(unit=13)
        return
92      format(a,a,a,f12.5)
96      format(3i4,6f12.6)
97      format(a,f12.5,a,f12.5)
99    format('   H   K   L      Iobs        Icalc       Diff')
981   format('   H   K   L      Fobs        Fcalc       Diff')
       end
