        real*8 function gatom0(vars,n)
        include 'rfact.h'
        include 'Xray.h'
        dimension cell(6),tempf(20)
        integer ncont(20)
        common /sfcom1/tempf,ncont,natomq,cell
        include 'Atoms.h'
        include 'Just_Pars.h'
        dimension x(natf),y(natf),z(natf)
        real*8 vars(*)
        logical dwref
        integer itype(natf),isymm
        character*4 symm
        equivalence(symm,isymm)
        dimension work(100)
        integer iwork(100)
        logical lwork(100)
        common /conminw/work,iwork,lwork
        integer ht(3),kt(3),lt(3)
        real*8 robf3Dn
        ndw=iwork(1)
        nref=iwork(2)
        isymm=iwork(3)
        n3=iwork(4)
        dwref=lwork(1)
        noff=4
        if(dwref)then
C               Only refine a single temperature factor
                natom=n-1
                do j=1,20
                        tempf(j)=abs(vars(n))+0.075
C                        if(tempf(j).lt.0.075)tempf(j)=0.075
                        if(tempf(j).gt.6.0)tempf(j)=6.0
                        tempf(j)=abs(tempf(j))
                enddo
                call GEN3DR(work,ht,kt,lt,NREF,xray)
        else
                natom=n
        endif
        m=0
        natom=natom/2
        do j=1,natom*2,2
                m=m+1
                x(m)=vars(j)
                y(m)=vars(j+1)
                z(m)=0
                itype(m)=iwork(m+noff)
C       Cleanup atom positions - trapping errors in symmetry positions
                call cleaner(x(m),y(m),symm,0.5)
        enddo
        gatom0=robf3Dn(rfhk,nref,natom,
     $                  x,y,z,symm,rh,rk,rl,itype,1)
        return
        end
        real*8 function gatom_1(work,iwork,lwork,scale,vars,n)
C       General function evaluation
        include 'rfact.h'
        include 'Xray.h'
        dimension cell(6),tempf(20)
        integer ncont(20)
        common /sfcom1/tempf,ncont,natomq,cell
        include 'Atoms.h'
        include 'Just_Pars.h'
        dimension x(natf),y(natf),z(natf)
        dimension vars(*),work(*),scale(*)
        logical lwork(*),dwref
        integer iwork(*),itype(natf),isymm
        integer ht(3),kt(3),lt(3)
        character*4 symm
        equivalence(symm,isymm)
        real*8 robf3Dn

        ndw=iwork(1)
        nref=iwork(2)
        isymm=iwork(3)
        n3=iwork(4)
        dwref=lwork(1)
        noff=4
        if(dwref)then
C               Only refine a single temperature factor
                natom=n-1
                do j=1,20
                        tempf(j)=abs(vars(n))+0.075
C                        if(tempf(j).lt.0.075)tempf(j)=0.075
                        if(tempf(j).gt.6.0)tempf(j)=6.0
                        tempf(j)=abs(tempf(j))
                enddo
                call GEN3DR(work,ht,kt,lt,NREF,xray)
        else
                natom=n
        endif
        m=0
        natom=natom/3
        do j=1,natom*3,3
                m=m+1
                x(m)=vars(j)
                y(m)=vars(j+1)
C               z(m)=vars(j+2)*scale(j+2)
                z(m)=0
                itype(m)=iwork(m+noff)
C               write(14,1)m,x(m),y(m),z(m),itype(m),scale(j),
C     1         scale(j+1),scale(j+2)
1               format(i2,3f10.4,i2,3e10.4)
C
C       Cleanup atom positions - trapping errors in symmetry positions
                call cleaner(x(m),y(m),symm,0.5)
        enddo
        gatom_1=robf3Dn(rfhk,nref,natom,
     $                  x,y,z,symm,rh,rk,rl,itype,1)
        return
        end

        subroutine gatom_2(vars,g,n,work,iwork,lwork,scale)
C       General gradient
        include 'rfact.h'
        include 'Xray.h'
        dimension cell(6),tempf(20)
        integer ncont(20)
        common /sfcom1/tempf,ncont,natomq,cell
        include 'Atoms.h'
        include 'Just_Pars.h'
        dimension x(natf),y(natf),z(natf)
        dimension gtemp(natf)
        dimension vars(*),g(*),work(*),scale(*)
        dimension gx(natf),gy(natf),gz(natf)
        integer iwork(*),itype(natf),isymm
        character*4 symm
        equivalence(symm,isymm)
        logical lwork(*),dwref
        integer ht(3),kt(3),lt(3)
        ndw=iwork(1)
        nref=iwork(2)
        isymm=iwork(3)
        n3=iwork(4)
        dwref=lwork(1)
        noff=4
        if(dwref)then
C               Only refine a single temperature factor
                natom=n-1
                do j=1,20
                        tempf(j)=abs(vars(n))+0.075
C                        if(tempf(j).lt.0.075)tempf(j)=0.075
                        if(tempf(j).gt.6.0)tempf(j)=6.0
                        tempf(j)=abs(tempf(j))
                enddo
                call GEN3DR(work,ht,kt,lt,NREF,xray)
        else
                natom=n
        endif
        m=0
        natom=natom/3
        do j=1,natom*3,3
                m=m+1
                x(m)=vars(j)
                y(m)=vars(j+1)
C               z(m)=vars(j+2)
                z(m)=0
C     Cleanup atoms close to symmetry points
                call cleaner(x(m),y(m),symm,0.5)
                vars(j)  =x(m)/scale(j)
                vars(j+1)=y(m)/scale(j+1)
                itype(m)=iwork(m+noff)
        enddo
        dx=1e-4/cell(1)
        dy=1e-4/cell(2)
        dz=1e-4/cell(3)
        call grad3Dn(rfhk,nref,natom,central,x,y,z,symm,
     1 gx,gy,gz,dx,dy,dz,rh,rk,rl,itype,dwref,gtemp,ndw)
        m=0
        do j=1,natom*3,3
                m=m+1
                g(j)  =gx(m)
                g(j+1)=gy(m)
C               g(j+2)=gz(m)
                g(j+2)=0
                gz(m)=0
C               if(n3.eq.1)g(j+2)=0
        enddo
        if(dwref)then
                do j=1,ndw
                        g(j+natom*3)=gtemp(j)
                        write(10,*)'Temp in gatom_2',j,gtemp(j)
                enddo
        endif
        return
        end
        subroutine gatom_3(vars,n,work,iwork,lwork,d2)
        include 'rfact.h'
        dimension cell(6),tempf(20)
        integer ncont(20)
        common /sfcom1/tempf,ncont,natomq,cell
        include 'Atoms.h'
        include 'Just_Pars.h'
        dimension x(natf),y(natf),z(natf)
        dimension vars(*),work(*),d2(*)
        dimension gx(natf),gy(natf),gz(natf),gtemp(natf)
        dimension d2x(natf),d2y(natf),d2z(natf),d2d(natf)
        integer iwork(*),itype(natf),isymm
        integer ht(3),kt(3),lt(3)
        character*4 symm
        equivalence(symm,isymm)
        logical lwork(*),dwref
        real*8 e0

        ndw=iwork(1)
        nref=iwork(2)
        isymm=iwork(3)
        n3=iwork(4)
        dwref=lwork(1)
        noff=4
        if(dwref)then
C               Only refine a single temperature factor
                natom=n-1
                do j=1,20
                        tempf(j)=abs(vars(n))+0.075
                        if(tempf(j).gt.6.0)tempf(j)=6.0
                        tempf(j)=abs(tempf(j))
                enddo
        else
                natom=n
        endif
        m=0
        natom=natom/3
        do j=1,natom*3,3
                m=m+1
                x(m)=vars(j)
                y(m)=vars(j+1)
C               z(m)=vars(j+2)
                z(m)=0
                itype(m)=iwork(m+noff)
C     Cleanup atoms close to symmetry points
                call cleaner(x(m),y(m),symm,0.5)
        enddo
        dx=1e-4/cell(1)
        dy=1e-4/cell(2)
        dz=1e-4/cell(3)
        call hess3Dn(rfhk,nref,natom,d2x,d2y,d2z,d2d,
     $  x,y,z,symm,gx,gy,gz,dx,dy,dz,rh,rk,rl,itype,dwref,gtemp,ndw
     $  ,e0)
        m=0
        do j=1,natom*3,3
                m=m+1
                d2(j)  =d2x(m)
                d2(j+1)=d2y(m)
                d2(j+2)=0
C               d2(j+2)=d2z(m)
C               if(n3.eq.1)d2(j+2)=1
        enddo
        if(dwref)then
                do j=1,ndw
                        d2(j+natom*3)=d2d(j)
                enddo
        endif
        return
        end
        subroutine gatom_4(vars,s,n,work,iwork,lwork,scale,
     1 debug)
C       Apply constraints to the search direction
C       Currently limited to z direction
        include 'rfact.h'
        dimension cell(6),tempf(20)
        integer ncont(20)
        common /sfcom1/tempf,ncont,natomq,cell
        include 'Atoms.h'
        include 'Just_Pars.h'
        dimension x(natf),y(natf),z(natf)
        dimension gtemp(natf)
        dimension vars(*),s(*),work(*),scale(*)
        dimension sx(natf),sy(natf),sz(natf)
        integer iwork(*),isymm
        character*4 symm
        equivalence(symm,isymm)
        logical lwork(*),dwref,debug

        ndw=iwork(1)
        nref=iwork(2)
        isymm=iwork(3)
        n3=iwork(4)
        dwref=lwork(1)
        if(dwref)then
                natom=n-ndw
        else
                natom=n
        endif
        m=0
        natom=natom/3
        ssz=0
        do j=1,natom*3,3
                m=m+1
C               x(m)=vars(j)
C               y(m)=vars(j+1)
C               z(m)=vars(j+2)
C               sx(m)=s(j)
C               sy(m)=s(j+1)
                sz(m)=s(j+2)
                ssz=ssz+sz(m)
        enddo
        ssz=ssz/m
        m=0
C       if(n3.eq.1)then
                do j=1,natom*3,3
                        s(j+2)=0
                enddo
C       else
C               do j=1,natom*3,3
C                       m=m+1
C       if(debug)write(14,*)m,sz(m),s(j+2),scale(j+2)
C               if(scale(j+2).gt.1e-4)
C     1                 s(j+2)=s(j+2)-ssz/scale(j+2)
C                       s(j+2)=s(j+2)-ssz/scale(j+2)
C               enddo
C       endif
        return
        end
