      subroutine ref_gen(x,n,work,iwork,lwork,scale,debug,funct,
     1 functg,cond,icond,sfunct,ng,err)
        dimension x(*),work(*)
        integer iwork(*)
        logical lwork(*),debug
        include 'Atoms.h'
        include 'Just_Pars.h'
        include 'cellcon.h'
        dimension xo(natf*3),go(natf*3),s(natf*3),g(natf*3)
        dimension scale(*),xt(natf*3),dscale(natf*3)
C       L-BFGS stuff
C       paramters for how many cycles etc
        parameter(nbstart=3,nbfgs=12)
        dimension B_s(natf*3,nbfgs),B_y(natf*3,nbfgs)
        dimension B_rho(nbfgs),B_wa(nbfgs)
        logical bfgs_on
C       save xo,mark,imark,B_rho,B_s,B_y,scl_ave,go
        real*8 funct,err,eold ,err1,err2,gt(natf*3),dstep
        real*8 d1,d2
        external funct,functg,cond,sfunct
        imode=-1
        ndw=iwork(1)
C       Initialize
        nt=4
C        do j=1,n,3
C           nt=nt+1
C           write(6,*)j,x(j),x(j+1),x(j+2),iwork(nt)
C        enddo
        mark=0
        imark=0
        bfgs_on=.false.
        jstart=0
        eold=0
        do j=1,n
                go(j)=0
                xo(j)=0
        enddo
C
C       Find the scaling matrix that conditions the variables
        scmin=1
C       if(icond.lt.0)then
C               call cond(x,n,work,iwork,lwork,scale)
C               do j=1,n
C                       scmin=abs(scale(j))
C                       if(scmin.gt.1e-9)goto 10
C               enddo
C       If we get here, the 2nd derivative is zero for everything!
C       write and error comment and return
C               if(scmin.lt.1e-9)then
C                       write(6,*)'Panic - 2nd derivatives zero!'
C                       do j=1,n
C                               scale(j)=1
C                       enddo
C                       err=funct(work,iwork,lwork,scale,x,n)
C                       return
C               endif
C10             continue
C               scmax=scmin
C               do j=2,n
C               ss=abs(scale(j))
C               if(ss.gt.scmax)scmax=ss
C               if(ss.lt.scmin.and.ss.gt.1e-8)scmin=ss
C               enddo
C       Take 1/sqrt(scale), safeguarded for overflows
C               sb=scmin*1e-2
C               do j=1,n
C                       ss=abs(scale(j))
C                       scale(j)=sqrt(max(ss,sb))/(ss+sb)
C               enddo
C       endif

        j=0
        do j1=1,n,3
           do j2=1,3
              j=j+1
C              scale(j)=1.d0/cell(j2)
C             x(j)=x(j)/scale(j)
              scale(j)=1
              dscale(j)=1.D0/cell(j2)
           enddo
        enddo
      if(lwork(1))then
        j1=n-ndw
        do j=j1,n
                scale(j)=1.D0
                dscale(j)=10.D0
        enddo
      endif
      step=1
      do jg=1,ng
        ibad=0
C       Get the gradient
99      continue
        if(imode.gt.0)then
                call functg(x,g,n,work,iwork,lwork,scale)
        else
            do j=1,n
               xt(j)=x(j)
               g(j)=0
            enddo
            dstep=1d-3
            do j=1,n
C              Avoid z
               if(( (j/3)*3 .eq. j).and.(j.lt.n-ndw))goto 110
               jj=j-1
C             if( (jj/3)*3 .eq. jj) write(6,*)' '
               xt(j)=x(j)+dstep*dscale(j)
               err1= funct(work,iwork,lwork,scale,xt,n)
               d1=xt(j)-x(j)
               do jq=1,n
                  xt(jq)=x(jq)
               enddo
               xt(j)=x(j)-dstep*dscale(j)
               err2= funct(work,iwork,lwork,scale,xt,n)
               d2=x(j)-xt(j)
               d1=d1+d2
               if(abs(d1).gt.1d-8)then
                        g(j)=(err1-err2)/d1
               else
                        g(j)=0.d0
               endif
               do jq=1,n
                  xt(jq)=x(jq)
               enddo
110            continue
             enddo
C        call exit(0)
        endif
        if(jg.le.2)then
                mark=0
                imark=0
        endif
C       Is the gradient very small ?
        gg=0
        b1=0
        b2=0
        do j=1,n
C                write(10,*)'Grad ',j,g(j),x(j)
                gg=gg+g(j)*g(j)
                b1=b1+(g(j)-go(j))*g(j)
                b2=b2+go(j)*go(j)
        enddo
        gg=sqrt(gg)
        if(debug)write(14,*)'Iteration ',jg,' Grad ',gg
        if(debug)write(6,*)'Iteration ',jg,' Grad ',gg
        if(gg.lt.1e-9)then
                if(debug)write(14,*)'Termination, grad small'
                if(debug)write(6,*)'Termination, grad small'
                return
        endif

        mark=mark+1
        if(mark.gt.nbfgs)mark=1
        imark=imark+1
        B_sum=0
        B_scl=0
        do j=1,n
                B_y(j,mark)=g(j)-go(j)
                go(j)=g(j)
C       The step
                B_s(j,mark)=x(j)-xo(j)
                xo(j)=x(j)
C       Inner products
                B_sum=B_sum+B_y(j,mark)*B_s(j,mark)
                B_scl=B_scl+B_y(j,mark)*B_y(j,mark)
        enddo
        B_rho(mark)=B_sum
        if(abs(B_scl).gt.1e-3*abs(B_sum))then
                B_scl=abs(B_sum/B_scl)
        else
                B_scl=1
        endif
        nuse=min(nbfgs,imark)
        bfgs_on=.false.
        if(nuse.gt.3)bfgs_on=.true.
        if(bfgs_abort)bfgs_on=.false.
        if(bfgs_on)then
                call slmmv(n,nuse,B_s,B_y,B_rho,B_scl,mark,g,B_wa,150)
        endif

        
        beta=0
        if(bfgs_on)then
C       Copy over the step from BFGS
                do j=1,n
                        s(j)=-g(j)
                enddo
        else
C       Conjugant gient step
                b1=0
                b2=0
C       Generate CG step
                if(jg.gt.1)then
                    if(abs(b2).gt.1e-4*abs(b1))beta=b1/b2
                endif
                if((jg/n)*n.eq.jg)beta=0
                do j=1,n
                    s(j)=-g(j)+beta*xo(j)
                enddo
        endif
C       Apply any tweaks to the search direction
        call sfunct(x,s,n,work,iwork,lwork,scale,debug)
        if(debug)write(14,*)'Search, iteration ',imark,mark,beta,B_scl
        if(jstart.eq.0)step=0.1
        jstart=1
        if(abs(step).gt.10.)step=10.
        if(abs(step).lt.0.1)step=0.1
        stepin=step
        call line_gen(x,s,work,iwork,lwork,step,n,err,eold,funct,debug
     1  ,scale)
        if(debug)write(14,991)jg,step,err,eold,gg
        if(debug)write(6,991)jg,step,err,eold,gg
C

991     format('End ',i2,4f10.6,i4,12f10.6)
                
        if(abs(step).lt.1e-5)then
                if(ibad.gt.0)then
                if(debug)write(14,*)'Termination - small % step'
                if(debug)write(6,*)'Termination - small % step'
                        return
                endif
C               Reset
                imark=0
                mark=0
                ibad=1
                do j=1,n
                        xo(j)=0
                        go(j)=0
                enddo
                goto 99
        endif
        ibad=0

        if(debug)write(14,*)'In ',eold,' Out ',err
        if(debug)write(14,*)'Step in: ',stepin,' out ',step
C       step is oscillating too much (?)
        step=(abs(stepin)+2*abs(step))/3.
        if(jg.eq.1)errin=eold
        if((abs(eold-err)/err).lt.1e-3.and.jg.ge.3)then
                if(debug)write(14,*)'Termination - small % drop'
                if(debug)write(6,*)'Termination - small % drop'
                goto 100
          endif
        if((abs(eold-err)).lt.1e-5.and.jg.ge.3)then
                if(debug)write(14,*)'Termination - small drop'
                if(debug)write(6,*)'Termination - small drop'
                goto 100
          endif
          eold=err
        enddo
100      continue   
        return
        end
