      subroutine fdiff3Dn(fcalc,fhold,xi,yi,zi,dxi,dyi,dzi
     $          ,nref,pi2,h,k,l,symm,itype)
      real*8 xe(12),ye(12),xe2(12),ye2(12)
      complex*16 fhold(*),amp1,amp2
      double precision p,pi2,u,v,w,x,y,z,dx,dy,dz,piz
      integer h(*),k(*),l(*)
      dimension fcalc(*)
      character*4 symm
      character*1 ssy
      include 'ffact.h'
      include 'FastDerd2.h'
C      complex*16 x2d(-40:40,12),y2d(-40:40,12),zrod(-100:100)
C      complex*16 x2d2(-40:40,12),y2d2(-40:40,12),zrod2(-100:100)
      double precision ampt(2)
      equivalence (amp1,ampt)
        logical centro,sepr
        common /ccentr/centro
        save nrefo,ixmax,ixmin,iymax,iymin,izmax,izmin
        data nrefo/0/
C
C       Look for centering
        call centered(symm)
        ssy=symm(2:2)
C       Check if the x,y variables seperate
        sepr=.false.
        if(ssy.eq.'3'.or.ssy.eq.'4'.or.ssy.eq.'6')sepr=.true.
        x=xi
        y=yi
        z=zi
        dx=dxi
        dy=dyi
        dz=dzi

      pi2=4.d0*asin(1.0d0)
C       piz=pi2/izsampl
      call asymmd(x,y,ne,xe,ye,symm)
      call asymmd(x+dx,y+dy,ne,xe2,ye2,symm)
        if(symm(1:1).eq.'c')ne=ne/2
C       Find ranges to use      
        if(nrefo.ne.nref)then
        izmax=0
        ixmax=0
        iymax=0
        ixmin=0
        iymin=0
        izmin=0
        do j=1,nref
                ixmax=max(ixmax,h(j))
                ixmin=min(ixmin,h(j))
                iymax=max(iymax,k(j))
                iymin=min(iymin,k(j))
C               izmax=max(izmax,l(j))
C               izmin=min(izmin,l(j))
        enddo
        nrefo=nref
        endif

C       Find rod component
C       if(abs(dz).gt.1d-8)then
C               do j3=izmin,izmax
C                       w=j3*pi2
C                       p=w*(z)
C                       zrod(j3)=cmplx(cos(p),sin(p))
C                       p=w*(z+dz)
C                       zrod2(j3)=cmplx(cos(p),sin(p))
C               enddo
C       else
C               do j3=izmin,izmax
C                       w=j3*pi2
C                       p=w*(z)
C                       zrod(j3)=cmplx(cos(p),sin(p))
C                       zrod2(j3)=zrod(j3)
C               enddo
C       endif
C
C       write(14,*)'X values'
C       Calculate x, x+dx for the atom
        if(abs(dx).gt.1d-8.or.sepr)then
           do j=ixmin,ixmax
                u=j*pi2
                do j2=1,ne
                        p=u*(xe(j2))
                        x2d(j,j2)=cmplx(cos(p),sin(p))
                        p=u*(xe2(j2))
                        x2d2(j,j2)=cmplx(cos(p),sin(p))
                enddo
           enddo
        else
           do j=ixmin,ixmax
                u=j*pi2
                do j2=1,ne
                        p=u*(xe(j2))
                        x2d(j,j2)=cmplx(cos(p),sin(p))
                        x2d2(j,j2)=x2d(j,j2)
                enddo
           enddo
        endif
C
C       write(14,*)'Y values'
C       Calculate y, y+dy for the atom
        if(abs(dy).gt.1d-8.or.sepr)then
           do j=iymin,iymax
                v=j*pi2
                do j2=1,ne
                        p=v*(ye(j2))
                        y2d(j,j2)=cmplx(cos(p),sin(p))
                        p=v*(ye2(j2))
                        y2d2(j,j2)=cmplx(cos(p),sin(p))
                enddo
           enddo
        else
           do j=iymin,iymax
                v=j*pi2
                do j2=1,ne
                        p=v*(ye(j2))
                        y2d(j,j2)=cmplx(cos(p),sin(p))
                        y2d2(j,j2)=y2d(j,j2)
                enddo
           enddo
        endif

C     Calculate new value
      do j=1,nref
                amp1=0
                amp2=0
                do j2=1,ne
                        amp1=amp1+x2d(h(j),j2)*y2d(k(j),j2)
                        amp2=amp2+x2d2(h(j),j2)*y2d2(k(j),j2)
                        enddo
                if(centro)then
                        amp2=dble(amp2)
                        amp1=dble(amp1)
                endif
C                       amp1=amp1*zrod(l(j))
C                       amp2=amp2*zrod2(l(j))
                p=rfact(j,itype)
                amp1=fhold(j)-p*(amp1-amp2)
        if(abs(ampt(1)).lt.1d-20.and.abs(ampt(2)).lt.1d-20)then
                fcalc(j)=0
        else
                fcalc(j)=ampt(1)*ampt(1)+ampt(2)*ampt(2)
        endif
      enddo             

      return
      end
