      subroutine fomcalc(nchild,nvar,fomchild,child,ngmaxn,
     $  npopn,f)
      include 'Gpops.h'
      include 'Atoms.h'
      integer*2 child(ngmaxn,npopn)
      dimension fomchild(*)
      dimension fhk(npop)
      dimension occ(natf),zocc(natf)
C      complex fbase(npop)
      complex f(*)
      common /fomgen/fhk,fbase,nref,natom,occ
      common /fomgen2/ntypes,zocc
      dimension liml(20),limn(20),numbn(100),igotn(20)
      common /ffcom10/liml,limn,numbn,igotn,nlimn
      do j=1,nchild
         ito=0
         do jj=1,ntypes
                igotn(jj)=0
         enddo
         do jj=1,natom
C           decode the occupancy
            i=child(jj,j)
            if(i.eq.0)then
               occ(jj)=0
            else
               occ(jj)=zocc(i)
               ito=ito+1
            if(nlimn.lt.0)igotn(i)=igotn(i)+numbn(jj)
            endif
         enddo
C     Trap no atoms
      if(ito.eq.0)then
        fomchild(j)=2.
      else
c       trap for too many
        if(nlimn.lt.0)then
                do jj=1,ntypes
                if(igotn(jj).gt.limn(jj))then
                        fomchild(j)=2+j*0.01
                        goto 9991
                else if(igotn(jj).lt.liml(jj))then
                        fomchild(j)=2+j*0.01
                        goto 9991
                endif
                enddo
        endif
        fomchild(j)=robgen2k(fhk,f,fbase,nref,natom,occ)
      endif
9991  continue
      enddo
      return
      end

      function robgen2k(fhk,fw,fbase,nref,natom,occ)
      dimension fhk(*),work(2000)
C      complex fbase(*)
      complex amp,fw(*)
      dimension occ(*)
      double precision s1,s2,f0
      character*4 sympass
      common /passsym/sympass
      include 'errref.h'
C     Get the R.M.S. error
      err=0
      pi2=4.*asin(1.0)
      s1=0.0
      s2=0.0
      f0=0.0
      jj=0
      s3=0
      s4=0
      do j=1,nref
      amp=0
C     amp=fbase(j)
      do n=1,natom
         jj=jj+1
         if(occ(n).gt.1e-3)then
         amp=amp+fw(jj)*occ(n)
         endif
      enddo
      fcalc=sqrt(amp*conjg(amp))
      if(sympass.eq.'p3  ')then
        amp=0
        do n=1,natom
                jj=jj+1
                if(occ(n).gt.1e-3)then
                amp=amp+fw(jj)*occ(n)
                endif
        enddo
        fcalc=sqrt((amp*conjg(amp)+fcalc*fcalc)*0.5)
C       fcalc=((amp*conjg(amp)+fcalc*fcalc)*0.5)
        endif
        fhh=fhk(j)
        if(erron.eq.9.and.errfv(j).gt.1e-3)then
                s3=s3+fhh*fhh
                s4=s4+fcalc
        endif
        work(j)=fcalc
        if(erron.gt.8)then
                fcalc=fcalc*fcalc
                fhh=fhh*fhh
        endif
        if(erron.gt.0)then
                fcalc=fcalc*errfv(j)
                fhh=fhh*errfv(j)
        endif
      s1=s1+fcalc*fcalc
      s2=s2+fhh*fcalc
      f0=f0+fhh*fhh
C      s1=s1+fcalc*fcalc
C      s2=s2+fhk(j)*fcalc
C      f0=f0+fhk(j)*fhk(j)
      enddo
      if(erron.eq.9)then
        scl=s3/s4
        s1=0
        do j=1,nref
                fhh=fhk(j)*fhk(j)
                diff=(fhh-scl*work(j))*errfv(j)
                s1=s1+diff*diff
        enddo
        robgen2k=sqrt(s1/f0)
      else
      scl=s2/s1
      robgen2k=sqrt((f0-s2*s2/s1)/f0)
      endif
      if(erron.gt.7)robgen2k=robgen2k*0.5
      end

