C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE debpic (n1,n2,F,L )
C     THIS PROGRAM EXPANDS THE PHASE OF A 2-D DATA SET TO AN IMAGE
         dimension F(N1*N2),IX(2),IY(2),LL(2)
         CHARACTER*1 CBUF(512*512)

        VMIN=1e5
        VMAX=-1E5
        DO I=1,N1*N2
           IF(F(I).GT.VMAX)VMAX=F(I)
           IF(F(I).LT.VMIN)VMIN=F(I)
        ENDDO
C Set up coefficients to transform intensity range
         A = 255.D0 / (VMAX - VMIN)
         IW = MAX (N1, 1)
         IH = MAX (N2, 1)
C     read everything from the input picture

        DO I=1,N1*N2
                 JJ = JJ + 1
                 P = F(I)
                 P = (P - VMIN) * A
                 IF (P .LT. 1D-2) THEN
                   IP = 0
                 ELSE IF (P .GT. 255) THEN
                   IP = 255
                 ELSE
                   IP = NINT (P)
                 END IF
                 CBUF(I) = CHAR (IP)
         END DO
    3    FORMAT(16I4)
         IX(1) = N1
         IY(1) = N2
         LL(1) = L
             CALL MKTIFFD(FILEN,CBUF,IX,IY,LL)
         RETURN
       END
