C 
C  Copyright (c) 1998 L. D. Marks
C 
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C 
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C 
C  You should have received a coyo of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C 
C
      logical function specx(x,y,symm)
      character*4 symm
      logical xc2mm,xp2mm,xpm,xp3, xc1m1,spec6,comb
      logical pp3m1,pp31m
      specx=.false.
      if(symm.eq.'c2mm')then
         specx=xc2mm(x,y)
        else if(symm.eq.'p2mm')then
                specx=xp2mm(x,y)
        else if(symm.eq.'pm  ')then
              specx=xpm(x,y)
        else if(symm(1:2).eq.'p3')then
              specx=xp3(x,y)
              if((.not.specx).and.symm.eq.'p3m1')comb=pp3m1(x,y,symm)
              if((.not.specx).and.symm.eq.'p31m')comb=pp31m(x,y,symm)
        else if(symm.eq.'c1m1')then
              specx=xc1m1(x,y)
        else if(symm(1:2).eq.'p6')then
              specx=spec6(x,y)
              if((.not.specx).and.symm.eq.'p6mm')comb=pp3m1(x,y,symm)
              if((.not.specx).and.symm.eq.'p6mm')comb=pp3m1(y,x,symm)
              if((.not.specx).and.symm.eq.'p6mm')comb=pp31m(x,y,symm)
              if((.not.specx).and.symm.eq.'p6mm')comb=pp31m(y,x,symm)
      endif
      return
      end
      logical function pp3m1(xi,yi,symm)
      include 'cellcon.h'
      character*4 symm
      real*8 ave,x,y
      x=xi
      y=yi
      pp3m1=.false.
      xt=x*cell(1)
      yt=y*cell(1)
      if(abs(xt+yt).lt.0.1)then
        pp3m1=.true.
        ave=(y-x)*0.5D0
        y=ave
        x=-ave
C       y=-x
      else if(abs(xt*2-yt).lt.0.1)then
        pp3m1=.true.
        ave=(y+2.D0*x)*0.5D0
        y=ave
        x=ave*0.5D0
C       y=2*x
      else if(abs(xt*2-yt-cell(1)).lt.0.1)then
        pp3m1=.true.
        ave=(y+2.D0*x-1.D0)*0.5D0
        y=ave
        x=(1.D0+y)*0.5D0
C       y=2*x-1
      else if(abs(xt*2-yt+cell(1)).lt.0.1)then
        pp3m1=.true.
        ave=(y+2.D0*x+1.D0)*0.5D0
        y=ave
        x=(y-1.D0)*0.5D0
C       y=2*x+1
      else if(abs(xt-2*yt).lt.0.1)then
        pp3m1=.true.
        ave=(y+0.5D0*x)*0.5D0
        y=ave
        x=2.D0*ave
C       y=0.5*x
      else if(abs(xt-2*yt+cell(1)).lt.0.1)then
        pp3m1=.true.
        ave=(y+0.5D0*x+0.5D0)*0.5D0
        y=ave
        x=ave*2.D0-1.D0
C       y=0.5*x+0.5
      else if(abs(xt-2*yt-cell(1)).lt.0.1)then
        pp3m1=.true.
        ave=(y+0.5D0*x-0.5D0)*0.5D0
        y=ave
        x=ave*2.D0+1.D0
C       y=0.5*x-0.5
      endif
      xi=x
      yi=y
      return
        end
      logical function pp31m(xi,yi,symm)
      include 'cellcon.h'
      character*4 symm
      real*8 ave,x,y
      x=xi
      y=yi
      pp31m=.false.
      xt=x*cell(1)
      yt=y*cell(1)
      if(abs(yt).lt.0.1)then
        pp31m=.true.
        y=0D0
      else if(abs(xt-yt).lt.0.1)then
        pp31m=.true.
        ave=(x+y)*0.5D0
        y=ave
        x=ave
      endif
      xi=x
      yi=y
      return
        end
      logical function specy(x,y,symm)
      character*4 symm
      logical yc2mm,yp2mm,ypm,xp3, yc11m,spec6,pp3m1,pp31m
      logical comb
      specy=.false.
      if(symm.eq.'c2mm')then
         specy=yc2mm(x,y)
        else if(symm.eq.'p2mm')then
                specy=yp2mm(x,y)
        else if(symm.eq.'p11m')then
              specy=ypm(x,y)
        else if(symm(1:2).eq.'p3')then
              specy=xp3(x,y)
              if((.not.specy).and.symm.eq.'p3m1')comb=pp3m1(x,y,symm)
              if((.not.specy).and.symm.eq.'p31m')comb=pp31m(x,y,symm)
        else if(symm.eq.'c11m')then
              specy=yc11m(x,y)
        else if(symm(1:2).eq.'p6')then
              specy=spec6(x,y)
              if((.not.specy).and.symm.eq.'p6mm')comb=pp3m1(x,y,symm)
              if((.not.specy).and.symm.eq.'p6mm')comb=pp3m1(y,x,symm)
              if((.not.specy).and.symm.eq.'p6mm')comb=pp31m(x,y,symm)
              if((.not.specy).and.symm.eq.'p6mm')comb=pp31m(y,x,symm)
        endif
      return
      end
      logical function xc1m1(x,y)
      include 'cellcon.h'
      xc1m1=.false.
      if(abs(x)*cell(1).lt.0.1)then
        x=0
        xc1m1=.true.
      else if(abs(x-0.5)*cell(1).lt.0.1)then
        x=0.5
        xc1m1=.true.
      endif
      return
      end
       logical function yc11m(x,y)
      include 'cellcon.h'
      yc11m=.false.
      if(abs(y)*cell(2).lt.0.1)then
        y=0
        yc11m=.true.
      else if(abs(y-0.5)*cell(2).lt.0.1)then
        y=0.5
        yc11m=.true.
      endif
      return
      end
      logical function xp3(x,y)
      include 'cellcon.h'
      xp3=.false.
      if(abs(x)*cell(1).lt.0.1.and.abs(y)*cell(1).lt.0.1)then
        x=0
        y=0
        xp3=.true.
      else if(abs(x-1./3.)*cell(1)*cell(1).lt.0.1.and.
     1               abs(y-2./3.)*cell(1).lt.0.1)then
        x=1./3.
        y=2./3.
        xp3=.true.
      else if(abs(x-2./3.)*cell(1).lt.0.1.and.
     1               abs(y-1./3.)*cell(1).lt.0.1)then
        x=2./3.
        y=1./3.
        xp3=.true.
      else if(abs(x+2./3.)*cell(1).lt.0.1.and.
     1               abs(y-2./3.)*cell(1).lt.0.1)then
        x=1./3.
        y=2./3.
        xp3=.true.
      else if(abs(x+1./3.)*cell(1).lt.0.1.and.
     1               abs(y-1./3.)*cell(1).lt.0.1)then
        x=2./3.
        y=1./3.
        xp3=.true.
      endif
      return
      end
      logical function xpm(x,y)
      include 'cellcon.h'
      if(abs(x)*cell(1).lt.0.1)then
         x=0
         xpm=.true.
      else if(abs(x-0.5)*cell(1).lt.0.1)then
         xpm=.true.
         x=0.5
      else
         xpm=.false.
      endif
      return
      end
      logical function ypm(x,y)
      include 'cellcon.h'
      if(abs(y)*cell(2).lt.0.1)then
         y=0
         ypm=.true.
      else if(abs(y-0.5)*cell(2).lt.0.1)then
         ypm=.true.
         y=0.5
      else
         ypm=.false.
      endif
      return
      end
      logical function xc2mm(x,y)
      include 'cellcon.h'
      if(abs(x)*cell(1).lt.0.1)then
         x=0
         xc2mm=.true.
      else if(abs(x-0.5)*cell(1).lt.0.1)then
         xc2mm=.true.
         x=0.5
      else if(abs(x-0.25)*cell(1).lt.0.1.and.
     1       abs(y-0.25)*cell(2).lt.0.1)then
         x=0.25
         y=0.25
         xc2mm=.true.
      else
         xc2mm=.false.
      endif
      return
      end   
      logical function yc2mm(x,y)
      include 'cellcon.h'
      if(abs(y)*cell(2).lt.0.1)then
         y=0
         yc2mm=.true.
      else if(abs(y-0.5)*cell(2).lt.0.1)then
         y=0.5
         yc2mm=.true.
      else if(abs(x-0.25)*cell(1).lt.0.1.and.
     1       abs(y-0.25)*cell(2).lt.0.1)then
         x=0.25
         y=0.25
         yc2mm=.true.
      else
         yc2mm=.false.
      endif
      return
      end
      logical function xp2mm(x,y)
      include 'cellcon.h'
      if(abs(x)*cell(1).lt.0.1)then
         x=0
         xp2mm=.true.
      else if(abs(x-0.5)*cell(1).lt.0.1)then
         x=0.5
         xp2mm=.true.
      else
         xp2mm=.false.
      endif
      return
      end   
      logical function yp2mm(x,y)
      include 'cellcon.h'
      if(abs(y)*cell(2).lt.0.1)then
         y=0.
         yp2mm=.true.
      else if(abs(y-0.5)*cell(2).lt.0.1)then
         y=0.5
         yp2mm=.true.
      else
         yp2mm=.false.
      endif
      return
      end
      logical function spec6(x,y)
      include 'cellcon.h'
        spec6=.false.
        if(abs(x).lt.1e-7.and.abs(y).lt.1e-7)then
                x=0
                y=0
                spec6=.true.
                return
        else if(abs(x-1./3.).lt.1e-7.and.abs(y-2./3.).lt.1e-7)then
                x=1./3.
                y=2./3.
                spec6=.true.
                return
        else if(abs(x-2./3.).lt.1e-7.and.abs(y-1./3.).lt.1e-7)then
                x=2./3.
                y=1./3.
                spec6=.true.
                return
        else if(abs(x-0.5).lt.1e-7.and.abs(y).lt.1e-7)then
                x=0.5
                y=0
                spec6=.true.
                return
        else if(abs(x).lt.1e-7.and.abs(y-0.5).lt.1e-7)then
                x=0
                y=0.5
                spec6=.true.
                return
        else if(abs(x-0.5).lt.1e-7.and.abs(y-0.5).lt.1e-7)then
                x=0.5
                y=0.5
                spec6=.true.
                return
        endif      
      return
      end
      
C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a coyo of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
      logical function specxd(x,y,symm)
      implicit real*8 (a-h,o-z)
      character*4 symm
      logical xc2mmd,xp2mmd,xpmd,xp3d, xc1m1d,spec6d,comb
      logical pp3m1d,pp31md
      specxd=.false.
      if(symm.eq.'c2mm')then
         specxd=xc2mmd(x,y)
        else if(symm.eq.'p2mm')then
              specxd=xp2mmd(x,y)
        else if(symm.eq.'pm  ')then
              specxd=xpmd(x,y)
        else if(symm(1:2).eq.'p3')then
              specxd=xp3d(x,y)
              if((.not.specxd).and.symm.eq.'p3m1')comb=pp3m1d(x,y,symm)
              if((.not.specxd).and.symm.eq.'p31m')comb=pp31md(x,y,symm)
        else if(symm.eq.'c1m1')then
              specxd=xc1m1d(x,y)
        else if(symm(1:2).eq.'p6')then
              specxd=spec6d(x,y)
              if((.not.specxd).and.symm.eq.'p6mm')comb=pp3m1d(x,y,symm)
              if((.not.specxd).and.symm.eq.'p6mm')comb=pp3m1d(y,x,symm)
              if((.not.specxd).and.symm.eq.'p6mm')comb=pp31md(x,y,symm)
              if((.not.specxd).and.symm.eq.'p6mm')comb=pp31md(y,x,symm)
      endif
      return
      end
      logical function pp3m1d(x,y,symm)
      implicit real*8 (a-h,o-z)
      include 'cellcon.h'
      character*4 symm
      real*8 ave,x,y
      pp3m1d=.false.
      xt=x*cell(1)
      yt=y*cell(1)
      if(abs(xt+yt).lt.0.1)then
        pp3m1d=.true.
        ave=(y-x)*half
        y=ave
        x=-ave
C       y=-x
      else if(abs(xt*2-yt).lt.0.1)then
        pp3m1d=.true.
        ave=(y+2.D0*x)*half
        y=ave
        x=ave*half
C       y=2*x
      else if(abs(xt*2-yt-cell(1)).lt.0.1)then
        pp3m1d=.true.
        ave=(y+2.D0*x-1.D0)*half
        y=ave
        x=(1.D0+y)*half
C       y=2*x-1
      else if(abs(xt*2-yt+cell(1)).lt.0.1)then
        pp3m1d=.true.
        ave=(y+2.D0*x+1.D0)*half
        y=ave
        x=(y-1.D0)*half
C       y=2*x+1
      else if(abs(xt-2*yt).lt.0.1)then
        pp3m1d=.true.
        ave=(y+half*x)*half
        y=ave
        x=2.D0*ave
C       y=half*x
      else if(abs(xt-2*yt+cell(1)).lt.0.1)then
        pp3m1d=.true.
        ave=(y+half*x+half)*half
        y=ave
        x=ave*2.D0-1.D0
C       y=half*x+half
      else if(abs(xt-2*yt-cell(1)).lt.0.1)then
        pp3m1d=.true.
        ave=(y+half*x-half)*half
        y=ave
        x=ave*2.D0+1.D0
C       y=half*x-half
      endif
      return
        end
      logical function pp31md(x,y,symm)
      implicit real*8 (a-h,o-z)
      include 'cellcon.h'
      character*4 symm
      real*8 ave,x,y
      pp31md=.false.
      xt=x*cell(1)
      yt=y*cell(1)
      if(abs(yt).lt.0.1)then
        pp31md=.true.
        y=0D0
      else if(abs(xt-yt).lt.0.1)then
        pp31md=.true.
        ave=(x+y)*half
        y=ave
        x=ave
      endif
      return
        end
      logical function specyd(x,y,symm)
      implicit real*8 (a-h,o-z)
      character*4 symm
      logical yc2mmd,yp2mmd,ypmd,xp3d, yc11md,spec6d,pp3m1d,pp31md
      logical comb
      specyd=.false.
      if(symm.eq.'c2mm')then
         specyd=yc2mmd(x,y)
        else if(symm.eq.'p2mm')then
                specyd=yp2mmd(x,y)
        else if(symm.eq.'p11m')then
              specyd=ypmd(x,y)
        else if(symm(1:2).eq.'p3')then
              specyd=xp3d(x,y)
              if((.not.specyd).and.symm.eq.'p3m1')comb=pp3m1d(x,y,symm)
              if((.not.specyd).and.symm.eq.'p31m')comb=pp31md(x,y,symm)
        else if(symm.eq.'c11m')then
              specyd=yc11md(x,y)
        else if(symm(1:2).eq.'p6')then
              specyd=spec6d(x,y)
              if((.not.specyd).and.symm.eq.'p6mm')comb=pp3m1d(x,y,symm)
              if((.not.specyd).and.symm.eq.'p6mm')comb=pp3m1d(y,x,symm)
              if((.not.specyd).and.symm.eq.'p6mm')comb=pp31md(x,y,symm)
              if((.not.specyd).and.symm.eq.'p6mm')comb=pp31md(y,x,symm)
        endif
      return
      end
      logical function xc1m1d(x,y)
      implicit real*8 (a-h,o-z)
      include 'cellcon.h'
      xc1m1d=.false.
      if(abs(x)*cell(1).lt.0.1)then
        x=0
        xc1m1d=.true.
      else if(abs(x-half)*cell(1).lt.0.1)then
        x=half
        xc1m1d=.true.
      endif
      return
      end
       logical function yc11md(x,y)
      implicit real*8 (a-h,o-z)
      include 'cellcon.h'
      yc11md=.false.
      if(abs(y)*cell(2).lt.0.1)then
        y=0
        yc11md=.true.
      else if(abs(y-half)*cell(2).lt.0.1)then
        y=half
        yc11md=.true.
      endif
      return
      end
      logical function xp3d(x,y)
      implicit real*8 (a-h,o-z)
      include 'cellcon.h'
      xp3d=.false.
      if(abs(x)*cell(1).lt.0.1.and.abs(y)*cell(1).lt.0.1)then
        x=0
        y=0
        xp3d=.true.
      else if(abs(x-othird)*cell(1)*cell(1).lt.0.1.and.
     1               abs(y-tthird)*cell(1).lt.0.1)then
        x=othird
        y=tthird
        xp3d=.true.
      else if(abs(x-tthird)*cell(1).lt.0.1.and.
     1               abs(y-othird)*cell(1).lt.0.1)then
        x=tthird
        y=othird
        xp3d=.true.
      else if(abs(x+tthird)*cell(1).lt.0.1.and.
     1               abs(y-tthird)*cell(1).lt.0.1)then
        x=othird
        y=tthird
        xp3d=.true.
      else if(abs(x+othird)*cell(1).lt.0.1.and.
     1               abs(y-othird)*cell(1).lt.0.1)then
        x=tthird
        y=othird
        xp3d=.true.
      endif
      return
      end
      logical function xpmd(x,y)
      implicit real*8 (a-h,o-z)
      include 'cellcon.h'
      if(abs(x)*cell(1).lt.0.1)then
         x=0
         xpmd=.true.
      else if(abs(x-half)*cell(1).lt.0.1)then
         xpmd=.true.
         x=half
      else
         xpmd=.false.
      endif
      return
      end
      logical function ypmd(x,y)
      implicit real*8 (a-h,o-z)
      include 'cellcon.h'
      if(abs(y)*cell(2).lt.0.1)then
         y=0
         ypmd=.true.
      else if(abs(y-half)*cell(2).lt.0.1)then
         ypmd=.true.
         y=half
      else
         ypmd=.false.
      endif
      return
      end
      logical function xc2mmd(x,y)
      implicit real*8 (a-h,o-z)
      include 'cellcon.h'
      if(abs(x)*cell(1).lt.0.1)then
         x=0
         xc2mmd=.true.
      else if(abs(x-half)*cell(1).lt.0.1)then
         xc2mmd=.true.
         x=half
      else if(abs(x-quart)*cell(1).lt.0.1.and.
     1       abs(y-quart)*cell(2).lt.0.1)then
         x=quart
         y=quart
         xc2mmd=.true.
      else
         xc2mmd=.false.
      endif
      return
      end
      logical function yc2mmd(x,y)
      implicit real*8 (a-h,o-z)
      include 'cellcon.h'
      if(abs(y)*cell(2).lt.0.1)then
         y=0
         yc2mmd=.true.
      else if(abs(y-half)*cell(2).lt.0.1)then
         y=half
         yc2mmd=.true.
      else if(abs(x-quart)*cell(1).lt.0.1.and.
     1       abs(y-quart)*cell(2).lt.0.1)then
         x=quart
         y=quart
         yc2mmd=.true.
      else
         yc2mmd=.false.
      endif
      return
      end
      logical function xp2mmd(x,y)
      implicit real*8 (a-h,o-z)
      include 'cellcon.h'
      if(abs(x)*cell(1).lt.0.1)then
         x=0
         xp2mmd=.true.
      else if(abs(x-half)*cell(1).lt.0.1)then
         x=half
         xp2mmd=.true.
      else
         xp2mmd=.false.
      endif
      return
      end
      logical function yp2mmd(x,y)
      implicit real*8 (a-h,o-z)
      include 'cellcon.h'
      if(abs(y)*cell(2).lt.0.1)then
         y=0.
         yp2mmd=.true.
      else if(abs(y-half)*cell(2).lt.0.1)then
         y=half
         yp2mmd=.true.
      else
         yp2mmd=.false.
      endif
      return
      end
      logical function spec6d(x,y)
      implicit real*8 (a-h,o-z)
      include 'cellcon.h'
        spec6d=.false.
        if(abs(x).lt.1d-7.and.abs(y).lt.1d-7)then
                x=0
                y=0
                spec6d=.true.
                return
        else if(abs(x-othird).lt.1d-7.and.abs(y-tthird).lt.1d-7)then
                x=othird
                y=tthird
                spec6d=.true.
                return
        else if(abs(x-tthird).lt.1d-7.and.abs(y-othird).lt.1d-7)then
                x=tthird
                y=othird
                spec6d=.true.
                return
        else if(abs(x-half).lt.1d-7.and.abs(y).lt.1d-7)then
                x=half
                y=0
                spec6d=.true.
                return
        else if(abs(x).lt.1d-7.and.abs(y-half).lt.1d-7)then
                x=0
                y=half
                spec6d=.true.
                return
        else if(abs(x-half).lt.1d-7.and.abs(y-half).lt.1d-7)then
                x=half
                y=half
                spec6d=.true.
                return
        endif   
      return
      end
