        subroutine pseed(ijk,symm)
        include 'SeedDef.h'
        character*4 symm
        logical symmdist3D
        if(nsd.lt.2)return
C       Purge the seeds of duplicates within 0.5 Angstroms
        tol=0.5
        nsdt=nsd
1       nsd=nsdt
        do i1=1,nsd-1
                do i2=i1+1,nsd
C                       Skip if number of atoms are different
                        if(ntsd(i1).ne.ntsd(i2))goto 20
C                       First check in order
                        do j1=1,ntsd(i1)
                           if(isd(j1,i1).ne.isd(j1,i2))goto 20
                           if(.not.symmdist3D(xsd(j1,i1),ysd(j1,i1),
     1                     zsd(j1,i1),xsd(j1,i2),ysd(j1,i2),
     2                     zsd(j1,i2),symm,tol))goto 20
                        enddo
C                       If we get here they are the same!
C                       Shuffle down and decrease number by 1
                        do j1=i2+1,nsd
                                n=ntsd(j1)
                                do j2=1,n
                                        xsd(j2,j1-1)=xsd(j2,j1)
                                        ysd(j2,j1-1)=ysd(j2,j1)
                                        zsd(j2,j1-1)=zsd(j2,j1)
                                        isd(j2,j1-1)=isd(j2,j1)
                                enddo
                                fomseed(j1-1)=fomseed(j1)
                                ntsd(j1-1)=n
                        enddo
                        nsdt=nsd-1
                        goto 1
20              continue
                enddo
        enddo
C       write(6,*)'Final number of seeds ',nsd
        return
        end
C
        logical function symmdist3D(x1,y1,z1,x2,y2,z2,symm,tol)
C       Check two atomic positions to see if they are
C       symmetry equivalents
        dimension xe(20),ye(20)
        logical dist3D
        character*4 symm
        dz=z1-z2
        call asymm(x1,y1,ne,xe,ye,symm)
        do j=1,ne
                dx=x1-xe(j)
                dy=y1-ye(j)
                dx=dx-nint(dx)
                dy=dy-nint(dy)
                if(dist3D(dx,dy,dz,tol))then
                        symmdist3D=.true.
                        return
                endif
        enddo
C       Did not find, so return false
        symmdist3D=.false.
        return
        end             

