C
       SUBROUTINE modelnew (N1, N2, M, C, MPROJ )
C      This version returns a combined entropy in the real
C      A combined positivity in the imaginary
C      If project, the entropies of the input and model are averaged
C      Otherwise the entropy is of the combination
         COMPLEX C(*)
         INTEGER M(3), N1, N2
         LOGICAL MPROJ
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
         DOUBLEPRECISION XMEAN, XR, XI, XC
         DOUBLEPRECISION XT,BCUT, XFLIP
         DOUBLEPRECISION EM, EW
         INCLUDE 'NewStuff.h'
        INCLUDE 'TModel.h'
        LOGICAL  UFLIP
C     Do a FFT
         CALL FFT2DN (C)
         UFLIP=.false.
         if(flip  .gt. 1e-4)then
                uflip=.true.
                XFLIP=FLIP/DBLE(N1*N2)
         else
                XFLIP=1./DBLE(N1*N2)
         endif

C       fs2002 partway atoms-like term -- new default
        INCLUDE 'EntScales.h'
C
C       Correct origin shift, find flipping term via max and scale of model
         JK = 0
         MF = (-1)
         XLMAX = -1
         S1=0
         S2=0
         DO   I=1,N2
           MF = -MF
           NF = -MF
           DO   J=1,N1
             JK = JK + 1
             NF = -NF
             IF(NF .LT. 0) C(JK) = -C(JK)
             XR = MAX (DBLE (       C(JK)) , 0.D0)
             XI = MAX (DBLE (AIMAG (C(JK))), 0.D0)
             IF (XR .gt. XLMAX) XLMAX=XR
C     Wiener-like filter for model
             S1 = S1 + XI*XR*FILT(JK)
             S2 = S2 + XI*XI*FILT(JK)
          enddo
        ENDDO
        XFLIP = XLMAX*XFCUT*FLIP
        IF(S2.GT.0.001*S1)THEN
               SCL = MAX(cutmodel,S1/S2)
               SCL = MIN(cutmodel2,SCL)
         ELSE
               SCL = 1
        ENDIF
C
         JK = 0
         MF = (-1)
           DO   I=1,N2
             MF = -MF
             NF = -MF
             DO   J=1,N1
               NF = -NF
               JK = JK + 1
               XT = REAL(C(JK))
               XC = AIMAG (C(JK))*SCL
C              Filtered combination
               EW = XT*(1-FILT(JK))+XC*FILT(JK)
               IF(MPROJ) THEN
C     Entropy term for model
                   IF (XC .GE. BCUT) THEN
                      EM = XC * LOG (XC/XMEAN)
                   ELSE
                      EM = 0.
                   END IF
C     Entropy term for solution
                   IF (XT .GT. BCUT) THEN
                      EA = XT * LOG (XT/XMEAN)
                   ELSE
                      EA = 0.
                   END IF
C     Add the two, filter character
                   EM = (EA*(1-FILT(JK)) + EM*FILT(JK))
                ELSE
C     Entropy term for combination
                   IF (EW .GE. BCUT) THEN
                      EM = EW * LOG (EW/XMEAN)
                   ELSE
                      EM = 0.
                   END IF
                ENDIF
C     Charge Flipping constraint here
                IF(UFLIP .AND. (EW .LT. XFLIP))then
                         EW=-EW
                endif
                IF(NF .LT. 0)then
                      EM = - EM
                      EW = - EW
                ENDIF
                C(JK) = cmplx(EM, EW)
             END DO
           END DO
C     Invert
         CALL FFT2DP (C)
         RETURN
       END
