C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
         subroutine TACCENT (IH, K, NREF, SYMM, NHK, C, M ,ARAD)
         include 'Nlimit.h'
 
C         PARAMETER (NHK2 = 900, NLIMIT = 65536)
         REAL*8 REL1,REL2
         PARAMETER (REL1 = 0.25D0, REL2 = 1.D0/(1.D0+REL1))
         LOGICAL PRINTF
         COMMON /PRINTS/PRINTF
         LOGICAL PWMASK, EOPT, PWACC, PMACC
         COMMON /WALSH/PWMASK, EOPT, PWACC, PMACC
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
         COMMON /ERRTRY/NWOPT
         COMMON /ENTC2D/RAD1, RAD2
 
C     For tuning
         LOGICAL TLOG(6)
         DIMENSION FTUNE(4)
         COMMON /TUNING/TLOG, FTUNE
         LOGICAL WTSON, WT2ON
         DIMENSION WTS(NHK2), EWTS(NHK2), MULTI(NHK2)
         DIMENSION WPOS(NHK2)
         COMMON /WPOSC/WPOS
         COMMON /WCOM/WTS, WTSON, MODE
         COMMON /WCOM2/EWTS, WT2ON
         COMMON /MPCOMM/MULTI
         COMMON /ECALC/SFERR1, ANGERR, SFERR2
C        COMMON /PADCMM/NPAD
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
         INTEGER NCONT(20)
         DIMENSION CELL(6), TEMPF(20), AOCC(20), ZATOM(20)
         LOGICAL FORIG, FSEMP, BROWNF, DMULT, DMLT, FOM2
         Include 'Sfacts.h'
         COMMON /SFCOM1/TEMPF, NCONT, NATOM, CELL
         COMMON /SFCOM2/AOCC, ZATOM, FORIG, BROWNF, DMULT, DMLT
         COMMON /MVIS/WIDTH, HEIGHT, TIMES, FSEMP
         COMMON /COPT/ATNUM, PATTC, ACTERM, FOM2
         DIMENSION FSTEST(20)
         COMMON /COPT2/FSTEST
         INTEGER LAT(2)
         COMMON /CLAT/LAT
C     generate an approximate mask iteratively in wcom
         DIMENSION IH(NHK2), K(NHK2)
         INTEGER HE(20), KE(20), ISE(20), M(3)
         COMPLEX C(*) !, CZERO
C         PARAMETER (CZERO = (0.,0.) )
         CHARACTER*4 SYMM
         SAVE /COPT2/ , /COPT/ , /MVIS/ , /SFCOM2/ , /SFCOM1/
     X   , /FOMALL/ , /MPCOMM/ , /WCOM2/ , /WCOM/ 
C         REAL RR1, RR2, RR3
         DOUBLE PRECISION FC,PI, XS, YS, SHIFT,F
         LOGICAL P3FLAG
         INCLUDE 'NewStuff.h'
C        Window Normalization
 
C     Origin for arrays (for consistency with FFT's)
         N1 = M(1)
         N2 = M(2)
         N1C = M(1) / 2 + 1
         N2C = M(2) / 2 + 1
C     Put the peak a little off-center
         XS  = Asin(1.D0)/dble(n1)
         YS  = Asin(1.D0)/dble(n2) 
         P3FLAG = SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6'
C        if(p3f)p3flag=.true.
         PI = ACOS (1.D0)
 
C     zero beams
           DO   J=1,N1*N2
             C(J) = 0
           END DO
 
C     setup in fo and ag the symmetry related values
           WMIN=WTS(1)
           i0=nref
           DO   J=1,NREF
             IF(WTS(J) .lt. WMIN)WMIN=WTS(J)
             if((IH(J).eq.0).and.(K(j).eq.0))then
                NE=1
                HE(1)=0
                KE(1)=0
                FC = 1
                I0 = J
             ELSE
                CALL EQUIV2 (HE,KE,ISE,IH(J),K(J),NE,SYMM)
                FC = WTS(J)
             endif 
C     Information about symmetry coding of phases
             DO   JJ=1,NE
C     trap problems with p3 symmetry to give rectangular axes
               F = FC
               IF (P3FLAG) THEN
                 CALL P3EXP (IHJJ,IKJJ,HE(JJ),KE(JJ))
                 IHJJ = IHJJ + N1C
                 IKJJ = IKJJ + N2C
               ELSE
                 IHJJ = HE(JJ) + N1C
                 IKJJ = KE(JJ) + N2C
               END IF
               IND = (IKJJ - 1) * N1 + IHJJ
               IF (ISE(JJ) .LT. 0) THEN
                 F = FC
               ELSE IF (ISE(JJ) .EQ. 3) THEN
                 F = FC
               ELSE IF (ISE(JJ) .EQ. 6) THEN
                 F = 0
               ELSE IF (ISE(JJ) .LT. 8) THEN
                 F = FC
               ELSE IF (ISE(JJ) .LT. 110) THEN
                 AWORK = HE(1) * PI
                 F = FC * CMPLX (COS (AWORK), SIN (AWORK))
 
C     X or Y-glide
               ELSE IF (ISE(JJ) .LT. 210) THEN
                 F = -FC
               ELSE IF (ISE(JJ) .EQ. 300) THEN
                 F = -FC 
C     p2mg case
               ELSE IF (ISE(JJ) .EQ. 1000) THEN
                 F = -FC
               ELSE IF (ISE(JJ) .EQ. 2000) THEN
                 F = 0
               END IF
c               Shift term
                IF(NSHIFT)then
                 C(IND)=F
                ELSE
                 shift=dble(ihjj-n1c)*xs+dble(ikjj-n2c)*ys
                 C(IND) = F*cmplx(cos(shift),sin(shift))
                ENDIF
             END DO
 
           END DO
 
C     Perform the transformation
           CALL ENTWEIGHT (N1,N2,M,C,ARAD)
 
C     Outer loop for target reflection
           DO   I=1,NREF
             CALL EQUIV2 (HE,KE,ISE,IH(I),K(I),NE,SYMM)
             NAV = 0
             FC = 0.
             DO   JE=1,NE
C     Average over equivalents
               IF (abs(ISE(JE)).EQ. 1 .OR. ISE(JE) .EQ. 3 ) THEN
                 NAV = NAV + 1
C           trap problems with p3 symmetry to give rectangular axes
                 IF (P3FLAG) THEN
                   CALL P3EXP (IHJJ,IKJJ,HE(JE),KE(JE))
                   IHJJ = IHJJ + N1C
                   IKJJ = IKJJ + N2C
                 ELSE
                   IHJJ = HE(JE) + N1C
                   IKJJ = KE(JE) + N2C
                 END IF
                 IND = (IKJJ - 1) * N1 + IHJJ
C                Inverse shift
                 IF(NSHIFT)then
                  FC = FC + C(IND)
                 ELSE
                  shift=dble(ihjj-n1c)*xs+dble(ikjj-n2c)*ys
                  FC=FC+c(ind)*cmplx(cos(shift),-sin(shift))
                 ENDIF
               END IF
             END DO
C     Average
             ENTW(I) = FC / FLOAT (NAV)
           ENDDO
           E0 = 1./ENTW(I0)
           CUT=1D-12
           if(LENT6)CUT=WMIN*WMIN*0.25
           DO I=1,NREF
C     Take filter level of 0.1 for inverse
             FC = ENTW(I)*E0
             IF(Owind)then
                ENTW(I) = E0*WTS(I)*FC/(FC*FC+CUT)
             ELSE
                ENTW(I) = E0
             ENDIF         
C            write(88,*)IH(I),K(I),WTS(I),ENTW(I),FC
           END DO
  
         RETURN
       END
 
C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE ENTWEIGHT (N1, N2, M, C, ARAD2)
C
C      Evaluate the window for a simple MaxEnt term
C      Also return the window width as arad
C
         INTEGER M(3), N1, N2
         REAL*8 XI, BCUT
         COMPLEX C(*) 
         parameter (RRBASE=125)
         INCLUDE 'NewStuff.h'
C
C     Do a negative FFT
         CALL FFT2DN (C)
C
C        INCLUDE 'EntScales.h'
C
        XMEAN=1.d0/DBLE(N1*N2)
        XFLIP=XMEAN
        if(flip .gt. 1e-4)XFLIP=XMEAN*FLIP
        BCUT=BCUTP*XMEAN
        RRMAX=min(N1/4.,N2/4.)
        RRMAX=min(RRMAX*RRMAX,RRBASE)
C       Correction for the origin shift
C       Quench any imaginary component as a rounding error
         MF = (-1)
         JK = 0
         arad =0
         arad2=0
         atest1=0
         atest2=0
         xmax=-99
         xmin= 99
         DO   I=1,N2
           MF = -MF
           NF = (-MF)
           dy1=i-1.25
           dy2=n2-i+1.25
           dy=min(dy1,dy2)
           dy=dy*dy

           DO   J=1,N1
             JK = JK + 1
             NF = -NF
             dx1=j-1.25
             dx2=n1-j+1.25
             dx=min(dx1,dx2)
             r=dx*dx+dy
             XI = C(JK)
             IF(NF .LT. 0)XI=-XI
             if(XI .gt. XMAX)XMAX=XI
             if(XI .lt. XMIN)XMIN=XI
             if(r .lt. RRMAX)then
C               write(88,*)I,J,XI/xmean
                r=sqrt(r)
                arad  =arad+r*xi
                arad2 =arad2+r*xi*xi
                atest1=atest1+xi
                atest2=atest2+xi*xi
             endif
           END DO
         END DO
         arad =arad/atest1
         arad2 =arad2/atest2
         if(uflip6)XFLIP = FLIP*ABS(XMIN)
         MF = (-1)
         JK = 0
         DO   I=1,N2
           MF = -MF
           NF = (-MF)
           DO   J=1,N1
             JK = JK + 1
             NF = -NF
              XI = C(JK)
             IF(NF .LT. 0)XI=-XI
C       Flipping overprojection estimate
             IF(UFLIP4)then
                IF(XI .LT. XFLIP)XI=0
C       Just set < 0 to zero
             ELSE IF (XI .LT. BCUT ) THEN
               XI = 0.
C       MaxEnt case
             ELSE IF (LENT1) THEN
               XI = -XI * DLOG (XI)
             ENDIF
             IF(NF .LT. 0)XI=-XI
             C(JK) = XI
           END DO
         END DO
        xmax=xmax/xmean
        xmin=xmin/xmean
        write(10,10)xmax,xmin,-Flip*xmin/xmax*100
10      format('TTT Max/mean ',F8.3,' Min/mean ',F8.3,
     X  ' Flip ',F7.4,'%')
        XFCUT = abs(Xmin/Xmax)
         CALL FFT2DP (C)
         RETURN
       END
