C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       FUNCTION TMOD2D (IH, K, FHK, AHK, AIN, NREF, NCON, CFLAG, SYMM,
     X    NBEAMS, NHK, C, M, IOPT, FCALC, ACALC, MPROJ )
C
C
         include 'Nlimit.h'
C         PARAMETER (NHK2 = 900, NLIMIT = 65536)
         LOGICAL PRINTF
         COMMON /PRINTS/PRINTF
C         DIMENSION WINWTS(NHK2)
C         COMMON /FOM5/WINWTS
         LOGICAL PWMASK, EOPT, PWACC, PMACC
         COMMON /WALSH/PWMASK, EOPT, PWACC, PMACC
         LOGICAL CENTRO
         COMMON /CCENTR/CENTRO
C     data centro /.false./
         COMMON /ERRTRY/NWOPT
         COMMON /ENTC2D/RAD1, RAD2
 
C     For tuning
         LOGICAL TLOG(6)
         DIMENSION FTUNE(4)
         COMMON /TUNING/TLOG, FTUNE
         LOGICAL WTSON, WT2ON
         DIMENSION WTS(NHK2), EWTS(NHK2), MULTI(NHK2)
         DIMENSION WPOS(NHK2)
         COMMON /WPOSC/WPOS
         COMMON /WCOM/WTS, WTSON, MODE
         COMMON /WCOM2/EWTS, WT2ON
         COMMON /MPCOMM/MULTI
         COMMON /ECALC/SFERR1, ANGERR, SFERR2
         COMMON /PADCMM/NPAD
         COMMON /FOMALL/ER1, EI1, EC1, F0PASS
         DIMENSION IH(NHK2), K(NHK2), FHK(NHK2), AHK(NHK2), AOLD(NHK2), 
     X   AIN(NHK2)
         DIMENSION FRCALC(NHK2), ARCALC(NHK2)
         DIMENSION FCALC(NHK2), ACALC(NHK2)
         DIMENSION WR(NHK2)
         INTEGER HE(20), KE(20), ISE(20), M(3)
         COMPLEX C(*), W1, W2, RES1, RES2
         LOGICAL CFLAG, MPROJ
         CHARACTER*4 SYMM
         SAVE /FOMALL/ , /MPCOMM/ , /WCOM2/ , /WCOM/
C        INTEGER II1, II2
C         REAL RR1, RR2, RR3, RR4
         LOGICAL P3FLAG
C         COMPLEX CC1, CC2, CC3, CC4, CC5, CC6, CC7, CC8, CC9, CC10, CC11
C     X      , CC12, CC13, CC14, CC15, CC16, CC17,
C         COMPLEX Imaginary
C         PARAMETER (Imaginary = CMPLX(0.,1.))
C          parameter (Imaginary = (0.,1.) )
C        Window Rescaling
         Include 'WNorm.h'
 
C     Origin for arrays (for consistency with FFT's)
         N1 = M(1)
         N2 = M(2)
         N1C = M(1) / 2 + 1
         N2C = M(2) / 2 + 1
 
C     Angle conversion scaler
         PI = ASIN (1.D0) * 2.D0
         PI2 = PI * 2
 
         DO   J=1,M(1)*M(2)
           C(J) = (0., 0.)
         END DO
C     save input values
         IF (PRINTF) WRITE (10, 998) NCON
 
  998    FORMAT('***** START OF ITERATION NUMBER ',I3,2X,'*****'/2X,'H',
     X      2X,'K',4X,'A1',6X,'F1',6X,'A2',6X,'F2',5X,'AOLD',4X,'FOLD',4
     X      X,'ANEW',5X,'FNEW',4X,'Diff')
 
C     save input values
 
C     setup in c the symmetry related values
         FMAX = (-10.)
C         Imaginary = CMPLX (0.D0, 1.D0)
         II2 = M(1)
         II1 = II2
         P3FLAG = SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6'
         DO   J=1,NPAD
           IHH = IH(J)
           IKK = K(J)
           CALL EQUIV2 (HE,KE,ISE,IHH,IKK,NE,SYMM)
           F = FHK(J)
           ANG = AHK(J)
           IF (ISE(1) .EQ. 3 .AND. ABS (AHK(J)) .GT. 1D-4) THEN
C     truncate angle to moduli pi provided that > a cutoff
             IA = NINT (AHK(J) / PI)
             IF (NINT (AHK(J) / PI) .EQ. 0) IA = 2
             ANG = PI * IA
             AHK(J) = PI * IA
           END IF
           IF (IHH .EQ. 0 .AND. IKK .EQ. 0) THEN
             COSAN = 1.
             SINAN = 0.
             F = 1.
           ELSE IF (ABS (ANG) .LT. 1D-4) THEN
             F = 0.
             COSAN = 0.
             SINAN = 0.
           ELSE
             IF (FHK(J) .GT. FMAX) FMAX = FHK(J)
             COSAN = COS (ANG) * FHK(J)
             SINAN = SIN (ANG) * FHK(J)
           END IF
C     Information about symmetry coding of phases
C           RR1 = FCALC(J)
C           RR2 = ACALC(J)
           COSM = FCALC(J)*COS(ACALC(J))
           SINM = FCALC(J)*SIN(ACALC(J))
C           II1 = II2
           DO   JJ=1,NE
C     trap problems with p3 symmetry to give rectangular axes
             IF (P3FLAG) THEN
               CALL P3EXP (IHJJ,IKJJ,HE(JJ),KE(JJ))
               IHJJ = IHJJ + N1C
               IKJJ = IKJJ + N2C
             ELSE
               IHJJ = HE(JJ) + N1C
               IKJJ = KE(JJ) + N2C
             END IF
             IND = (IKJJ - 1) * II1 + IHJJ
C            Other is CMPLX( -SINM, COSM)
             IF (ISE(JJ) .LT. 0) THEN
               C(IND) = CMPLX (COSAN+SINM, -SINAN+COSM)
             ELSE IF (ISE(JJ) .EQ. 3) THEN
               C(IND) = CMPLX (COSAN, COSM)
             ELSE IF (ISE(JJ) .EQ. 6) THEN
               C(IND) = CMPLX (-SINM, SINAN)
             ELSE IF (ISE(JJ) .LT. 8) THEN
               C(IND) = CMPLX (COSAN-SINM, SINAN+COSM)
             ELSE IF (ISE(JJ) .LT. 110) THEN
               AWORK = ANG + HE(1) * PI
               C(IND) = F * CMPLX (COS (AWORK), SIN (AWORK))
               AWORK = ACALC(J) + HE(1) * PI
               C(IND) = C(IND) + FCALC(J)*CMPLX(-SIN(AWORK),COS(AWORK))
C     X or Y-glide
             ELSE IF (ISE(JJ) .LT. 210) THEN
               C(IND) = -CMPLX (COSAN-SINM, SINAN+COSM)
             ELSE IF (ISE(JJ) .EQ. 300) THEN
               C(IND) = -CMPLX (COSAN+SINM, -SINAN+COSM)
C     p2mg case
             ELSE IF (ISE(JJ) .EQ. 1000) THEN
               C(IND) = -CMPLX (COSAN, COSM)
             ELSE IF (ISE(JJ) .EQ. 2000) THEN
               C(IND) = CMPLX (SINM, -SINAN)
             END IF
           END DO
 
C     endif
         END DO
 
C     Perform the transformation
         CALL SHPM2D (N1,N2,M,C,MPROJ)
 
C     Outer loop for target reflections
         DO 1031 I=1,NPAD
           FRCALC(I) = 0.
           ARCALC(I) = 0.
C           IF (IH(I) .NE. 0 .OR. K(I) .NE. 0) THEN
 
C     Index coding for 2D
C     trap problems with p3 symmetry to give rectangular axes
             IF (SYMM(1:2) .EQ. 'p3' .OR. SYMM(1:2) .EQ. 'p6') THEN
               CALL EQUIV2 (HE,KE,ISE,IH(I),K(I),NE,SYMM)
               W1 = (0., 0.)
               W2 = (0., 0.)
               NNN = 0
               DO   JT=1,NE
                 IF (ISE(JT) .EQ. 1 .OR. ISE(JT) .EQ. 3) THEN
                   CALL P3EXP (IHJJ,IKJJ,HE(JT),KE(JT))
                   W1 = W1 + C((IKJJ+N2C-1)*N1+N1C+IHJJ)
                   W2 = W2 + C((N2C-IKJJ-1)*N1-IHJJ+N1C)
                   NNN = NNN + 1
                 END IF
               END DO
               W1 = W1 / DBLE (NNN)
               W2 = W2 / DBLE (NNN)
             ELSE
               W1 = C((K(I)+N2C-1)*N1+N1C+IH(I))
               W2 = C((N2C-K(I)-1)*N1-IH(I)+N1C)
             END IF
C
C     Extract two terms from real and imag parts
C     w1=c(ind1)
C     w2=c(ind2)
             RES1 = (W1 + CONJG (W2)) * 0.5D0
C             RES1 = W1
             ARSUM = RES1
             BRSUM = AIMAG (RES1)
 
             FSQ = ARSUM * ARSUM + BRSUM * BRSUM
             IF (FSQ .GT. 1D-12) THEN
               FRCALC(I) = SQRT (FSQ)
               ARCALC(I) = ATAN2 (BRSUM, ARSUM)
               IF (ARCALC(I) .LT. 1D-4) ARCALC(I) = ARCALC(I) + PI2
             END IF
             WR(I) = COS (ARCALC(I) - AHK(I))
C          END IF
 1031      CONTINUE
 
C     calculate error terms
         CALL ERRNT2 (FHK,FRCALC,WR,NREF,IH,K,SCALER,AOLD)
         SCALER = ABS (SCALER)
           IF (PRINTF) THEN
           DO J=1,NPAD
             WRITE (10, 4) IH(J), K(J), ARCALC(J), FRCALC(J)*SCALER
     X         ,AHK(J),FHK(J)
    4        FORMAT(2I3,4(F8.3,F8.4),F8.3,F9.4)
           ENDDO
           END IF
           
         DO 1051 J=1,NREF
           IF (IH(J) .NE. 0 .OR. K(J) .NE. 0) AHK(J) = ARCALC(J)
 1051    END DO
 
         DO   J=NREF+1,NPAD
           FHK(J) = FRCALC(J) * SCALER
           AHK(J) = ARCALC(J)
         END DO
 
         TMOD2D = 10.
 
         RETURN
       END
 
