C
C  Copyright (c) 1998 L. D. Marks
C
C  This program is free software; you can redistribute it and/or modify
C  it under the terms of the GNU General Public License as published by
C  the Free Software Foundation; either version 2 of the License, or
C  (at your option) any later version.
C
C  This program is distributed in the hope that it will be useful,
C  but WITHOUT ANY WARRANTY; without even the implied warranty of
C  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C  GNU General Public License for more details.
C
C  You should have received a copy of the GNU General Public License
C  along with this program; if not, write to the Free Software
C  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
C
C
       SUBROUTINE UOPEN (NUMBER, IUNIT, ECHAR )
C     opens, using bsd4.3 system calls, a program arguement as a unit
         CHARACTER*(*) ECHAR
         CHARACTER*100 FNAME
         CALL GETARG (NUMBER,FNAME)
         IF (FNAME(1:2) .EQ. '  ') THEN
           WRITE (6, *) ECHAR
           CALL EXIT    (0)
         END IF
         OPEN (UNIT=IUNIT, FILE=FNAME)
         RETURN
       END
       SUBROUTINE UOPEN2 (ITYPE )
C     opens, using bsd4.3 system calls, a program arguement as a unit
         CHARACTER*100 FNAME
         CHARACTER*110 FILEN
         LOGICAL THERE
         NUMBER = 1
         CALL GETARG (NUMBER,FNAME)
         LN = 0
         DO   J=1,100
           IF (FNAME(J:J) .EQ. ' ') GO TO 10
           LN = LN + 1
         END DO
         WRITE (6, *) 'File name is too long'
         CALL EXIT    (0)
   10    CONTINUE
C     Trap for zero length, ddd
        if(LN.eq.0)then
        write(6,*)'Warning, no file input, assuming debug mode'
        fname(1:8)='qphasedp'
        ln=8
        endif
C     Open units
         FILEN(1:LN) = FNAME(1:LN)
 
 
C     Log output
         FILEN(LN + 1:LN + 4) = '.lst'
         OPEN (UNIT=10, FILE=FILEN(1:LN + 4))
C     Input
         FILEN(LN + 1:LN + 4) = '.ins'
         INQUIRE (FILE=FILEN(1:LN + 4), EXIST=THERE)
         IF (.NOT.THERE) THEN
           WRITE (6, *) 'File ', FILEN(1:LN + 4), ' does not exist'
           CALL EXIT    (0)
         END IF
         OPEN (UNIT=1, FILE=FILEN(1:LN + 4))
 
C     Populations
         IF (ITYPE .EQ. 1) THEN
C     Data file
           FILEN(LN + 1:LN + 4) = '.hkl'
           INQUIRE (FILE=FILEN(1:LN + 4), EXIST=THERE)
           IF (.NOT.THERE) THEN
             WRITE (6, *) 'File ', FILEN(1:LN + 4), ' does not exist'
             CALL EXIT    (0)
           END IF
           OPEN (UNIT=2, FILE=FILEN(1:LN + 4))
 
C     Extnsion
         ELSE IF (ITYPE .EQ. 2) THEN
C     Data file
           FILEN(LN + 1:LN + 4) = '.ext'
           INQUIRE (FILE=FILEN(1:LN + 4), EXIST=THERE)
           IF (.NOT.THERE) THEN
             WRITE (6, *) 'File ', FILEN(1:LN + 4), ' does not exist'
             CALL EXIT    (0)
           END IF
           OPEN (UNIT=2, FILE=FILEN(1:LN + 4))
C     Results
           FILEN(LN + 1:LN + 4) = '.res'
           OPEN (UNIT=7, FILE=FILEN(1:LN + 4))
C     U results
           FILEN(LN + 1:LN + 5) = '.ures'
           OPEN (UNIT=8, FILE=FILEN(1:LN + 5))
 
C     Divergence
         ELSE IF (ITYPE .EQ. 3) THEN
C     Data file
           FILEN(LN + 1:LN + 4) = '.hkl'
           INQUIRE (FILE=FILEN(1:LN + 4), EXIST=THERE)
           IF (.NOT.THERE) THEN
             WRITE (6, *) 'File ', FILEN(1:LN + 4), ' does not exist'
             CALL EXIT    (0)
           END IF
           OPEN (UNIT=2, FILE=FILEN(1:LN + 4))
C     Results
           FILEN(LN + 1:LN + 6) = '.Dsort'
           OPEN (UNIT=7, FILE=FILEN(1:LN + 6))
C     F results
           FILEN(LN + 1:LN + 6) = '.Fsort'
           OPEN (UNIT=9, FILE=FILEN(1:LN + 6))
           FILEN(LN + 1:LN + 5) = '.Usort'
           OPEN (UNIT=8, FILE=FILEN(1:LN + 6))
         END IF
 
         RETURN
       END
 
       SUBROUTINE UOPEN3 (ITYPE,fname )
C     opens, using bsd4.3 system calls, a program arguement as a unit
         CHARACTER*100 FNAME
         CHARACTER*110 FILEN
         LOGICAL THERE
C         NUMBER = 1
C         CALL GETARG (NUMBER,FNAME)
         LN = 0
         DO   J=1,100
           IF (FNAME(J:J) .EQ. ' ') GO TO 10
           LN = LN + 1
         END DO
         WRITE (6, *) 'File name is too long'
         CALL EXIT    (0)
   10    CONTINUE
C     Open units
         FILEN(1:LN) = FNAME(1:LN)
 
 
C     Log output
         FILEN(LN + 1:LN + 4) = '.lst'
         OPEN (UNIT=10, FILE=FILEN(1:LN + 4))
C     Input
         FILEN(LN + 1:LN + 4) = '.ins'
         INQUIRE (FILE=FILEN(1:LN + 4), EXIST=THERE)
         IF (.NOT.THERE) THEN
           WRITE (6, *) 'File ', FILEN(1:LN + 4), ' does not exist'
           CALL EXIT    (0)
         END IF
         OPEN (UNIT=1, FILE=FILEN(1:LN + 4))
 
C     Populations
         IF (ITYPE .EQ. 1) THEN
C     Data file
           FILEN(LN + 1:LN + 4) = '.hkl'
           INQUIRE (FILE=FILEN(1:LN + 4), EXIST=THERE)
           IF (.NOT.THERE) THEN
             WRITE (6, *) 'File ', FILEN(1:LN + 4), ' does not exist'
             CALL EXIT    (0)
           END IF
           OPEN (UNIT=2, FILE=FILEN(1:LN + 4))
 
C     Extnsion
         ELSE IF (ITYPE .EQ. 2) THEN
C     Data file
           FILEN(LN + 1:LN + 4) = '.ext'
           INQUIRE (FILE=FILEN(1:LN + 4), EXIST=THERE)
           IF (.NOT.THERE) THEN
             WRITE (6, *) 'File ', FILEN(1:LN + 4), ' does not exist'
             CALL EXIT    (0)
           END IF
           OPEN (UNIT=2, FILE=FILEN(1:LN + 4))
C     Results
           FILEN(LN + 1:LN + 4) = '.res'
           OPEN (UNIT=7, FILE=FILEN(1:LN + 4))
C     U results
           FILEN(LN + 1:LN + 5) = '.ures'
           OPEN (UNIT=8, FILE=FILEN(1:LN + 5))
 
C     Divergence
         ELSE IF (ITYPE .EQ. 3) THEN
C     Data file
           FILEN(LN + 1:LN + 4) = '.hkl'
           INQUIRE (FILE=FILEN(1:LN + 4), EXIST=THERE)
           IF (.NOT.THERE) THEN
             WRITE (6, *) 'File ', FILEN(1:LN + 4), ' does not exist'
             CALL EXIT    (0)
           END IF
           OPEN (UNIT=2, FILE=FILEN(1:LN + 4))
C     Results
           FILEN(LN + 1:LN + 6) = '.Dsort'
           OPEN (UNIT=7, FILE=FILEN(1:LN + 6))
C     F results
           FILEN(LN + 1:LN + 6) = '.Fsort'
           OPEN (UNIT=9, FILE=FILEN(1:LN + 6))
           FILEN(LN + 1:LN + 5) = '.Usort'
           OPEN (UNIT=8, FILE=FILEN(1:LN + 6))
         END IF
 
         RETURN
       END
 
