/*
 * atom_bk.h
 */
#define NUM_DT 27
#define NUM_GM 6
#define NUM_GMS2 10

typedef struct{
	double dt[NUM_DT], dts[NUM_DT],
	f[NUM_GM][NUM_GMS2], gm[NUM_GM], gms2[NUM_GMS2],
	mlt_fct, add_fct;
} ATOMF_BK;

int atom_bk (ATOMF_BK ftbl, double s, double m, complex *atomf, double kvolts);
ATOMF_BK read_atom_dat_table(char *element);
