#ifndef TAtomRefinementListDialog_h_
#define TAtomRefinementListDialog_h_

#include "TXForm.h"
#include "TCrystal.h"

class	TAtomRefinementListDialog : public TXForm {
	public:
		TAtomRefinementListDialog(TCrystal *,RefinementList *,FPVII ) ;
		~TAtomRefinementListDialog() ;
		void	GetRefinementListProperties() ;
		static	void	DoClick(FL_OBJECT *obj,long arg) ;	
	private:
		void			DefineForm() ;
		void			Initialize() ;
		FL_OBJECT 	*mOK;
		FL_OBJECT 	*mCancel;
		FL_OBJECT 	*mAtomList;
		FL_OBJECT 	*mONx;
		FL_OBJECT 	*mONy;
		FL_OBJECT 	*mONz;
		FL_OBJECT 	*mONdw;
		FL_OBJECT 	*mONocc;
		FL_OBJECT 	*mTestEach;
		FPVII		mCallback ;

		Boolean	mXAllOn ;
		Boolean	mYAllOn ;
		Boolean	mZAllOn ;
		Boolean	mDWAllOn ;
		Boolean	mOCCAllOn ;

		short	mNumAtoms ;

		TCrystal	*mCrystal ;
		RefinementList	*mList ;
		TAtom		*mAtoms ;
	
} ;
#endif // TAtomRefinementListDialog_h_

