// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "menudef.h"
#include "funcdefs.h"
#include "menu_index.h"
extern long LAYERED ;

// --------------------------------------------------------------------
// Activate the parameter fields as active items within menu2 if we
// in menu1. If we already have activated menu2 turn it off and make
// menu1 active                                                    
// --------------------------------------------------------------------
void change_par() {

	eraser(0,120,1020,160) ;
	if (CurrentMenuIs(MAIN_SNGL_STR)
			||  CurrentMenuIs(MAIN_LAY_STR)) {
		gCurrentCommand = gCurrentButton ;
		on_highlight() ;
		change_cursor() ;
		set_menu(CH_MAIN_PAR) ;
	}
	else  {
		off_highlight() ;
		reset_cursor() ;
		if (LAYERED)
			set_menu(MAIN_LAY_STR) ;
		else
			set_menu(MAIN_SNGL_STR) ;
	}
}

