// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "funcdefs.h"
#include "header.h"
#include "menudef.h"
#include "menu_index.h"
void r_remove() {
  /*****************************************************/
  /* Remove a layer from the phasegrating sequence     */
  /*****************************************************/
    extern long gREMOVE,INSERT,REPEAT,DEPOSIT,RESET,
               gMSisChanged,gCalculationIsChanged ;
    extern MENUS gMenuList[] ;

    if (gCurrentMenu == &gMenuList[LAY_PG])
      {
        gCurrentCommand = gCurrentButton ;
        on_highlight() ;
        change_cursor() ;
        gREMOVE = TRUE ;
        set_menu(REM_PG_LAY) ;
        gMSisChanged = TRUE ;
        gCalculationIsChanged = TRUE ;
      }
    else if (gCurrentMenu == &gMenuList[SET_PG_SEQ])
      {
        off_highlight() ;
        gCurrentCommand = gCurrentButton ;
        on_highlight() ;
        change_cursor() ;
        INSERT = FALSE ;
        DEPOSIT = FALSE ;
        REPEAT = FALSE ;
        RESET  = FALSE ;
        gREMOVE = TRUE ;
        gMSisChanged = TRUE ;
        gCalculationIsChanged = TRUE ;
        set_menu(REM_PG_LAY) ;
      }
    else if (gCurrentMenu == &gMenuList[REM_PG_LAY])
      {
        off_highlight() ;
        reset_cursor() ;
        INSERT = FALSE ;
        DEPOSIT = FALSE ;
        REPEAT = FALSE ;
        RESET  = FALSE ;
        gREMOVE = FALSE ;
        set_menu(LAY_PG) ;
      }
}
