// -----------------------------------------------------------------------------
//  Copyright (c) 2001 Roar Kilaas
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// -----------------------------------------------------------------------------
#include "header.h"
#include "funcdefs.h"
#include "menudef.h"
#include "menu_index.h"
extern MENUS cmndptrs[] ;
extern FPV funcpntrs[] ;
extern long IMAGE_MODE,DIFFRPT,HISTOGRAM,no_cmnd ;
// --------------------------------------------------------------------------
// Set up routine for picking up an experimental image when
// such gets implemented                                  
// --------------------------------------------------------------------------
void r_expim() {

	eraser(0,0,1000,32) ;
	if (no_cmnd == 0) {
		cmndptrs[no_cmnd] = gCurrentButton ;
		funcpntrs[no_cmnd++] = (FPV)getxim ;
		on_highlight() ;
		set_menu(DSPL_OPER) ;
		IMAGE_MODE = TRUE ; DIFFRPT = FALSE ; HISTOGRAM = FALSE ;
	}
	else if (no_cmnd == 1) {
		set_menu(DSPL_SOURCE) ;
		gCurrentCommand = cmndptrs[--no_cmnd] ;
		off_highlight() ;
		cmndptrs[no_cmnd] = gCurrentButton ;
		funcpntrs[no_cmnd++] = (FPV)getxim ;
		on_highlight() ;
		set_menu(DSPL_OPER) ;
		IMAGE_MODE = TRUE ; DIFFRPT = FALSE ; HISTOGRAM = FALSE ;
	}
	else if (no_cmnd > 1) {
		err_disp(2) ;
		return ;
	}
}
